/* ContainerSourceCollection.c generated by valac 0.12.1, the Vala compiler
 * generated from ContainerSourceCollection.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* A ContainerSourceCollection is for DataSources which maintain links to one or more other*/
/* DataSources, assumed to be of a different type.  ContainerSourceCollection automates the task*/
/* of handling unlinking and relinking and maintaining backlinks.  Unlinked DataSources are*/
/* held in a holding tank, until they are either relinked or destroyed.*/
/**/
/* If the ContainerSourceCollection's DataSources are types that "evaporate" (i.e. they disappear*/
/* when they hold no items), they should use the evaporate() method, which will either destroy*/
/* the DataSource or hold it in the tank (if backlinks are outstanding).*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;
typedef struct _ContainerSourceCollectionPrivate ContainerSourceCollectionPrivate;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*break_link_many) (ContainerSource* self, GeeCollection* sources);
	void (*establish_link) (ContainerSource* self, DataSource* source);
	void (*establish_link_many) (ContainerSource* self, GeeCollection* sources);
};

struct _ContainerSourceCollection {
	DatabaseSourceCollection parent_instance;
	ContainerSourceCollectionPrivate * priv;
};

struct _ContainerSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	void (*notify_container_contents_added) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
	void (*notify_container_contents_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
	void (*notify_container_contents_altered) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
	void (*notify_backlink_to_container_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
	GeeCollection* (*get_containers_holding_source) (ContainerSourceCollection* self, DataSource* source);
	ContainerSource* (*convert_backlink_to_container) (ContainerSourceCollection* self, SourceBacklink* backlink);
	void (*container_contents_added) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
	void (*container_contents_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
	void (*container_contents_altered) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
	void (*backlink_to_container_removed) (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
};

struct _ContainerSourceCollectionPrivate {
	GeeHashSet* attached_collections;
	gchar* backlink_name;
	GeeHashSet* holding_tank;
};

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);

static gpointer container_source_collection_parent_class = NULL;

gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
GType marker_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType container_source_get_type (void) G_GNUC_CONST;
#define CONTAINER_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionPrivate))
enum  {
	CONTAINER_SOURCE_COLLECTION_DUMMY_PROPERTY
};
void container_source_collection_detach_all_collections (ContainerSourceCollection* self);
ContainerSourceCollection* container_source_collection_construct (GType object_type, const gchar* backlink_name, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
DatabaseSourceCollection* database_source_collection_construct (GType object_type, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
static void container_source_collection_real_notify_backlink_removed (SourceCollection* base, SourceBacklink* backlink, GeeCollection* sources);
void source_collection_notify_backlink_removed (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
ContainerSource* container_source_collection_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink);
void container_source_collection_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
void container_source_collection_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
static void container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
void source_collection_relink (SourceCollection* self, DataSource* source);
void container_source_collection_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
void container_source_collection_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
GeeCollection* container_source_collection_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source);
static GeeCollection* container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source);
static ContainerSource* container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink);
void container_source_collection_freeze_attached_notifications (ContainerSourceCollection* self);
void data_collection_freeze_notifications (DataCollection* self);
void container_source_collection_thaw_attached_notifications (ContainerSourceCollection* self);
void data_collection_thaw_notifications (DataCollection* self);
GeeCollection* container_source_collection_get_holding_tank (ContainerSourceCollection* self);
void container_source_collection_init_add_unlinked (ContainerSourceCollection* self, ContainerSource* unlinked);
void container_source_collection_init_add_many_unlinked (ContainerSourceCollection* self, GeeCollection* unlinked);
gboolean container_source_collection_relink_from_holding_tank (ContainerSourceCollection* self, ContainerSource* source);
static void container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self, GeeCollection* unlinking);
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink);
SourceBacklink* container_source_get_backlink (ContainerSource* self);
void container_source_break_link_many (ContainerSource* self, GeeCollection* sources);
static void container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self, GeeCollection* relinked);
GeeList* data_source_get_backlinks (DataSource* self, const gchar* name);
gchar* data_object_to_string (DataObject* self);
gchar* source_backlink_to_string (SourceBacklink* self);
void container_source_establish_link_many (ContainerSource* self, GeeCollection* sources);
static void container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self, DataSource* source);
gboolean container_source_has_links (ContainerSource* self);
gboolean data_source_destroy_orphan (DataSource* self, gboolean delete_backing);
static void container_source_collection_real_notify_item_destroyed (SourceCollection* base, DataSource* source);
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
void source_collection_notify_item_destroyed (SourceCollection* self, DataSource* source);
void container_source_collection_evaporate (ContainerSourceCollection* self, ContainerSource* container);
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink);
GeeCollection* source_collection_unlink_marked (SourceCollection* self, Marker* marker, ProgressMonitor monitor, void* monitor_target);
Marker* data_collection_mark (DataCollection* self, DataObject* object);
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
gint source_collection_destroy_marked (SourceCollection* self, Marker* marker, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target, GeeList* not_removed);
void container_source_collection_attach_collection (ContainerSourceCollection* self, SourceCollection* collection);
gchar* data_collection_to_string (DataCollection* self);
static void _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender, GeeCollection* unlinking, gpointer self);
static void _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender, GeeCollection* relinked, gpointer self);
static void _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
static void _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
void container_source_collection_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
static void container_source_collection_real_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
void container_source_collection_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked);
void container_source_collection_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
static void container_source_collection_real_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
void container_source_collection_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
static void container_source_collection_real_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void container_source_collection_finalize (DataCollection* obj);


ContainerSourceCollection* container_source_collection_construct (GType object_type, const gchar* backlink_name, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target) {
	ContainerSourceCollection* self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (backlink_name != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = (ContainerSourceCollection*) database_source_collection_construct (object_type, name, source_key_func, source_key_func_target);
	_tmp0_ = g_strdup (backlink_name);
	_g_free0 (self->priv->backlink_name);
	self->priv->backlink_name = _tmp0_;
	return self;
}


static void container_source_collection_real_notify_backlink_removed (SourceCollection* base, SourceBacklink* backlink, GeeCollection* sources) {
	ContainerSourceCollection * self;
	ContainerSource* _tmp0_ = NULL;
	ContainerSource* container;
	self = CONTAINER_SOURCE_COLLECTION (base);
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
	g_return_if_fail (GEE_IS_COLLECTION (sources));
	SOURCE_COLLECTION_CLASS (container_source_collection_parent_class)->notify_backlink_removed (SOURCE_COLLECTION (DATABASE_SOURCE_COLLECTION (self)), backlink, sources);
	_tmp0_ = container_source_collection_convert_backlink_to_container (self, backlink);
	container = _tmp0_;
	if (container != NULL) {
		container_source_collection_notify_backlink_to_container_removed (self, container, sources);
	}
	_g_object_unref0 (container);
}


static void container_source_collection_real_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked) {
	gboolean _tmp0_;
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
	g_return_if_fail (GEE_IS_COLLECTION (added));
	_tmp0_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container);
	if (_tmp0_) {
		gboolean _tmp1_;
		gboolean removed;
		_tmp1_ = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container);
		removed = _tmp1_;
		g_assert (removed);
		source_collection_relink (SOURCE_COLLECTION (self), DATA_SOURCE (container));
	}
	g_signal_emit_by_name (self, "container-contents-added", container, added, relinked);
}


void container_source_collection_notify_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked) {
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_added (self, container, added, relinked);
}


static void container_source_collection_real_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
	g_return_if_fail (GEE_IS_COLLECTION (removed));
	g_signal_emit_by_name (self, "container-contents-removed", container, removed, unlinked);
}


void container_source_collection_notify_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked) {
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_removed (self, container, removed, unlinked);
}


static void container_source_collection_real_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
	g_signal_emit_by_name (self, "container-contents-altered", container, added, relinked, removed, unlinked);
}


void container_source_collection_notify_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked) {
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_container_contents_altered (self, container, added, relinked, removed, unlinked);
}


static void container_source_collection_real_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
	g_return_if_fail (GEE_IS_COLLECTION (sources));
	g_signal_emit_by_name (self, "backlink-to-container-removed", container, sources);
}


void container_source_collection_notify_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources) {
	CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->notify_backlink_to_container_removed (self, container, sources);
}


static GeeCollection* container_source_collection_real_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source) {
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_get_containers_holding_source'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


GeeCollection* container_source_collection_get_containers_holding_source (ContainerSourceCollection* self, DataSource* source) {
	return CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->get_containers_holding_source (self, source);
}


static ContainerSource* container_source_collection_real_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink) {
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `container_source_collection_convert_backlink_to_container'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


ContainerSource* container_source_collection_convert_backlink_to_container (ContainerSourceCollection* self, SourceBacklink* backlink) {
	return CONTAINER_SOURCE_COLLECTION_GET_CLASS (self)->convert_backlink_to_container (self, backlink);
}


void container_source_collection_freeze_attached_notifications (ContainerSourceCollection* self) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _collection_it;
		_tmp0_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
		_collection_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			SourceCollection* collection;
			_tmp1_ = gee_iterator_next (_collection_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_collection_it);
			collection = (SourceCollection*) _tmp2_;
			data_collection_freeze_notifications (DATA_COLLECTION (collection));
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
}


void container_source_collection_thaw_attached_notifications (ContainerSourceCollection* self) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _collection_it;
		_tmp0_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
		_collection_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			SourceCollection* collection;
			_tmp1_ = gee_iterator_next (_collection_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_collection_it);
			collection = (SourceCollection*) _tmp2_;
			data_collection_thaw_notifications (DATA_COLLECTION (collection));
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
}


GeeCollection* container_source_collection_get_holding_tank (ContainerSourceCollection* self) {
	GeeCollection* result = NULL;
	GeeSet* _tmp0_ = NULL;
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), NULL);
	_tmp0_ = gee_abstract_set_get_read_only_view (GEE_ABSTRACT_SET (self->priv->holding_tank));
	result = GEE_COLLECTION (_tmp0_);
	return result;
}


void container_source_collection_init_add_unlinked (ContainerSourceCollection* self, ContainerSource* unlinked) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_CONTAINER_SOURCE (unlinked));
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), unlinked);
}


void container_source_collection_init_add_many_unlinked (ContainerSourceCollection* self, GeeCollection* unlinked) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (unlinked));
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), unlinked);
}


gboolean container_source_collection_relink_from_holding_tank (ContainerSourceCollection* self, ContainerSource* source) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_CONTAINER_SOURCE (source), FALSE);
	_tmp0_ = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), source);
	if (!_tmp0_) {
		result = FALSE;
		return result;
	}
	source_collection_relink (SOURCE_COLLECTION (self), DATA_SOURCE (source));
	result = TRUE;
	return result;
}


static void container_source_collection_on_contained_sources_unlinking (ContainerSourceCollection* self, GeeCollection* unlinking) {
	GeeHashMultiMap* _tmp0_ = NULL;
	GeeHashMultiMap* map;
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (unlinking));
	container_source_collection_freeze_attached_notifications (self);
	_tmp0_ = gee_hash_multi_map_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL);
	map = _tmp0_;
	{
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _source_it;
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (unlinking));
		_source_it = _tmp1_;
		while (TRUE) {
			gboolean _tmp2_;
			gpointer _tmp3_ = NULL;
			DataSource* source;
			GeeCollection* _tmp4_ = NULL;
			GeeCollection* containers;
			gboolean _tmp5_ = FALSE;
			_tmp2_ = gee_iterator_next (_source_it);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = gee_iterator_get (_source_it);
			source = (DataSource*) _tmp3_;
			_tmp4_ = container_source_collection_get_containers_holding_source (self, source);
			containers = _tmp4_;
			if (containers == NULL) {
				_tmp5_ = TRUE;
			} else {
				gint _tmp6_;
				_tmp6_ = gee_collection_get_size (containers);
				_tmp5_ = _tmp6_ == 0;
			}
			if (_tmp5_) {
				_g_object_unref0 (containers);
				_g_object_unref0 (source);
				continue;
			}
			{
				GeeIterator* _tmp7_ = NULL;
				GeeIterator* _container_it;
				_tmp7_ = gee_iterable_iterator (GEE_ITERABLE (containers));
				_container_it = _tmp7_;
				while (TRUE) {
					gboolean _tmp8_;
					gpointer _tmp9_ = NULL;
					ContainerSource* container;
					SourceBacklink* _tmp10_ = NULL;
					SourceBacklink* _tmp11_;
					_tmp8_ = gee_iterator_next (_container_it);
					if (!_tmp8_) {
						break;
					}
					_tmp9_ = gee_iterator_get (_container_it);
					container = (ContainerSource*) _tmp9_;
					gee_multi_map_set (GEE_MULTI_MAP (map), container, source);
					_tmp10_ = container_source_get_backlink (container);
					_tmp11_ = _tmp10_;
					data_source_set_backlink (source, _tmp11_);
					_source_backlink_unref0 (_tmp11_);
					_g_object_unref0 (container);
				}
				_g_object_unref0 (_container_it);
			}
			_g_object_unref0 (containers);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	{
		GeeSet* _tmp12_ = NULL;
		GeeSet* _tmp13_;
		GeeIterator* _tmp14_ = NULL;
		GeeIterator* _tmp15_;
		GeeIterator* _container_it;
		_tmp12_ = gee_multi_map_get_keys (GEE_MULTI_MAP (map));
		_tmp13_ = _tmp12_;
		_tmp14_ = gee_iterable_iterator (GEE_ITERABLE (_tmp13_));
		_tmp15_ = _tmp14_;
		_g_object_unref0 (_tmp13_);
		_container_it = _tmp15_;
		while (TRUE) {
			gboolean _tmp16_;
			gpointer _tmp17_ = NULL;
			ContainerSource* container;
			GeeCollection* _tmp18_ = NULL;
			GeeCollection* _tmp19_;
			_tmp16_ = gee_iterator_next (_container_it);
			if (!_tmp16_) {
				break;
			}
			_tmp17_ = gee_iterator_get (_container_it);
			container = (ContainerSource*) _tmp17_;
			_tmp18_ = gee_multi_map_get (GEE_MULTI_MAP (map), container);
			_tmp19_ = _tmp18_;
			container_source_break_link_many (container, _tmp19_);
			_g_object_unref0 (_tmp19_);
			_g_object_unref0 (container);
		}
		_g_object_unref0 (_container_it);
	}
	container_source_collection_thaw_attached_notifications (self);
	_g_object_unref0 (map);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void container_source_collection_on_contained_sources_relinked (ContainerSourceCollection* self, GeeCollection* relinked) {
	GeeHashMultiMap* _tmp0_ = NULL;
	GeeHashMultiMap* map;
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (relinked));
	container_source_collection_freeze_attached_notifications (self);
	_tmp0_ = gee_hash_multi_map_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL);
	map = _tmp0_;
	{
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _source_it;
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (relinked));
		_source_it = _tmp1_;
		while (TRUE) {
			gboolean _tmp2_;
			gpointer _tmp3_ = NULL;
			DataSource* source;
			GeeList* _tmp4_ = NULL;
			GeeList* backlinks;
			gboolean _tmp5_ = FALSE;
			_tmp2_ = gee_iterator_next (_source_it);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = gee_iterator_get (_source_it);
			source = (DataSource*) _tmp3_;
			_tmp4_ = data_source_get_backlinks (source, self->priv->backlink_name);
			backlinks = _tmp4_;
			if (backlinks == NULL) {
				_tmp5_ = TRUE;
			} else {
				gint _tmp6_;
				_tmp6_ = gee_collection_get_size (GEE_COLLECTION (backlinks));
				_tmp5_ = _tmp6_ == 0;
			}
			if (_tmp5_) {
				_g_object_unref0 (backlinks);
				_g_object_unref0 (source);
				continue;
			}
			{
				GeeList* _tmp7_;
				GeeList* _backlink_list;
				gint _tmp8_;
				gint _backlink_size;
				gint _backlink_index;
				_tmp7_ = _g_object_ref0 (backlinks);
				_backlink_list = _tmp7_;
				_tmp8_ = gee_collection_get_size (GEE_COLLECTION (_backlink_list));
				_backlink_size = _tmp8_;
				_backlink_index = -1;
				while (TRUE) {
					gpointer _tmp9_ = NULL;
					SourceBacklink* backlink;
					ContainerSource* _tmp10_ = NULL;
					ContainerSource* container;
					_backlink_index = _backlink_index + 1;
					if (!(_backlink_index < _backlink_size)) {
						break;
					}
					_tmp9_ = gee_list_get (_backlink_list, _backlink_index);
					backlink = (SourceBacklink*) _tmp9_;
					_tmp10_ = container_source_collection_convert_backlink_to_container (self, backlink);
					container = _tmp10_;
					if (container != NULL) {
						gee_multi_map_set (GEE_MULTI_MAP (map), container, source);
					} else {
						gchar* _tmp11_ = NULL;
						gchar* _tmp12_;
						gchar* _tmp13_ = NULL;
						gchar* _tmp14_;
						_tmp11_ = data_object_to_string (DATA_OBJECT (source));
						_tmp12_ = _tmp11_;
						_tmp13_ = source_backlink_to_string (backlink);
						_tmp14_ = _tmp13_;
						g_warning ("ContainerSourceCollection.vala:161: Unable to relink %s to container b" \
"acklink %s", _tmp12_, _tmp14_);
						_g_free0 (_tmp14_);
						_g_free0 (_tmp12_);
					}
					_g_object_unref0 (container);
					_source_backlink_unref0 (backlink);
				}
				_g_object_unref0 (_backlink_list);
			}
			_g_object_unref0 (backlinks);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	{
		GeeSet* _tmp15_ = NULL;
		GeeSet* _tmp16_;
		GeeIterator* _tmp17_ = NULL;
		GeeIterator* _tmp18_;
		GeeIterator* _container_it;
		_tmp15_ = gee_multi_map_get_keys (GEE_MULTI_MAP (map));
		_tmp16_ = _tmp15_;
		_tmp17_ = gee_iterable_iterator (GEE_ITERABLE (_tmp16_));
		_tmp18_ = _tmp17_;
		_g_object_unref0 (_tmp16_);
		_container_it = _tmp18_;
		while (TRUE) {
			gboolean _tmp19_;
			gpointer _tmp20_ = NULL;
			ContainerSource* container;
			GeeCollection* _tmp21_ = NULL;
			GeeCollection* _tmp22_;
			_tmp19_ = gee_iterator_next (_container_it);
			if (!_tmp19_) {
				break;
			}
			_tmp20_ = gee_iterator_get (_container_it);
			container = (ContainerSource*) _tmp20_;
			_tmp21_ = gee_multi_map_get (GEE_MULTI_MAP (map), container);
			_tmp22_ = _tmp21_;
			container_source_establish_link_many (container, _tmp22_);
			_g_object_unref0 (_tmp22_);
			_g_object_unref0 (container);
		}
		_g_object_unref0 (_container_it);
	}
	container_source_collection_thaw_attached_notifications (self);
	_g_object_unref0 (map);
}


static void container_source_collection_on_contained_source_destroyed (ContainerSourceCollection* self, DataSource* source) {
	GeeIterator* _tmp0_ = NULL;
	GeeIterator* iter;
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_DATA_SOURCE (source));
	_tmp0_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank));
	iter = _tmp0_;
	while (TRUE) {
		gboolean _tmp1_;
		gpointer _tmp2_ = NULL;
		ContainerSource* container;
		gboolean _tmp3_;
		_tmp1_ = gee_iterator_next (iter);
		if (!_tmp1_) {
			break;
		}
		_tmp2_ = gee_iterator_get (iter);
		container = (ContainerSource*) _tmp2_;
		_tmp3_ = container_source_has_links (container);
		if (!_tmp3_) {
			gee_iterator_remove (iter);
			data_source_destroy_orphan (DATA_SOURCE (container), TRUE);
		}
		_g_object_unref0 (container);
	}
	_g_object_unref0 (iter);
}


static void container_source_collection_real_notify_item_destroyed (SourceCollection* base, DataSource* source) {
	ContainerSourceCollection * self;
	self = CONTAINER_SOURCE_COLLECTION (base);
	g_return_if_fail (IS_DATA_SOURCE (source));
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _collection_it;
		_tmp0_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
		_collection_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			SourceCollection* collection;
			SourceBacklink* _tmp3_ = NULL;
			SourceBacklink* _tmp4_;
			_tmp1_ = gee_iterator_next (_collection_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_collection_it);
			collection = (SourceCollection*) _tmp2_;
			_tmp3_ = container_source_get_backlink (CONTAINER_SOURCE (source));
			_tmp4_ = _tmp3_;
			source_collection_remove_backlink (collection, _tmp4_);
			_source_backlink_unref0 (_tmp4_);
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
	SOURCE_COLLECTION_CLASS (container_source_collection_parent_class)->notify_item_destroyed (SOURCE_COLLECTION (DATABASE_SOURCE_COLLECTION (self)), source);
}


void container_source_collection_evaporate (ContainerSourceCollection* self, ContainerSource* container) {
	Marker* _tmp12_ = NULL;
	Marker* _tmp13_;
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _collection_it;
		_tmp0_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
		_collection_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			SourceCollection* collection;
			SourceBacklink* _tmp3_ = NULL;
			SourceBacklink* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
			_tmp1_ = gee_iterator_next (_collection_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_collection_it);
			collection = (SourceCollection*) _tmp2_;
			_tmp3_ = container_source_get_backlink (container);
			_tmp4_ = _tmp3_;
			_tmp5_ = source_collection_has_backlink (collection, _tmp4_);
			_tmp6_ = _tmp5_;
			_source_backlink_unref0 (_tmp4_);
			if (_tmp6_) {
				Marker* _tmp7_ = NULL;
				Marker* _tmp8_;
				GeeCollection* _tmp9_ = NULL;
				GeeCollection* _tmp10_;
				gboolean _tmp11_;
				gboolean added;
				_tmp7_ = data_collection_mark (DATA_COLLECTION (self), DATA_OBJECT (container));
				_tmp8_ = _tmp7_;
				_tmp9_ = source_collection_unlink_marked (SOURCE_COLLECTION (self), _tmp8_, NULL, NULL);
				_tmp10_ = _tmp9_;
				_g_object_unref0 (_tmp10_);
				_g_object_unref0 (_tmp8_);
				_tmp11_ = gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->holding_tank), container);
				added = _tmp11_;
				g_assert (added);
				_data_collection_unref0 (collection);
				_g_object_unref0 (_collection_it);
				return;
			}
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
	_tmp12_ = data_collection_mark (DATA_COLLECTION (self), DATA_OBJECT (container));
	_tmp13_ = _tmp12_;
	source_collection_destroy_marked (SOURCE_COLLECTION (self), _tmp13_, TRUE, NULL, NULL, NULL);
	_g_object_unref0 (_tmp13_);
}


static void _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking (SourceCollection* _sender, GeeCollection* unlinking, gpointer self) {
	container_source_collection_on_contained_sources_unlinking (self, unlinking);
}


static void _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked (SourceCollection* _sender, GeeCollection* relinked, gpointer self) {
	container_source_collection_on_contained_sources_relinked (self, relinked);
}


static void _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
	container_source_collection_on_contained_source_destroyed (self, source);
}


static void _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
	container_source_collection_on_contained_source_destroyed (self, source);
}


void container_source_collection_attach_collection (ContainerSourceCollection* self, SourceCollection* collection) {
	gboolean _tmp0_;
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_SOURCE_COLLECTION (collection));
	_tmp0_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections), collection);
	if (_tmp0_) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp1_ = data_collection_to_string (DATA_COLLECTION (collection));
		_tmp2_ = _tmp1_;
		_tmp3_ = data_collection_to_string (DATA_COLLECTION (self));
		_tmp4_ = _tmp3_;
		g_warning ("ContainerSourceCollection.vala:211: attempted to multiple-attach '%s' " \
"to '%s'", _tmp2_, _tmp4_);
		_g_free0 (_tmp4_);
		_g_free0 (_tmp2_);
		return;
	}
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections), collection);
	g_signal_connect (collection, "items-unlinking", (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
	g_signal_connect (collection, "items-relinked", (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
	g_signal_connect (collection, "item-destroyed", (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
	g_signal_connect (collection, "unlinked-destroyed", (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed, self);
}


void container_source_collection_detach_all_collections (ContainerSourceCollection* self) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _collection_it;
		_tmp0_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
		_collection_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			SourceCollection* collection;
			guint _tmp3_;
			guint _tmp4_;
			guint _tmp5_;
			guint _tmp6_;
			_tmp1_ = gee_iterator_next (_collection_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_collection_it);
			collection = (SourceCollection*) _tmp2_;
			g_signal_parse_name ("items-unlinking", TYPE_SOURCE_COLLECTION, &_tmp3_, NULL, FALSE);
			g_signal_handlers_disconnect_matched (collection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_unlinking_source_collection_items_unlinking, self);
			g_signal_parse_name ("items-relinked", TYPE_SOURCE_COLLECTION, &_tmp4_, NULL, FALSE);
			g_signal_handlers_disconnect_matched (collection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _container_source_collection_on_contained_sources_relinked_source_collection_items_relinked, self);
			g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp5_, NULL, FALSE);
			g_signal_handlers_disconnect_matched (collection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_item_destroyed, self);
			g_signal_parse_name ("unlinked-destroyed", TYPE_SOURCE_COLLECTION, &_tmp6_, NULL, FALSE);
			g_signal_handlers_disconnect_matched (collection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _container_source_collection_on_contained_source_destroyed_source_collection_unlinked_destroyed, self);
			_data_collection_unref0 (collection);
		}
		_g_object_unref0 (_collection_it);
	}
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->attached_collections));
}


static void container_source_collection_real_container_contents_added (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
	g_return_if_fail (GEE_IS_COLLECTION (added));
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gpointer arg_2, gboolean arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_boolean (param_values + 3), data2);
}


static void container_source_collection_real_container_contents_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* removed, gboolean unlinked) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
	g_return_if_fail (GEE_IS_COLLECTION (removed));
}


static void container_source_collection_real_container_contents_altered (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gpointer arg_2, gboolean arg_3, gpointer arg_4, gboolean arg_5, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 6);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_boolean (param_values + 3), g_value_get_object (param_values + 4), g_value_get_boolean (param_values + 5), data2);
}


static void container_source_collection_real_backlink_to_container_removed (ContainerSourceCollection* self, ContainerSource* container, GeeCollection* sources) {
	g_return_if_fail (IS_CONTAINER_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
	g_return_if_fail (GEE_IS_COLLECTION (sources));
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void container_source_collection_class_init (ContainerSourceCollectionClass * klass) {
	container_source_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = container_source_collection_finalize;
	g_type_class_add_private (klass, sizeof (ContainerSourceCollectionPrivate));
	SOURCE_COLLECTION_CLASS (klass)->notify_backlink_removed = container_source_collection_real_notify_backlink_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_added = container_source_collection_real_notify_container_contents_added;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_removed = container_source_collection_real_notify_container_contents_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_container_contents_altered = container_source_collection_real_notify_container_contents_altered;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->notify_backlink_to_container_removed = container_source_collection_real_notify_backlink_to_container_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->get_containers_holding_source = container_source_collection_real_get_containers_holding_source;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->convert_backlink_to_container = container_source_collection_real_convert_backlink_to_container;
	SOURCE_COLLECTION_CLASS (klass)->notify_item_destroyed = container_source_collection_real_notify_item_destroyed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_added = container_source_collection_real_container_contents_added;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_removed = container_source_collection_real_container_contents_removed;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->container_contents_altered = container_source_collection_real_container_contents_altered;
	CONTAINER_SOURCE_COLLECTION_CLASS (klass)->backlink_to_container_removed = container_source_collection_real_backlink_to_container_removed;
	g_signal_new ("container_contents_added", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_added), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN, G_TYPE_NONE, 3, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
	g_signal_new ("container_contents_removed", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_removed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN, G_TYPE_NONE, 3, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
	g_signal_new ("container_contents_altered", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, container_contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOOLEAN_OBJECT_BOOLEAN, G_TYPE_NONE, 5, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN, GEE_TYPE_COLLECTION, G_TYPE_BOOLEAN);
	g_signal_new ("backlink_to_container_removed", TYPE_CONTAINER_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ContainerSourceCollectionClass, backlink_to_container_removed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_CONTAINER_SOURCE, GEE_TYPE_COLLECTION);
}


static void container_source_collection_instance_init (ContainerSourceCollection * self) {
	GeeHashSet* _tmp0_ = NULL;
	GeeHashSet* _tmp1_ = NULL;
	self->priv = CONTAINER_SOURCE_COLLECTION_GET_PRIVATE (self);
	_tmp0_ = gee_hash_set_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, data_collection_unref, NULL, NULL);
	self->priv->attached_collections = _tmp0_;
	_tmp1_ = gee_hash_set_new (TYPE_CONTAINER_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->holding_tank = _tmp1_;
}


static void container_source_collection_finalize (DataCollection* obj) {
	ContainerSourceCollection * self;
	self = CONTAINER_SOURCE_COLLECTION (obj);
	container_source_collection_detach_all_collections (self);
	_g_object_unref0 (self->priv->attached_collections);
	_g_free0 (self->priv->backlink_name);
	_g_object_unref0 (self->priv->holding_tank);
	DATA_COLLECTION_CLASS (container_source_collection_parent_class)->finalize (obj);
}


GType container_source_collection_get_type (void) {
	static volatile gsize container_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&container_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContainerSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) container_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContainerSourceCollection), 0, (GInstanceInitFunc) container_source_collection_instance_init, NULL };
		GType container_source_collection_type_id;
		container_source_collection_type_id = g_type_register_static (TYPE_DATABASE_SOURCE_COLLECTION, "ContainerSourceCollection", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&container_source_collection_type_id__volatile, container_source_collection_type_id);
	}
	return container_source_collection_type_id__volatile;
}



