/* DataSource.c generated by valac 0.12.1, the Vala compiler
 * generated from DataSource.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/**/
/* DataSource*/
/* */
/* A DataSource is an object that is unique throughout the system.  DataSources*/
/* commonly have external and/or persistent representations, hence they have a notion of being*/
/* destroyed (versus removed or freed).  Several DataViews may exist that reference a single*/
/* DataSource.  Note that DataSources MUST be destroyed (rather than simply removed) from their*/
/* SourceCollection, and that they MUST be destroyed via their SourceCollection (rather than*/
/* calling DataSource.destroy() directly.)*/
/**/
/* Destroying a DataSource indicates it should remove all secondary and tertiary structures (such*/
/* as thumbnails) and any records pointing to its backing store.  SourceCollection.destroy_marked()*/
/* has a parameter indicating if the backing should be destroyed as well; that is when*/
/* internal_delete_backing() is called.*/
/**/
/* There are no provisions (currently) for a DataSource to be removed from its SourceCollection*/
/* without destroying its backing and/or secondary and tertiary structures.  DataSources are intended*/
/* to go to the grave with their SourceCollection otherwise.  If a need arises for a DataSource to*/
/* be peaceably removed from its SourceCollection, code will need to be written.  SourceSnapshots*/
/* may be one solution to this problem.*/
/**/
/* Some DataSources cannot be reconstituted (for example, if its backing file is deleted).  In*/
/* that case, dehydrate() should return null.  When reconstituted, it is the responsibility of the*/
/* implementation to ensure an exact clone is produced, minus any details that are not relevant or*/
/* exposed (such as a database ID).*/
/**/
/* If other DataSources refer to this DataSource, their state will *not* be */
/* saved/restored.  This must be achieved via other means.  However, implementations *should**/
/* track when changes to external state would break the proxy and call notify_broken();*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;
#define _source_backlink_unref0(var) ((var == NULL) ? NULL : (var = (source_backlink_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SourceSnapshotPrivate SourceSnapshotPrivate;
typedef struct _ParamSpecSourceSnapshot ParamSpecSourceSnapshot;
typedef struct _SourceBacklinkPrivate SourceBacklinkPrivate;
typedef struct _ParamSpecSourceBacklink ParamSpecSourceBacklink;

#define TYPE_SOURCE_PROXY (source_proxy_get_type ())
#define SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_PROXY, SourceProxy))
#define SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_PROXY, SourceProxyClass))
#define IS_SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_PROXY))
#define IS_SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_PROXY))
#define SOURCE_PROXY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_PROXY, SourceProxyClass))

typedef struct _SourceProxy SourceProxy;
typedef struct _SourceProxyClass SourceProxyClass;
typedef struct _SourceProxyPrivate SourceProxyPrivate;
#define _source_snapshot_unref0(var) ((var == NULL) ? NULL : (var = (source_snapshot_unref (var), NULL)))
typedef struct _ParamSpecSourceProxy ParamSpecSourceProxy;

#define TYPE_PROXYABLE (proxyable_get_type ())
#define PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROXYABLE, Proxyable))
#define IS_PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROXYABLE))
#define PROXYABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_PROXYABLE, ProxyableIface))

typedef struct _Proxyable Proxyable;
typedef struct _ProxyableIface ProxyableIface;

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _DataSourcePrivate {
	DataView** subscribers;
	gint subscribers_length1;
	gint _subscribers_size_;
	SourceHoldingTank* holding_tank;
	SourceCollection* unlinked_from_collection;
	GeeHashMap* backlinks;
	gboolean in_contact;
	gboolean marked_for_destroy;
	gboolean is_destroyed;
};

typedef void (*DataSourceContactSubscriber) (DataView* view, void* user_data);
typedef void (*DataSourceContactSubscriberAlteration) (DataView* view, Alteration* alteration, void* user_data);
struct _SourceSnapshot {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceSnapshotPrivate * priv;
};

struct _SourceSnapshotClass {
	GTypeClass parent_class;
	void (*finalize) (SourceSnapshot *self);
	void (*notify_broken) (SourceSnapshot* self);
	void (*broken) (SourceSnapshot* self);
};

struct _SourceSnapshotPrivate {
	gboolean snapshot_broken;
};

struct _ParamSpecSourceSnapshot {
	GParamSpec parent_instance;
};

struct _SourceBacklink {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceBacklinkPrivate * priv;
};

struct _SourceBacklinkClass {
	GTypeClass parent_class;
	void (*finalize) (SourceBacklink *self);
};

struct _SourceBacklinkPrivate {
	gchar* _name;
	gchar* _value;
};

struct _ParamSpecSourceBacklink {
	GParamSpec parent_instance;
};

struct _SourceProxy {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceProxyPrivate * priv;
};

struct _SourceProxyClass {
	GTypeClass parent_class;
	void (*finalize) (SourceProxy *self);
	DataSource* (*reconstitute) (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
	void (*notify_reconstituted) (SourceProxy* self, DataSource* source);
	void (*notify_dehydrated) (SourceProxy* self);
	void (*notify_broken) (SourceProxy* self);
	void (*reconstituted) (SourceProxy* self, DataSource* source);
	void (*dehydrated) (SourceProxy* self);
	void (*broken) (SourceProxy* self);
};

struct _SourceProxyPrivate {
	gint64 object_id;
	gchar* source_string;
	DataSource* source;
	SourceSnapshot* snapshot;
	SourceCollection* membership;
};

struct _ParamSpecSourceProxy {
	GParamSpec parent_instance;
};

struct _ProxyableIface {
	GTypeInterface parent_iface;
	SourceProxy* (*get_proxy) (Proxyable* self);
};


static gpointer data_source_parent_class = NULL;
static gpointer source_snapshot_parent_class = NULL;
static gpointer source_backlink_parent_class = NULL;
static gpointer source_proxy_parent_class = NULL;

GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_snapshot (GValue* value, gpointer v_object);
void value_take_source_snapshot (GValue* value, gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
#define DATA_SOURCE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_SOURCE, DataSourcePrivate))
enum  {
	DATA_SOURCE_DUMMY_PROPERTY
};
DataSource* data_source_construct (GType object_type, gint64 object_id);
DataObject* data_object_construct (GType object_type, gint64 object_id);
static void data_source_real_notify_membership_changed (DataObject* base, DataCollection* collection);
void data_source_notify_unlinked (DataSource* self);
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection);
void data_source_notify_held_in_tank (DataSource* self, SourceHoldingTank* holding_tank);
static void data_source_real_notify_held_in_tank (DataSource* self, SourceHoldingTank* holding_tank);
DataCollection* data_object_get_membership (DataObject* self);
static void data_source_real_notify_altered (DataObject* base, Alteration* alteration);
void source_holding_tank_internal_notify_altered (SourceHoldingTank* self, DataSource* source, Alteration* alteration);
void data_source_contact_subscribers_alteration (DataSource* self, Alteration* alteration);
void data_object_notify_altered (DataObject* self, Alteration* alteration);
void data_source_notify_unlinking (DataSource* self, SourceCollection* collection);
static void data_source_real_notify_unlinking (DataSource* self, SourceCollection* collection);
static void data_source_real_notify_unlinked (DataSource* self);
void data_source_commit_backlinks (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
static gchar* data_source_dehydrate_backlinks (DataSource* self);
void data_source_notify_relinking (DataSource* self, SourceCollection* collection);
static void data_source_real_notify_relinking (DataSource* self, SourceCollection* collection);
void data_source_notify_relinked (DataSource* self);
static void data_source_real_notify_relinked (DataSource* self);
gchar* data_source_get_typename (DataSource* self);
static gchar* data_source_real_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
static gint64 data_source_real_get_instance_id (DataSource* self);
gchar* data_source_get_source_id (DataSource* self);
static gchar* data_source_real_get_source_id (DataSource* self);
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink);
const gchar* source_backlink_get_name (SourceBacklink* self);
const gchar* source_backlink_get_value (SourceBacklink* self);
GeeList* data_source_get_backlinks (DataSource* self, const gchar* name);
SourceBacklink* source_backlink_new (const gchar* name, const gchar* value);
SourceBacklink* source_backlink_construct (GType object_type, const gchar* name, const gchar* value);
void data_source_set_backlink (DataSource* self, SourceBacklink* backlink);
void source_collection_internal_backlink_set (SourceCollection* self, DataSource* source, SourceBacklink* backlink);
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink);
void source_collection_internal_backlink_removed (SourceCollection* self, DataSource* source, SourceBacklink* backlink);
static void data_source_real_commit_backlinks (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
gchar* data_object_to_string (DataObject* self);
gboolean is_string_empty (const gchar* s);
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const gchar* dehydrated);
SourceSnapshot* data_source_save_snapshot (DataSource* self);
static SourceSnapshot* data_source_real_save_snapshot (DataSource* self);
void data_source_internal_mark_for_destroy (DataSource* self);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
static gboolean data_source_real_internal_delete_backing (DataSource* self, GError** error);
gboolean data_source_equals (DataSource* self, DataSource* source);
static gboolean data_source_real_equals (DataSource* self, DataSource* source);
void data_source_destroy (DataSource* self);
static void data_source_real_destroy (DataSource* self);
void data_view_notify_unsubscribed (DataView* self, DataSource* source);
gboolean data_source_destroy_orphan (DataSource* self, gboolean delete_backing);
void source_collection_notify_unlinked_destroyed (SourceCollection* self, DataSource* unlinked);
void data_source_internal_subscribe (DataSource* self, DataView* view);
static void _vala_array_add86 (DataView*** array, int* length, int* size, DataView* value);
void data_source_internal_unsubscribe (DataSource* self, DataView* view);
void data_source_contact_subscribers (DataSource* self, DataSourceContactSubscriber contact_subscriber, void* contact_subscriber_target);
void data_source_unlinked (DataSource* self, SourceCollection* sources);
static void data_source_real_unlinked (DataSource* self, SourceCollection* sources);
static void g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
void data_source_relinked (DataSource* self, SourceCollection* sources);
static void data_source_real_relinked (DataSource* self, SourceCollection* sources);
void data_source_destroyed (DataSource* self);
static void data_source_real_destroyed (DataSource* self);
static void data_source_finalize (GObject* obj);
#define SOURCE_SNAPSHOT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_SNAPSHOT, SourceSnapshotPrivate))
enum  {
	SOURCE_SNAPSHOT_DUMMY_PROPERTY
};
void source_snapshot_notify_broken (SourceSnapshot* self);
static void source_snapshot_real_notify_broken (SourceSnapshot* self);
gboolean source_snapshot_is_broken (SourceSnapshot* self);
SourceSnapshot* source_snapshot_construct (GType object_type);
void source_snapshot_broken (SourceSnapshot* self);
static void source_snapshot_real_broken (SourceSnapshot* self);
static void source_snapshot_finalize (SourceSnapshot* obj);
#define SOURCE_BACKLINK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_BACKLINK, SourceBacklinkPrivate))
enum  {
	SOURCE_BACKLINK_DUMMY_PROPERTY
};
static gboolean source_backlink_validate_name_value (const gchar* name, const gchar* value);
SourceBacklink* source_backlink_new_from_source (DataSource* source);
SourceBacklink* source_backlink_construct_from_source (GType object_type, DataSource* source);
gchar* source_backlink_to_string (SourceBacklink* self);
guint source_backlink_hash_func (void* key);
gboolean source_backlink_equal_func (void* a, void* b);
const gchar* source_backlink_get_typename (SourceBacklink* self);
gint64 source_backlink_get_instance_id (SourceBacklink* self);
static void source_backlink_finalize (SourceBacklink* obj);
gpointer source_proxy_ref (gpointer instance);
void source_proxy_unref (gpointer instance);
GParamSpec* param_spec_source_proxy (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_proxy (GValue* value, gpointer v_object);
void value_take_source_proxy (GValue* value, gpointer v_object);
gpointer value_get_source_proxy (const GValue* value);
GType source_proxy_get_type (void) G_GNUC_CONST;
#define SOURCE_PROXY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_PROXY, SourceProxyPrivate))
enum  {
	SOURCE_PROXY_DUMMY_PROPERTY
};
static void source_proxy_drop_source (SourceProxy* self);
static void source_proxy_on_source_added (SourceProxy* self, GeeIterable* added);
static void _source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
SourceProxy* source_proxy_construct (GType object_type, DataSource* source);
gint64 data_object_get_object_id (DataObject* self);
static void source_proxy_on_snapshot_broken (SourceProxy* self);
static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender, gpointer self);
static void source_proxy_set_source (SourceProxy* self, DataSource* source);
DataSource* source_proxy_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
static DataSource* source_proxy_real_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
void source_proxy_notify_reconstituted (SourceProxy* self, DataSource* source);
static void source_proxy_real_notify_reconstituted (SourceProxy* self, DataSource* source);
void source_proxy_notify_dehydrated (SourceProxy* self);
static void source_proxy_real_notify_dehydrated (SourceProxy* self);
void source_proxy_notify_broken (SourceProxy* self);
static void source_proxy_real_notify_broken (SourceProxy* self);
static void source_proxy_on_destroyed (SourceProxy* self);
static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender, gpointer self);
DataSource* source_proxy_get_source (SourceProxy* self);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
void source_proxy_reconstituted (SourceProxy* self, DataSource* source);
static void source_proxy_real_reconstituted (SourceProxy* self, DataSource* source);
void source_proxy_dehydrated (SourceProxy* self);
static void source_proxy_real_dehydrated (SourceProxy* self);
void source_proxy_broken (SourceProxy* self);
static void source_proxy_real_broken (SourceProxy* self);
static void source_proxy_finalize (SourceProxy* obj);
GType proxyable_get_type (void) G_GNUC_CONST;
SourceProxy* proxyable_get_proxy (Proxyable* self);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


DataSource* data_source_construct (GType object_type, gint64 object_id) {
	DataSource * self = NULL;
	self = (DataSource*) data_object_construct (object_type, object_id);
	return self;
}


static void data_source_real_notify_membership_changed (DataObject* base, DataCollection* collection) {
	DataSource * self;
	gboolean _tmp1_ = FALSE;
	self = DATA_SOURCE (base);
	g_return_if_fail ((collection == NULL) || IS_DATA_COLLECTION (collection));
	if (collection == NULL) {
		gboolean _tmp0_ = FALSE;
		if (self->priv->is_destroyed) {
			_tmp0_ = TRUE;
		} else {
			_tmp0_ = self->priv->backlinks != NULL;
		}
		g_assert (_tmp0_);
	} else {
		g_assert (!self->priv->is_destroyed);
	}
	if (collection == NULL) {
		_tmp1_ = self->priv->backlinks != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		data_source_notify_unlinked (self);
	}
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_membership_changed (DATA_OBJECT (self), collection);
}


static gpointer _source_holding_tank_ref0 (gpointer self) {
	return self ? source_holding_tank_ref (self) : NULL;
}


static void data_source_real_notify_held_in_tank (DataSource* self, SourceHoldingTank* holding_tank) {
	DataCollection* _tmp0_ = NULL;
	DataCollection* _tmp1_;
	SourceHoldingTank* _tmp2_;
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_return_if_fail ((holding_tank == NULL) || IS_SOURCE_HOLDING_TANK (holding_tank));
	_tmp0_ = data_object_get_membership (DATA_OBJECT (self));
	_tmp1_ = _tmp0_;
	g_assert (_tmp1_ == NULL);
	_data_collection_unref0 (_tmp1_);
	if (holding_tank != NULL) {
		g_assert (self->priv->holding_tank == NULL);
	} else {
		g_assert (self->priv->holding_tank != NULL);
	}
	_tmp2_ = _source_holding_tank_ref0 (holding_tank);
	_source_holding_tank_unref0 (self->priv->holding_tank);
	self->priv->holding_tank = _tmp2_;
}


void data_source_notify_held_in_tank (DataSource* self, SourceHoldingTank* holding_tank) {
	DATA_SOURCE_GET_CLASS (self)->notify_held_in_tank (self, holding_tank);
}


static void data_source_real_notify_altered (DataObject* base, Alteration* alteration) {
	DataSource * self;
	self = DATA_SOURCE (base);
	g_return_if_fail (IS_ALTERATION (alteration));
	if (self->priv->holding_tank != NULL) {
		source_holding_tank_internal_notify_altered (self->priv->holding_tank, self, alteration);
	} else {
		data_source_contact_subscribers_alteration (self, alteration);
		DATA_OBJECT_CLASS (data_source_parent_class)->notify_altered (DATA_OBJECT (self), alteration);
	}
}


static void data_source_real_notify_unlinking (DataSource* self, SourceCollection* collection) {
	gboolean _tmp0_ = FALSE;
	GeeHashMap* _tmp1_ = NULL;
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_return_if_fail (IS_SOURCE_COLLECTION (collection));
	if (self->priv->backlinks == NULL) {
		_tmp0_ = self->priv->unlinked_from_collection == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	g_assert (_tmp0_);
	self->priv->unlinked_from_collection = collection;
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->backlinks);
	self->priv->backlinks = _tmp1_;
}


void data_source_notify_unlinking (DataSource* self, SourceCollection* collection) {
	DATA_SOURCE_GET_CLASS (self)->notify_unlinking (self, collection);
}


static void data_source_real_notify_unlinked (DataSource* self) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	g_return_if_fail (IS_DATA_SOURCE (self));
	if (self->priv->unlinked_from_collection != NULL) {
		_tmp0_ = self->priv->backlinks != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	g_assert (_tmp0_);
	g_signal_emit_by_name (self, "unlinked", self->priv->unlinked_from_collection);
	_tmp1_ = gee_map_get_size (GEE_MAP (self->priv->backlinks));
	if (_tmp1_ > 0) {
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		_tmp2_ = data_source_dehydrate_backlinks (self);
		_tmp3_ = _tmp2_;
		data_source_commit_backlinks (self, self->priv->unlinked_from_collection, _tmp3_);
		_g_free0 (_tmp3_);
	}
}


void data_source_notify_unlinked (DataSource* self) {
	DATA_SOURCE_GET_CLASS (self)->notify_unlinked (self);
}


static void data_source_real_notify_relinking (DataSource* self, SourceCollection* collection) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_return_if_fail (IS_SOURCE_COLLECTION (collection));
	if (self->priv->backlinks != NULL) {
		_tmp0_ = self->priv->unlinked_from_collection == collection;
	} else {
		_tmp0_ = FALSE;
	}
	g_assert (_tmp0_);
}


void data_source_notify_relinking (DataSource* self, SourceCollection* collection) {
	DATA_SOURCE_GET_CLASS (self)->notify_relinking (self, collection);
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


static void data_source_real_notify_relinked (DataSource* self) {
	gboolean _tmp0_ = FALSE;
	SourceCollection* _tmp1_;
	SourceCollection* relinked_to;
	g_return_if_fail (IS_DATA_SOURCE (self));
	if (self->priv->backlinks != NULL) {
		_tmp0_ = self->priv->unlinked_from_collection != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	g_assert (_tmp0_);
	_tmp1_ = _data_collection_ref0 (self->priv->unlinked_from_collection);
	relinked_to = _tmp1_;
	_g_object_unref0 (self->priv->backlinks);
	self->priv->backlinks = NULL;
	self->priv->unlinked_from_collection = NULL;
	g_signal_emit_by_name (self, "relinked", relinked_to);
	data_source_commit_backlinks (self, NULL, NULL);
	_data_collection_unref0 (relinked_to);
}


void data_source_notify_relinked (DataSource* self) {
	DATA_SOURCE_GET_CLASS (self)->notify_relinked (self);
}


static gchar* data_source_real_get_typename (DataSource* self) {
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_source_get_typename'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


gchar* data_source_get_typename (DataSource* self) {
	return DATA_SOURCE_GET_CLASS (self)->get_typename (self);
}


static gint64 data_source_real_get_instance_id (DataSource* self) {
	g_return_val_if_fail (IS_DATA_SOURCE (self), 0LL);
	g_critical ("Type `%s' does not implement abstract method `data_source_get_instance_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0LL;
}


gint64 data_source_get_instance_id (DataSource* self) {
	return DATA_SOURCE_GET_CLASS (self)->get_instance_id (self);
}


static gchar* data_source_real_get_source_id (DataSource* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gint64 _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
	_tmp0_ = data_source_get_typename (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = data_source_get_instance_id (self);
	_tmp3_ = g_strdup_printf ("%s-%016" G_GINT64_MODIFIER "x", _tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp1_);
	result = _tmp4_;
	return result;
}


gchar* data_source_get_source_id (DataSource* self) {
	return DATA_SOURCE_GET_CLASS (self)->get_source_id (self);
}


gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gpointer _tmp1_ = NULL;
	GeeList* values;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
	if (self->priv->backlinks == NULL) {
		result = FALSE;
		return result;
	}
	_tmp0_ = source_backlink_get_name (backlink);
	_tmp1_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), _tmp0_);
	values = (GeeList*) _tmp1_;
	if (values != NULL) {
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_;
		_tmp3_ = source_backlink_get_value (backlink);
		_tmp4_ = gee_collection_contains (GEE_COLLECTION (values), _tmp3_);
		_tmp2_ = _tmp4_;
	} else {
		_tmp2_ = FALSE;
	}
	result = _tmp2_;
	_g_object_unref0 (values);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GeeList* data_source_get_backlinks (DataSource* self, const gchar* name) {
	GeeList* result = NULL;
	gpointer _tmp0_ = NULL;
	GeeList* values;
	gboolean _tmp1_ = FALSE;
	GeeArrayList* _tmp3_ = NULL;
	GeeList* backlinks;
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
	g_return_val_if_fail (name != NULL, NULL);
	if (self->priv->backlinks == NULL) {
		result = NULL;
		return result;
	}
	_tmp0_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), name);
	values = (GeeList*) _tmp0_;
	if (values == NULL) {
		_tmp1_ = TRUE;
	} else {
		gint _tmp2_;
		_tmp2_ = gee_collection_get_size (GEE_COLLECTION (values));
		_tmp1_ = _tmp2_ == 0;
	}
	if (_tmp1_) {
		result = NULL;
		_g_object_unref0 (values);
		return result;
	}
	_tmp3_ = gee_array_list_new (TYPE_SOURCE_BACKLINK, (GBoxedCopyFunc) source_backlink_ref, source_backlink_unref, NULL);
	backlinks = GEE_LIST (_tmp3_);
	{
		GeeList* _tmp4_;
		GeeList* _value_list;
		gint _tmp5_;
		gint _value_size;
		gint _value_index;
		_tmp4_ = _g_object_ref0 (values);
		_value_list = _tmp4_;
		_tmp5_ = gee_collection_get_size (GEE_COLLECTION (_value_list));
		_value_size = _tmp5_;
		_value_index = -1;
		while (TRUE) {
			gpointer _tmp6_ = NULL;
			gchar* value;
			SourceBacklink* _tmp7_ = NULL;
			SourceBacklink* _tmp8_;
			_value_index = _value_index + 1;
			if (!(_value_index < _value_size)) {
				break;
			}
			_tmp6_ = gee_list_get (_value_list, _value_index);
			value = (gchar*) _tmp6_;
			_tmp7_ = source_backlink_new (name, value);
			_tmp8_ = _tmp7_;
			gee_collection_add (GEE_COLLECTION (backlinks), _tmp8_);
			_source_backlink_unref0 (_tmp8_);
			_g_free0 (value);
		}
		_g_object_unref0 (_value_list);
	}
	result = backlinks;
	_g_object_unref0 (values);
	return result;
}


void data_source_set_backlink (DataSource* self, SourceBacklink* backlink) {
	const gchar* _tmp0_ = NULL;
	gpointer _tmp1_ = NULL;
	GeeList* values;
	const gchar* _tmp4_ = NULL;
	DataCollection* _tmp5_ = NULL;
	SourceCollection* sources;
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
	g_assert (self->priv->backlinks != NULL);
	_tmp0_ = source_backlink_get_name (backlink);
	_tmp1_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), _tmp0_);
	values = (GeeList*) _tmp1_;
	if (values == NULL) {
		GeeArrayList* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		_tmp2_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
		_g_object_unref0 (values);
		values = GEE_LIST (_tmp2_);
		_tmp3_ = source_backlink_get_name (backlink);
		gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->backlinks), _tmp3_, values);
	}
	_tmp4_ = source_backlink_get_value (backlink);
	gee_collection_add (GEE_COLLECTION (values), _tmp4_);
	_tmp5_ = data_object_get_membership (DATA_OBJECT (self));
	sources = SOURCE_COLLECTION (_tmp5_);
	if (sources != NULL) {
		source_collection_internal_backlink_set (sources, self, backlink);
	}
	_data_collection_unref0 (sources);
	_g_object_unref0 (values);
}


gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gpointer _tmp1_ = NULL;
	GeeList* values;
	gint _tmp2_;
	gint original_size;
	GeeIterator* _tmp3_ = NULL;
	GeeIterator* iter;
	gint _tmp9_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	DataCollection* _tmp13_ = NULL;
	SourceCollection* sources;
	gint _tmp14_;
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
	if (self->priv->backlinks == NULL) {
		result = FALSE;
		return result;
	}
	_tmp0_ = source_backlink_get_name (backlink);
	_tmp1_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), _tmp0_);
	values = (GeeList*) _tmp1_;
	if (values == NULL) {
		result = FALSE;
		_g_object_unref0 (values);
		return result;
	}
	_tmp2_ = gee_collection_get_size (GEE_COLLECTION (values));
	original_size = _tmp2_;
	g_assert (original_size > 0);
	_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (values));
	iter = _tmp3_;
	while (TRUE) {
		gboolean _tmp4_;
		gpointer _tmp5_ = NULL;
		gchar* _tmp6_;
		const gchar* _tmp7_ = NULL;
		gboolean _tmp8_;
		_tmp4_ = gee_iterator_next (iter);
		if (!_tmp4_) {
			break;
		}
		_tmp5_ = gee_iterator_get (iter);
		_tmp6_ = (gchar*) _tmp5_;
		_tmp7_ = source_backlink_get_value (backlink);
		_tmp8_ = g_strcmp0 (_tmp6_, _tmp7_) == 0;
		_g_free0 (_tmp6_);
		if (_tmp8_) {
			gee_iterator_remove (iter);
		}
	}
	_tmp9_ = gee_collection_get_size (GEE_COLLECTION (values));
	if (_tmp9_ == 0) {
		const gchar* _tmp10_ = NULL;
		_tmp10_ = source_backlink_get_name (backlink);
		gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->backlinks), _tmp10_, NULL);
	}
	_tmp11_ = data_source_dehydrate_backlinks (self);
	_tmp12_ = _tmp11_;
	data_source_commit_backlinks (self, self->priv->unlinked_from_collection, _tmp12_);
	_g_free0 (_tmp12_);
	_tmp13_ = data_object_get_membership (DATA_OBJECT (self));
	sources = SOURCE_COLLECTION (_tmp13_);
	if (sources != NULL) {
		source_collection_internal_backlink_removed (sources, self, backlink);
	}
	_tmp14_ = gee_collection_get_size (GEE_COLLECTION (values));
	result = _tmp14_ != original_size;
	_data_collection_unref0 (sources);
	_g_object_unref0 (iter);
	_g_object_unref0 (values);
	return result;
}


static void data_source_real_commit_backlinks (DataSource* self, SourceCollection* sources, const gchar* dehydrated) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
	if (sources != NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = dehydrated != NULL;
	}
	if (_tmp0_) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		_tmp1_ = data_object_to_string (DATA_OBJECT (self));
		_tmp2_ = _tmp1_;
		g_warning ("DataSource.vala:250: No implementation to commit link state for %s", _tmp2_);
		_g_free0 (_tmp2_);
	}
}


void data_source_commit_backlinks (DataSource* self, SourceCollection* sources, const gchar* dehydrated) {
	DATA_SOURCE_GET_CLASS (self)->commit_backlinks (self, sources, dehydrated);
}


static gchar* data_source_dehydrate_backlinks (DataSource* self) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	GString* _tmp2_ = NULL;
	GString* builder;
	const gchar* _tmp23_ = NULL;
	gint _tmp24_;
	gchar* _tmp25_;
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
	if (self->priv->backlinks == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp1_;
		_tmp1_ = gee_map_get_size (GEE_MAP (self->priv->backlinks));
		_tmp0_ = _tmp1_ == 0;
	}
	if (_tmp0_) {
		result = NULL;
		return result;
	}
	_tmp2_ = g_string_new ("");
	builder = _tmp2_;
	{
		GeeSet* _tmp3_ = NULL;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_;
		GeeIterator* _name_it;
		_tmp3_ = gee_map_get_keys (GEE_MAP (self->priv->backlinks));
		_tmp4_ = _tmp3_;
		_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (_tmp4_));
		_tmp6_ = _tmp5_;
		_g_object_unref0 (_tmp4_);
		_name_it = _tmp6_;
		while (TRUE) {
			gboolean _tmp7_;
			gpointer _tmp8_ = NULL;
			gchar* name;
			gpointer _tmp9_ = NULL;
			GeeList* values;
			gboolean _tmp10_ = FALSE;
			gchar* _tmp12_;
			gchar* value_field;
			gint _tmp20_;
			_tmp7_ = gee_iterator_next (_name_it);
			if (!_tmp7_) {
				break;
			}
			_tmp8_ = gee_iterator_get (_name_it);
			name = (gchar*) _tmp8_;
			_tmp9_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->backlinks), name);
			values = (GeeList*) _tmp9_;
			if (values == NULL) {
				_tmp10_ = TRUE;
			} else {
				gint _tmp11_;
				_tmp11_ = gee_collection_get_size (GEE_COLLECTION (values));
				_tmp10_ = _tmp11_ == 0;
			}
			if (_tmp10_) {
				_g_object_unref0 (values);
				_g_free0 (name);
				continue;
			}
			_tmp12_ = g_strdup ("");
			value_field = _tmp12_;
			{
				GeeList* _tmp13_;
				GeeList* _value_list;
				gint _tmp14_;
				gint _value_size;
				gint _value_index;
				_tmp13_ = _g_object_ref0 (values);
				_value_list = _tmp13_;
				_tmp14_ = gee_collection_get_size (GEE_COLLECTION (_value_list));
				_value_size = _tmp14_;
				_value_index = -1;
				while (TRUE) {
					gpointer _tmp15_ = NULL;
					gchar* value;
					gboolean _tmp16_;
					_value_index = _value_index + 1;
					if (!(_value_index < _value_size)) {
						break;
					}
					_tmp15_ = gee_list_get (_value_list, _value_index);
					value = (gchar*) _tmp15_;
					_tmp16_ = is_string_empty (value);
					if (!_tmp16_) {
						gchar* _tmp17_;
						gchar* _tmp18_;
						gchar* _tmp19_;
						_tmp17_ = g_strconcat (value, "|", NULL);
						_tmp18_ = _tmp17_;
						_tmp19_ = g_strconcat (value_field, _tmp18_, NULL);
						_g_free0 (value_field);
						value_field = _tmp19_;
						_g_free0 (_tmp18_);
					}
					_g_free0 (value);
				}
				_g_object_unref0 (_value_list);
			}
			_tmp20_ = strlen (value_field);
			if (_tmp20_ > 0) {
				gchar* _tmp21_ = NULL;
				gchar* _tmp22_;
				_tmp21_ = g_strdup_printf ("%s=%s\n", name, value_field);
				_tmp22_ = _tmp21_;
				g_string_append (builder, _tmp22_);
				_g_free0 (_tmp22_);
			}
			_g_free0 (value_field);
			_g_object_unref0 (values);
			_g_free0 (name);
		}
		_g_object_unref0 (_name_it);
	}
	_tmp24_ = strlen (builder->str);
	if (_tmp24_ > 0) {
		_tmp23_ = builder->str;
	} else {
		_tmp23_ = NULL;
	}
	_tmp25_ = g_strdup (_tmp23_);
	result = _tmp25_;
	_g_string_free0 (builder);
	return result;
}


void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const gchar* dehydrated) {
	GeeHashMap* _tmp0_ = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_ = NULL;
	gchar** lines;
	gint lines_length1;
	gint _lines_size_;
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_return_if_fail (IS_SOURCE_COLLECTION (unlinked_from));
	self->priv->unlinked_from_collection = unlinked_from;
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->backlinks);
	self->priv->backlinks = _tmp0_;
	if (dehydrated == NULL) {
		return;
	}
	_tmp2_ = _tmp1_ = g_strsplit (dehydrated, "\n", 0);
	lines = _tmp2_;
	lines_length1 = _vala_array_length (_tmp1_);
	_lines_size_ = _vala_array_length (_tmp1_);
	{
		gchar** line_collection;
		int line_collection_length1;
		int line_it;
		line_collection = lines;
		line_collection_length1 = lines_length1;
		for (line_it = 0; line_it < lines_length1; line_it = line_it + 1) {
			gchar* _tmp3_;
			gchar* line;
			_tmp3_ = g_strdup (line_collection[line_it]);
			line = _tmp3_;
			{
				gint _tmp4_;
				gchar** _tmp5_;
				gchar** _tmp6_ = NULL;
				gchar** tokens;
				gint tokens_length1;
				gint _tokens_size_;
				gchar** _tmp9_;
				gchar** _tmp10_ = NULL;
				gchar** decoded_values;
				gint decoded_values_length1;
				gint _decoded_values_size_;
				GeeArrayList* _tmp11_ = NULL;
				GeeList* values;
				gint _tmp15_;
				_tmp4_ = strlen (line);
				if (_tmp4_ == 0) {
					_g_free0 (line);
					continue;
				}
				_tmp6_ = _tmp5_ = g_strsplit (line, "=", 2);
				tokens = _tmp6_;
				tokens_length1 = _vala_array_length (_tmp5_);
				_tokens_size_ = _vala_array_length (_tmp5_);
				if (tokens_length1 < 2) {
					gchar* _tmp7_ = NULL;
					gchar* _tmp8_;
					_tmp7_ = data_object_to_string (DATA_OBJECT (self));
					_tmp8_ = _tmp7_;
					g_warning ("DataSource.vala:292: Unable to rehydrate \"%s\" for %s: name and value" \
" not present", line, _tmp8_);
					_g_free0 (_tmp8_);
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (line);
					continue;
				}
				_tmp10_ = _tmp9_ = g_strsplit (tokens[1], "|", 0);
				decoded_values = _tmp10_;
				decoded_values_length1 = _vala_array_length (_tmp9_);
				_decoded_values_size_ = _vala_array_length (_tmp9_);
				_tmp11_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
				values = GEE_LIST (_tmp11_);
				{
					gchar** value_collection;
					int value_collection_length1;
					int value_it;
					value_collection = decoded_values;
					value_collection_length1 = decoded_values_length1;
					for (value_it = 0; value_it < decoded_values_length1; value_it = value_it + 1) {
						gchar* _tmp12_;
						gchar* value;
						_tmp12_ = g_strdup (value_collection[value_it]);
						value = _tmp12_;
						{
							gboolean _tmp13_ = FALSE;
							if (value != NULL) {
								gint _tmp14_;
								_tmp14_ = strlen (value);
								_tmp13_ = _tmp14_ > 0;
							} else {
								_tmp13_ = FALSE;
							}
							if (_tmp13_) {
								gee_collection_add (GEE_COLLECTION (values), value);
							}
							_g_free0 (value);
						}
					}
				}
				_tmp15_ = gee_collection_get_size (GEE_COLLECTION (values));
				if (_tmp15_ > 0) {
					gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->backlinks), tokens[0], values);
				}
				_g_object_unref0 (values);
				decoded_values = (_vala_array_free (decoded_values, decoded_values_length1, (GDestroyNotify) g_free), NULL);
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (line);
			}
		}
	}
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
}


static SourceSnapshot* data_source_real_save_snapshot (DataSource* self) {
	SourceSnapshot* result = NULL;
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
	result = NULL;
	return result;
}


SourceSnapshot* data_source_save_snapshot (DataSource* self) {
	return DATA_SOURCE_GET_CLASS (self)->save_snapshot (self);
}


void data_source_internal_mark_for_destroy (DataSource* self) {
	g_return_if_fail (IS_DATA_SOURCE (self));
	self->priv->marked_for_destroy = TRUE;
}


static gboolean data_source_real_internal_delete_backing (DataSource* self, GError** error) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
	result = TRUE;
	return result;
}


gboolean data_source_internal_delete_backing (DataSource* self, GError** error) {
	return DATA_SOURCE_GET_CLASS (self)->internal_delete_backing (self, error);
}


static gboolean data_source_real_equals (DataSource* self, DataSource* source) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
	result = self == source;
	return result;
}


gboolean data_source_equals (DataSource* self, DataSource* source) {
	return DATA_SOURCE_GET_CLASS (self)->equals (self, source);
}


static void data_source_real_destroy (DataSource* self) {
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_assert (self->priv->marked_for_destroy);
	self->priv->is_destroyed = TRUE;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					ctr++;
				}
				_tmp0_ = FALSE;
				if (!(ctr < self->priv->subscribers_length1)) {
					break;
				}
				if (self->priv->subscribers[ctr] != NULL) {
					DataView* _tmp1_;
					DataView* view;
					DataView* _tmp2_;
					_tmp1_ = _g_object_ref0 (self->priv->subscribers[ctr]);
					view = _tmp1_;
					_tmp2_ = NULL;
					_g_object_unref0 (self->priv->subscribers[ctr]);
					self->priv->subscribers[ctr] = _tmp2_;
					data_view_notify_unsubscribed (view, self);
					_g_object_unref0 (view);
				}
			}
		}
	}
	g_signal_emit_by_name (self, "destroyed");
}


void data_source_destroy (DataSource* self) {
	DATA_SOURCE_GET_CLASS (self)->destroy (self);
}


gboolean data_source_destroy_orphan (DataSource* self, gboolean delete_backing) {
	gboolean result = FALSE;
	gboolean ret;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
	ret = TRUE;
	if (delete_backing) {
		gboolean _tmp0_;
		gboolean _tmp1_;
		_tmp0_ = data_source_internal_delete_backing (self, &_inner_error_);
		_tmp1_ = _tmp0_;
		if (_inner_error_ != NULL) {
			goto __catch59_g_error;
		}
		ret = _tmp1_;
		if (!ret) {
			gchar* _tmp2_ = NULL;
			gchar* _tmp3_;
			_tmp2_ = data_object_to_string (DATA_OBJECT (self));
			_tmp3_ = _tmp2_;
			g_warning ("DataSource.vala:372: Unable to delete backing for %s", _tmp3_);
			_g_free0 (_tmp3_);
		}
		goto __finally59;
		__catch59_g_error:
		{
			GError * err;
			gchar* _tmp4_ = NULL;
			gchar* _tmp5_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp4_ = data_object_to_string (DATA_OBJECT (self));
			_tmp5_ = _tmp4_;
			g_warning ("DataSource.vala:375: Unable to delete backing for %s: %s", _tmp5_, err->message);
			_g_free0 (_tmp5_);
			ret = FALSE;
			_g_error_free0 (err);
		}
		__finally59:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
	}
	data_source_internal_mark_for_destroy (self);
	data_source_destroy (self);
	if (self->priv->unlinked_from_collection != NULL) {
		source_collection_notify_unlinked_destroyed (self->priv->unlinked_from_collection, self);
	}
	result = ret;
	return result;
}


static void _vala_array_add86 (DataView*** array, int* length, int* size, DataView* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (DataView*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


void data_source_internal_subscribe (DataSource* self, DataView* view) {
	DataView* _tmp3_;
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_return_if_fail (IS_DATA_VIEW (view));
	g_assert (!self->priv->in_contact);
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					ctr++;
				}
				_tmp0_ = FALSE;
				if (!(ctr < self->priv->subscribers_length1)) {
					break;
				}
				if (self->priv->subscribers[ctr] == NULL) {
					DataView* _tmp1_;
					DataView* _tmp2_;
					_tmp1_ = _g_object_ref0 (view);
					_tmp2_ = _tmp1_;
					_g_object_unref0 (self->priv->subscribers[ctr]);
					self->priv->subscribers[ctr] = _tmp2_;
					return;
				}
			}
		}
	}
	_tmp3_ = _g_object_ref0 (view);
	_vala_array_add86 (&self->priv->subscribers, &self->priv->subscribers_length1, &self->priv->_subscribers_size_, _tmp3_);
}


void data_source_internal_unsubscribe (DataSource* self, DataView* view) {
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_return_if_fail (IS_DATA_VIEW (view));
	g_assert (!self->priv->in_contact);
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					ctr++;
				}
				_tmp0_ = FALSE;
				if (!(ctr < self->priv->subscribers_length1)) {
					break;
				}
				if (self->priv->subscribers[ctr] == view) {
					DataView* _tmp1_;
					_tmp1_ = NULL;
					_g_object_unref0 (self->priv->subscribers[ctr]);
					self->priv->subscribers[ctr] = _tmp1_;
					return;
				}
			}
		}
	}
}


void data_source_contact_subscribers (DataSource* self, DataSourceContactSubscriber contact_subscriber, void* contact_subscriber_target) {
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_assert (!self->priv->in_contact);
	self->priv->in_contact = TRUE;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					ctr++;
				}
				_tmp0_ = FALSE;
				if (!(ctr < self->priv->subscribers_length1)) {
					break;
				}
				if (self->priv->subscribers[ctr] != NULL) {
					contact_subscriber (self->priv->subscribers[ctr], contact_subscriber_target);
				}
			}
		}
	}
	self->priv->in_contact = FALSE;
}


void data_source_contact_subscribers_alteration (DataSource* self, Alteration* alteration) {
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_return_if_fail (IS_ALTERATION (alteration));
	g_assert (!self->priv->in_contact);
	self->priv->in_contact = TRUE;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					ctr++;
				}
				_tmp0_ = FALSE;
				if (!(ctr < self->priv->subscribers_length1)) {
					break;
				}
				if (self->priv->subscribers[ctr] != NULL) {
					data_object_notify_altered (DATA_OBJECT (self->priv->subscribers[ctr]), alteration);
				}
			}
		}
	}
	self->priv->in_contact = FALSE;
}


static void data_source_real_unlinked (DataSource* self, SourceCollection* sources) {
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
}


static void g_cclosure_user_marshal_VOID__DATA_COLLECTION (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__DATA_COLLECTION) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__DATA_COLLECTION callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__DATA_COLLECTION) (marshal_data ? marshal_data : cc->callback);
	callback (data1, value_get_data_collection (param_values + 1), data2);
}


static void data_source_real_relinked (DataSource* self, SourceCollection* sources) {
	g_return_if_fail (IS_DATA_SOURCE (self));
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
}


static void data_source_real_destroyed (DataSource* self) {
	g_return_if_fail (IS_DATA_SOURCE (self));
}


static void data_source_class_init (DataSourceClass * klass) {
	data_source_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataSourcePrivate));
	DATA_OBJECT_CLASS (klass)->notify_membership_changed = data_source_real_notify_membership_changed;
	DATA_SOURCE_CLASS (klass)->notify_held_in_tank = data_source_real_notify_held_in_tank;
	DATA_OBJECT_CLASS (klass)->notify_altered = data_source_real_notify_altered;
	DATA_SOURCE_CLASS (klass)->notify_unlinking = data_source_real_notify_unlinking;
	DATA_SOURCE_CLASS (klass)->notify_unlinked = data_source_real_notify_unlinked;
	DATA_SOURCE_CLASS (klass)->notify_relinking = data_source_real_notify_relinking;
	DATA_SOURCE_CLASS (klass)->notify_relinked = data_source_real_notify_relinked;
	DATA_SOURCE_CLASS (klass)->get_typename = data_source_real_get_typename;
	DATA_SOURCE_CLASS (klass)->get_instance_id = data_source_real_get_instance_id;
	DATA_SOURCE_CLASS (klass)->get_source_id = data_source_real_get_source_id;
	DATA_SOURCE_CLASS (klass)->commit_backlinks = data_source_real_commit_backlinks;
	DATA_SOURCE_CLASS (klass)->save_snapshot = data_source_real_save_snapshot;
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = data_source_real_internal_delete_backing;
	DATA_SOURCE_CLASS (klass)->equals = data_source_real_equals;
	DATA_SOURCE_CLASS (klass)->destroy = data_source_real_destroy;
	DATA_SOURCE_CLASS (klass)->unlinked = data_source_real_unlinked;
	DATA_SOURCE_CLASS (klass)->relinked = data_source_real_relinked;
	DATA_SOURCE_CLASS (klass)->destroyed = data_source_real_destroyed;
	G_OBJECT_CLASS (klass)->finalize = data_source_finalize;
	g_signal_new ("unlinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, unlinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
	g_signal_new ("relinked", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, relinked), NULL, NULL, g_cclosure_user_marshal_VOID__DATA_COLLECTION, G_TYPE_NONE, 1, TYPE_SOURCE_COLLECTION);
	g_signal_new ("destroyed", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, destroyed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void data_source_instance_init (DataSource * self) {
	DataView** _tmp0_ = NULL;
	self->priv = DATA_SOURCE_GET_PRIVATE (self);
	_tmp0_ = g_new0 (DataView*, 4 + 1);
	self->priv->subscribers = _tmp0_;
	self->priv->subscribers_length1 = 4;
	self->priv->_subscribers_size_ = self->priv->subscribers_length1;
	self->priv->holding_tank = NULL;
	self->priv->unlinked_from_collection = NULL;
	self->priv->backlinks = NULL;
	self->priv->in_contact = FALSE;
	self->priv->marked_for_destroy = FALSE;
	self->priv->is_destroyed = FALSE;
}


static void data_source_finalize (GObject* obj) {
	DataSource * self;
	self = DATA_SOURCE (obj);
	self->priv->subscribers = (_vala_array_free (self->priv->subscribers, self->priv->subscribers_length1, (GDestroyNotify) g_object_unref), NULL);
	_source_holding_tank_unref0 (self->priv->holding_tank);
	_g_object_unref0 (self->priv->backlinks);
	G_OBJECT_CLASS (data_source_parent_class)->finalize (obj);
}


GType data_source_get_type (void) {
	static volatile gsize data_source_type_id__volatile = 0;
	if (g_once_init_enter (&data_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataSource), 0, (GInstanceInitFunc) data_source_instance_init, NULL };
		GType data_source_type_id;
		data_source_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_source_type_id__volatile, data_source_type_id);
	}
	return data_source_type_id__volatile;
}


static void source_snapshot_real_notify_broken (SourceSnapshot* self) {
	g_return_if_fail (IS_SOURCE_SNAPSHOT (self));
	self->priv->snapshot_broken = TRUE;
	g_signal_emit_by_name (self, "broken");
}


void source_snapshot_notify_broken (SourceSnapshot* self) {
	SOURCE_SNAPSHOT_GET_CLASS (self)->notify_broken (self);
}


gboolean source_snapshot_is_broken (SourceSnapshot* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_SOURCE_SNAPSHOT (self), FALSE);
	result = self->priv->snapshot_broken;
	return result;
}


SourceSnapshot* source_snapshot_construct (GType object_type) {
	SourceSnapshot* self = NULL;
	self = (SourceSnapshot*) g_type_create_instance (object_type);
	return self;
}


static void source_snapshot_real_broken (SourceSnapshot* self) {
	g_return_if_fail (IS_SOURCE_SNAPSHOT (self));
}


static void value_source_snapshot_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_snapshot_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_snapshot_unref (value->data[0].v_pointer);
	}
}


static void value_source_snapshot_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_snapshot_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_snapshot_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_snapshot_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceSnapshot* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_snapshot_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_snapshot_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceSnapshot** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_snapshot_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceSnapshot* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_SNAPSHOT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_snapshot (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_snapshot (GValue* value, gpointer v_object) {
	SourceSnapshot* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_snapshot_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_snapshot_unref (old);
	}
}


void value_take_source_snapshot (GValue* value, gpointer v_object) {
	SourceSnapshot* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_snapshot_unref (old);
	}
}


static void source_snapshot_class_init (SourceSnapshotClass * klass) {
	source_snapshot_parent_class = g_type_class_peek_parent (klass);
	SOURCE_SNAPSHOT_CLASS (klass)->finalize = source_snapshot_finalize;
	g_type_class_add_private (klass, sizeof (SourceSnapshotPrivate));
	SOURCE_SNAPSHOT_CLASS (klass)->notify_broken = source_snapshot_real_notify_broken;
	SOURCE_SNAPSHOT_CLASS (klass)->broken = source_snapshot_real_broken;
	g_signal_new ("broken", TYPE_SOURCE_SNAPSHOT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceSnapshotClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void source_snapshot_instance_init (SourceSnapshot * self) {
	self->priv = SOURCE_SNAPSHOT_GET_PRIVATE (self);
	self->priv->snapshot_broken = FALSE;
	self->ref_count = 1;
}


static void source_snapshot_finalize (SourceSnapshot* obj) {
	SourceSnapshot * self;
	self = SOURCE_SNAPSHOT (obj);
}


GType source_snapshot_get_type (void) {
	static volatile gsize source_snapshot_type_id__volatile = 0;
	if (g_once_init_enter (&source_snapshot_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_snapshot_init, value_source_snapshot_free_value, value_source_snapshot_copy_value, value_source_snapshot_peek_pointer, "p", value_source_snapshot_collect_value, "p", value_source_snapshot_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceSnapshotClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_snapshot_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceSnapshot), 0, (GInstanceInitFunc) source_snapshot_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_snapshot_type_id;
		source_snapshot_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceSnapshot", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_snapshot_type_id__volatile, source_snapshot_type_id);
	}
	return source_snapshot_type_id__volatile;
}


gpointer source_snapshot_ref (gpointer instance) {
	SourceSnapshot* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_snapshot_unref (gpointer instance) {
	SourceSnapshot* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_SNAPSHOT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}


SourceBacklink* source_backlink_construct (GType object_type, const gchar* name, const gchar* value) {
	SourceBacklink* self = NULL;
	gboolean _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (value != NULL, NULL);
	self = (SourceBacklink*) g_type_create_instance (object_type);
	_tmp0_ = source_backlink_validate_name_value (name, value);
	g_assert (_tmp0_);
	_tmp1_ = string_strip (name);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
	_tmp2_ = string_strip (value);
	_g_free0 (self->priv->_value);
	self->priv->_value = _tmp2_;
	return self;
}


SourceBacklink* source_backlink_new (const gchar* name, const gchar* value) {
	return source_backlink_construct (TYPE_SOURCE_BACKLINK, name, value);
}


SourceBacklink* source_backlink_construct_from_source (GType object_type, DataSource* source) {
	SourceBacklink* self = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gint64 _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_;
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
	self = (SourceBacklink*) g_type_create_instance (object_type);
	_tmp0_ = data_source_get_typename (source);
	_tmp1_ = _tmp0_;
	_tmp2_ = string_strip (_tmp1_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp2_;
	_g_free0 (_tmp1_);
	_tmp3_ = data_source_get_instance_id (source);
	_tmp4_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = string_strip (_tmp5_);
	_g_free0 (self->priv->_value);
	self->priv->_value = _tmp6_;
	_g_free0 (_tmp5_);
	_tmp7_ = source_backlink_validate_name_value (self->priv->_name, self->priv->_value);
	g_assert (_tmp7_);
	return self;
}


SourceBacklink* source_backlink_new_from_source (DataSource* source) {
	return source_backlink_construct_from_source (TYPE_SOURCE_BACKLINK, source);
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


static gboolean source_backlink_validate_name_value (const gchar* name, const gchar* value) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	g_return_val_if_fail (name != NULL, FALSE);
	g_return_val_if_fail (value != NULL, FALSE);
	_tmp2_ = string_contains (name, "=");
	if (!_tmp2_) {
		gboolean _tmp3_;
		_tmp3_ = string_contains (name, "|");
		_tmp1_ = !_tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp4_;
		_tmp4_ = string_contains (value, "|");
		_tmp0_ = !_tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gchar* source_backlink_to_string (SourceBacklink* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
	_tmp0_ = source_backlink_get_name (self);
	_tmp1_ = source_backlink_get_value (self);
	_tmp2_ = g_strdup_printf ("Backlink %s=%s", _tmp0_, _tmp1_);
	result = _tmp2_;
	return result;
}


guint source_backlink_hash_func (void* key) {
	guint result = 0U;
	SourceBacklink* backlink;
	guint _tmp0_;
	guint _tmp1_;
	backlink = (SourceBacklink*) key;
	_tmp0_ = g_str_hash (SOURCE_BACKLINK (backlink)->priv->_name);
	_tmp1_ = g_str_hash (SOURCE_BACKLINK (backlink)->priv->_value);
	result = _tmp0_ ^ _tmp1_;
	return result;
}


gboolean source_backlink_equal_func (void* a, void* b) {
	gboolean result = FALSE;
	SourceBacklink* alink;
	SourceBacklink* blink;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	alink = (SourceBacklink*) a;
	blink = (SourceBacklink*) b;
	_tmp1_ = g_str_equal (SOURCE_BACKLINK (alink)->priv->_name, SOURCE_BACKLINK (blink)->priv->_name);
	if (_tmp1_) {
		gboolean _tmp2_;
		_tmp2_ = g_str_equal (SOURCE_BACKLINK (alink)->priv->_value, SOURCE_BACKLINK (blink)->priv->_value);
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


const gchar* source_backlink_get_name (SourceBacklink* self) {
	const gchar* result;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
	result = self->priv->_name;
	return result;
}


const gchar* source_backlink_get_value (SourceBacklink* self) {
	const gchar* result;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
	result = self->priv->_value;
	return result;
}


const gchar* source_backlink_get_typename (SourceBacklink* self) {
	const gchar* result;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), NULL);
	result = self->priv->_name;
	return result;
}


static gint64 int64_parse (const gchar* str) {
	gint64 result = 0LL;
	gint64 _tmp0_;
	g_return_val_if_fail (str != NULL, 0LL);
	_tmp0_ = g_ascii_strtoll (str, NULL, (guint) 0);
	result = _tmp0_;
	return result;
}


gint64 source_backlink_get_instance_id (SourceBacklink* self) {
	gint64 result;
	gint64 _tmp0_;
	g_return_val_if_fail (IS_SOURCE_BACKLINK (self), 0LL);
	_tmp0_ = int64_parse (self->priv->_value);
	result = _tmp0_;
	return result;
}


static void value_source_backlink_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_backlink_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_backlink_unref (value->data[0].v_pointer);
	}
}


static void value_source_backlink_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_backlink_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_backlink_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_backlink_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceBacklink* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_backlink_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_backlink_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceBacklink** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_backlink_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceBacklink* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_BACKLINK), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_backlink (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_backlink (GValue* value, gpointer v_object) {
	SourceBacklink* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_backlink_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_backlink_unref (old);
	}
}


void value_take_source_backlink (GValue* value, gpointer v_object) {
	SourceBacklink* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_BACKLINK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_BACKLINK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_backlink_unref (old);
	}
}


static void source_backlink_class_init (SourceBacklinkClass * klass) {
	source_backlink_parent_class = g_type_class_peek_parent (klass);
	SOURCE_BACKLINK_CLASS (klass)->finalize = source_backlink_finalize;
	g_type_class_add_private (klass, sizeof (SourceBacklinkPrivate));
}


static void source_backlink_instance_init (SourceBacklink * self) {
	self->priv = SOURCE_BACKLINK_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void source_backlink_finalize (SourceBacklink* obj) {
	SourceBacklink * self;
	self = SOURCE_BACKLINK (obj);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_value);
}


GType source_backlink_get_type (void) {
	static volatile gsize source_backlink_type_id__volatile = 0;
	if (g_once_init_enter (&source_backlink_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_backlink_init, value_source_backlink_free_value, value_source_backlink_copy_value, value_source_backlink_peek_pointer, "p", value_source_backlink_collect_value, "p", value_source_backlink_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceBacklinkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_backlink_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceBacklink), 0, (GInstanceInitFunc) source_backlink_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_backlink_type_id;
		source_backlink_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceBacklink", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&source_backlink_type_id__volatile, source_backlink_type_id);
	}
	return source_backlink_type_id__volatile;
}


gpointer source_backlink_ref (gpointer instance) {
	SourceBacklink* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_backlink_unref (gpointer instance) {
	SourceBacklink* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_BACKLINK_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _source_proxy_on_source_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
	source_proxy_on_source_added (self, added);
}


static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender, gpointer self) {
	source_proxy_on_snapshot_broken (self);
}


SourceProxy* source_proxy_construct (GType object_type, DataSource* source) {
	SourceProxy* self = NULL;
	gint64 _tmp0_;
	gchar* _tmp1_ = NULL;
	SourceSnapshot* _tmp2_ = NULL;
	DataCollection* _tmp3_ = NULL;
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
	self = (SourceProxy*) g_type_create_instance (object_type);
	_tmp0_ = data_object_get_object_id (DATA_OBJECT (source));
	self->priv->object_id = _tmp0_;
	_tmp1_ = data_object_to_string (DATA_OBJECT (source));
	_g_free0 (self->priv->source_string);
	self->priv->source_string = _tmp1_;
	_tmp2_ = data_source_save_snapshot (source);
	_source_snapshot_unref0 (self->priv->snapshot);
	self->priv->snapshot = _tmp2_;
	g_assert (self->priv->snapshot != NULL);
	g_signal_connect (self->priv->snapshot, "broken", (GCallback) _source_proxy_on_snapshot_broken_source_snapshot_broken, self);
	source_proxy_set_source (self, source);
	_tmp3_ = data_object_get_membership (DATA_OBJECT (source));
	_data_collection_unref0 (self->priv->membership);
	self->priv->membership = SOURCE_COLLECTION (_tmp3_);
	g_assert (self->priv->membership != NULL);
	g_signal_connect (DATA_COLLECTION (self->priv->membership), "items-added", (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
	return self;
}


static DataSource* source_proxy_real_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot) {
	g_return_val_if_fail (IS_SOURCE_PROXY (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `source_proxy_reconstitute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


DataSource* source_proxy_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot) {
	return SOURCE_PROXY_GET_CLASS (self)->reconstitute (self, object_id, snapshot);
}


static void source_proxy_real_notify_reconstituted (SourceProxy* self, DataSource* source) {
	g_return_if_fail (IS_SOURCE_PROXY (self));
	g_return_if_fail (IS_DATA_SOURCE (source));
	g_signal_emit_by_name (self, "reconstituted", source);
}


void source_proxy_notify_reconstituted (SourceProxy* self, DataSource* source) {
	SOURCE_PROXY_GET_CLASS (self)->notify_reconstituted (self, source);
}


static void source_proxy_real_notify_dehydrated (SourceProxy* self) {
	g_return_if_fail (IS_SOURCE_PROXY (self));
	g_signal_emit_by_name (self, "dehydrated");
}


void source_proxy_notify_dehydrated (SourceProxy* self) {
	SOURCE_PROXY_GET_CLASS (self)->notify_dehydrated (self);
}


static void source_proxy_real_notify_broken (SourceProxy* self) {
	g_return_if_fail (IS_SOURCE_PROXY (self));
	g_signal_emit_by_name (self, "broken");
}


void source_proxy_notify_broken (SourceProxy* self) {
	SOURCE_PROXY_GET_CLASS (self)->notify_broken (self);
}


static void source_proxy_on_snapshot_broken (SourceProxy* self) {
	g_return_if_fail (IS_SOURCE_PROXY (self));
	source_proxy_drop_source (self);
	source_proxy_notify_broken (self);
}


static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender, gpointer self) {
	source_proxy_on_destroyed (self);
}


static void source_proxy_set_source (SourceProxy* self, DataSource* source) {
	DataSource* _tmp0_;
	g_return_if_fail (IS_SOURCE_PROXY (self));
	g_return_if_fail (IS_DATA_SOURCE (source));
	source_proxy_drop_source (self);
	_tmp0_ = _g_object_ref0 (source);
	_g_object_unref0 (self->priv->source);
	self->priv->source = _tmp0_;
	g_signal_connect (source, "destroyed", (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
}


static void source_proxy_drop_source (SourceProxy* self) {
	guint _tmp0_;
	g_return_if_fail (IS_SOURCE_PROXY (self));
	if (self->priv->source == NULL) {
		return;
	}
	g_signal_parse_name ("destroyed", TYPE_DATA_SOURCE, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (self->priv->source, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
	_g_object_unref0 (self->priv->source);
	self->priv->source = NULL;
}


DataSource* source_proxy_get_source (SourceProxy* self) {
	DataSource* result = NULL;
	gboolean _tmp0_;
	DataSource* _tmp2_ = NULL;
	DataSource* new_source;
	gint64 _tmp4_;
	gint64 _tmp6_;
	gboolean _tmp7_;
	DataSource* _tmp8_;
	g_return_val_if_fail (IS_SOURCE_PROXY (self), NULL);
	_tmp0_ = source_snapshot_is_broken (self->priv->snapshot);
	if (_tmp0_) {
		result = NULL;
		return result;
	}
	if (self->priv->source != NULL) {
		DataSource* _tmp1_;
		_tmp1_ = _g_object_ref0 (self->priv->source);
		result = _tmp1_;
		return result;
	}
	_tmp2_ = source_proxy_reconstitute (self, self->priv->object_id, self->priv->snapshot);
	new_source = _tmp2_;
	if (self->priv->source != new_source) {
		DataSource* _tmp3_;
		_tmp3_ = _g_object_ref0 (new_source);
		_g_object_unref0 (self->priv->source);
		self->priv->source = _tmp3_;
	}
	_tmp4_ = data_object_get_object_id (DATA_OBJECT (self->priv->source));
	if (self->priv->object_id != _tmp4_) {
		gint64 _tmp5_;
		_tmp5_ = data_object_get_object_id (DATA_OBJECT (new_source));
		self->priv->object_id = _tmp5_;
	}
	_tmp6_ = data_object_get_object_id (DATA_OBJECT (self->priv->source));
	g_assert (_tmp6_ == self->priv->object_id);
	_tmp7_ = data_collection_contains (DATA_COLLECTION (self->priv->membership), DATA_OBJECT (self->priv->source));
	g_assert (_tmp7_);
	_tmp8_ = _g_object_ref0 (self->priv->source);
	result = _tmp8_;
	_g_object_unref0 (new_source);
	return result;
}


static void source_proxy_on_destroyed (SourceProxy* self) {
	g_return_if_fail (IS_SOURCE_PROXY (self));
	g_assert (self->priv->source != NULL);
	source_proxy_drop_source (self);
	source_proxy_notify_dehydrated (self);
}


static void source_proxy_on_source_added (SourceProxy* self, GeeIterable* added) {
	g_return_if_fail (IS_SOURCE_PROXY (self));
	g_return_if_fail (GEE_IS_ITERABLE (added));
	if (self->priv->source != NULL) {
		return;
	}
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _object_it;
		_tmp0_ = gee_iterable_iterator (added);
		_object_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			DataObject* object;
			gint64 _tmp3_;
			_tmp1_ = gee_iterator_next (_object_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp2_;
			_tmp3_ = data_object_get_object_id (object);
			if (_tmp3_ != self->priv->object_id) {
				_g_object_unref0 (object);
				continue;
			}
			source_proxy_set_source (self, DATA_SOURCE (object));
			source_proxy_notify_reconstituted (self, DATA_SOURCE (object));
			_g_object_unref0 (object);
			break;
		}
		_g_object_unref0 (_object_it);
	}
}


static void source_proxy_real_reconstituted (SourceProxy* self, DataSource* source) {
	g_return_if_fail (IS_SOURCE_PROXY (self));
	g_return_if_fail (IS_DATA_SOURCE (source));
}


static void source_proxy_real_dehydrated (SourceProxy* self) {
	g_return_if_fail (IS_SOURCE_PROXY (self));
}


static void source_proxy_real_broken (SourceProxy* self) {
	g_return_if_fail (IS_SOURCE_PROXY (self));
}


static void value_source_proxy_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_proxy_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_proxy_unref (value->data[0].v_pointer);
	}
}


static void value_source_proxy_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_proxy_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_proxy_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_proxy_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceProxy* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_proxy_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_proxy_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceProxy** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_proxy_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_proxy (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceProxy* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_PROXY), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_proxy (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_proxy (GValue* value, gpointer v_object) {
	SourceProxy* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_proxy_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_proxy_unref (old);
	}
}


void value_take_source_proxy (GValue* value, gpointer v_object) {
	SourceProxy* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_proxy_unref (old);
	}
}


static void source_proxy_class_init (SourceProxyClass * klass) {
	source_proxy_parent_class = g_type_class_peek_parent (klass);
	SOURCE_PROXY_CLASS (klass)->finalize = source_proxy_finalize;
	g_type_class_add_private (klass, sizeof (SourceProxyPrivate));
	SOURCE_PROXY_CLASS (klass)->reconstitute = source_proxy_real_reconstitute;
	SOURCE_PROXY_CLASS (klass)->notify_reconstituted = source_proxy_real_notify_reconstituted;
	SOURCE_PROXY_CLASS (klass)->notify_dehydrated = source_proxy_real_notify_dehydrated;
	SOURCE_PROXY_CLASS (klass)->notify_broken = source_proxy_real_notify_broken;
	SOURCE_PROXY_CLASS (klass)->reconstituted = source_proxy_real_reconstituted;
	SOURCE_PROXY_CLASS (klass)->dehydrated = source_proxy_real_dehydrated;
	SOURCE_PROXY_CLASS (klass)->broken = source_proxy_real_broken;
	g_signal_new ("reconstituted", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, reconstituted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
	g_signal_new ("dehydrated", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, dehydrated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("broken", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void source_proxy_instance_init (SourceProxy * self) {
	self->priv = SOURCE_PROXY_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void source_proxy_finalize (SourceProxy* obj) {
	SourceProxy * self;
	guint _tmp0_;
	self = SOURCE_PROXY (obj);
	source_proxy_drop_source (self);
	g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->membership), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
	_g_free0 (self->priv->source_string);
	_g_object_unref0 (self->priv->source);
	_source_snapshot_unref0 (self->priv->snapshot);
	_data_collection_unref0 (self->priv->membership);
}


GType source_proxy_get_type (void) {
	static volatile gsize source_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&source_proxy_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_proxy_init, value_source_proxy_free_value, value_source_proxy_copy_value, value_source_proxy_peek_pointer, "p", value_source_proxy_collect_value, "p", value_source_proxy_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceProxyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_proxy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceProxy), 0, (GInstanceInitFunc) source_proxy_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_proxy_type_id;
		source_proxy_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceProxy", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_proxy_type_id__volatile, source_proxy_type_id);
	}
	return source_proxy_type_id__volatile;
}


gpointer source_proxy_ref (gpointer instance) {
	SourceProxy* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_proxy_unref (gpointer instance) {
	SourceProxy* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_PROXY_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


SourceProxy* proxyable_get_proxy (Proxyable* self) {
	return PROXYABLE_GET_INTERFACE (self)->get_proxy (self);
}


static void proxyable_base_init (ProxyableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType proxyable_get_type (void) {
	static volatile gsize proxyable_type_id__volatile = 0;
	if (g_once_init_enter (&proxyable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ProxyableIface), (GBaseInitFunc) proxyable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType proxyable_type_id;
		proxyable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Proxyable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (proxyable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&proxyable_type_id__volatile, proxyable_type_id);
	}
	return proxyable_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



