/* DatabaseTable.c generated by valac 0.12.1, the Vala compiler
 * generated from DatabaseTable.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
typedef struct _ParamSpecDatabaseTable ParamSpecDatabaseTable;

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _ParamSpecDatabaseTable {
	GParamSpec parent_instance;
};


static gpointer database_table_parent_class = NULL;
extern sqlite3* database_table_db;
sqlite3* database_table_db = NULL;
static gint database_table_in_transaction;
static gint database_table_in_transaction = 0;

GQuark database_error_quark (void);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
enum  {
	DATABASE_TABLE_DUMMY_PROPERTY
};
#define DATABASE_TABLE_SCHEMA_VERSION 14
static void database_table_prepare_db (const gchar* filename);
void app_window_panic (const gchar* msg);
#define DB_IN_MEMORY_NAME ":memory:"
void database_table_init (const gchar* filename);
void database_table_warning (const gchar* op, gint res);
void database_table_terminate (void);
void database_table_fatal (const gchar* op, gint res);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
void database_table_throw_error (const gchar* method, gint res, GError** error);
gboolean database_table_exists_by_id (DatabaseTable* self, gint64 id);
gboolean database_table_select_by_id (DatabaseTable* self, gint64 id, const gchar* columns, sqlite3_stmt** stmt);
static void database_table_prepare_update_by_id (DatabaseTable* self, gint64 id, const gchar* column, sqlite3_stmt** stmt);
static gboolean database_table_execute_update_by_id (DatabaseTable* self, sqlite3_stmt* stmt);
gboolean database_table_update_text_by_id (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
gboolean database_table_update_int_by_id (DatabaseTable* self, gint64 id, const gchar* column, gint value);
void database_table_update_int_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint value, GError** error);
gboolean database_table_update_int64_by_id (DatabaseTable* self, gint64 id, const gchar* column, gint64 value);
void database_table_update_int64_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint64 value, GError** error);
void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error);
gboolean database_table_has_column (const gchar* table_name, const gchar* column_name);
gboolean database_table_has_table (const gchar* table_name);
gboolean database_table_add_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints);
gboolean database_table_ensure_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints, const gchar* upgrade_msg);
gint database_table_get_row_count (DatabaseTable* self);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
DatabaseTable* database_table_construct (GType object_type);
static void database_table_finalize (DatabaseTable* obj);


GQuark database_error_quark (void) {
	return g_quark_from_static_string ("database_error-quark");
}


static void database_table_prepare_db (const gchar* filename) {
	sqlite3* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	GError * _inner_error_ = NULL;
	g_return_if_fail (filename != NULL);
	_tmp1_ = sqlite3_open_v2 (filename, &_tmp0_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
	_sqlite3_close0 (database_table_db);
	database_table_db = _tmp0_;
	res = _tmp1_;
	if (res != SQLITE_OK) {
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp2_ = _ ("Unable to open/create photo database %s: error code %d");
		_tmp3_ = g_strdup_printf (_tmp2_, filename, res);
		_tmp4_ = _tmp3_;
		app_window_panic (_tmp4_);
		_g_free0 (_tmp4_);
	}
	if (g_strcmp0 (filename, DB_IN_MEMORY_NAME) != 0) {
		GFile* _tmp5_ = NULL;
		GFile* file_db;
		GFileInfo* _tmp6_ = NULL;
		GFileInfo* info;
		gboolean _tmp7_;
		_tmp5_ = g_file_new_for_path (filename);
		file_db = _tmp5_;
		_tmp6_ = g_file_query_info (file_db, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
		info = _tmp6_;
		if (_inner_error_ != NULL) {
			_g_object_unref0 (file_db);
			goto __catch12_g_error;
		}
		_tmp7_ = g_file_info_get_attribute_boolean (info, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
		if (!_tmp7_) {
			const gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			gchar* _tmp10_;
			_tmp8_ = _ ("Unable to write to photo database file:\n %s");
			_tmp9_ = g_strdup_printf (_tmp8_, filename);
			_tmp10_ = _tmp9_;
			app_window_panic (_tmp10_);
			_g_free0 (_tmp10_);
		}
		_g_object_unref0 (info);
		_g_object_unref0 (file_db);
		goto __finally12;
		__catch12_g_error:
		{
			GError * e;
			const gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			gchar* _tmp13_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp11_ = _ ("Error accessing database file:\n %s\n\nError was: \n%s");
			_tmp12_ = g_strdup_printf (_tmp11_, filename, e->message);
			_tmp13_ = _tmp12_;
			app_window_panic (_tmp13_);
			_g_free0 (_tmp13_);
			_g_error_free0 (e);
		}
		__finally12:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static gint _sqlite3_exec (sqlite3* self, const gchar* sql, sqlite3_callback sqlite3_callback, void* sqlite3_callback_target, gchar** errmsg) {
	gchar* _errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	gint ec;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (sql != NULL, 0);
	_tmp1_ = sqlite3_exec (self, sql, sqlite3_callback, sqlite3_callback_target, (char**) (&_tmp0_));
	sqlite_errmsg = _tmp0_;
	ec = _tmp1_;
	if ((&_errmsg) != NULL) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (sqlite_errmsg);
		_g_free0 (_errmsg);
		_errmsg = _tmp2_;
	}
	sqlite3_free ((void*) sqlite_errmsg);
	result = ec;
	if (errmsg) {
		*errmsg = _errmsg;
	} else {
		_g_free0 (_errmsg);
	}
	return result;
}


void database_table_init (const gchar* filename) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp9_;
	g_return_if_fail (filename != NULL);
	database_table_prepare_db (filename);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "CREATE TABLE IF NOT EXISTS VersionTable (" "id INTEGER PRIMARY KEY, " "schema_version INTEGER, " "app_version TEXT, " "user_data TEXT NULL" ")", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	if (res != SQLITE_OK) {
		gchar* _tmp2_;
		gchar* backup_path;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* cmdline;
		_sqlite3_close0 (database_table_db);
		database_table_db = NULL;
		_tmp2_ = g_strconcat (filename, ".bak", NULL);
		backup_path = _tmp2_;
		_tmp3_ = g_strconcat ("cp ", backup_path, NULL);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strconcat (_tmp4_, " ", NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strconcat (_tmp6_, filename, NULL);
		_tmp8_ = _tmp7_;
		_g_free0 (_tmp6_);
		_g_free0 (_tmp4_);
		cmdline = _tmp8_;
		system (cmdline);
		database_table_prepare_db (filename);
		_g_free0 (cmdline);
		_g_free0 (backup_path);
	}
	_tmp9_ = _sqlite3_exec (database_table_db, "PRAGMA synchronous=OFF", NULL, NULL, NULL);
	res = _tmp9_;
	if (res != SQLITE_OK) {
		database_table_warning ("Unable to disable synchronous mode", res);
	}
	_sqlite3_finalize0 (stmt);
}


void database_table_terminate (void) {
	_sqlite3_close0 (database_table_db);
	database_table_db = NULL;
}


void database_table_fatal (const gchar* op, gint res) {
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (op != NULL);
	_tmp0_ = sqlite3_errmsg (database_table_db);
	g_error ("DatabaseTable.vala:92: %s: [%d] %s", op, res, _tmp0_);
}


void database_table_warning (const gchar* op, gint res) {
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (op != NULL);
	_tmp0_ = sqlite3_errmsg (database_table_db);
	g_warning ("DatabaseTable.vala:97: %s: [%d] %s", op, res, _tmp0_);
}


void database_table_set_table_name (DatabaseTable* self, const gchar* table_name) {
	gchar* _tmp0_;
	g_return_if_fail (IS_DATABASE_TABLE (self));
	g_return_if_fail (table_name != NULL);
	_tmp0_ = g_strdup (table_name);
	_g_free0 (self->table_name);
	self->table_name = _tmp0_;
}


void database_table_throw_error (const gchar* method, gint res, GError** error) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* msg;
	GError * _inner_error_ = NULL;
	g_return_if_fail (method != NULL);
	_tmp0_ = sqlite3_errmsg (database_table_db);
	_tmp1_ = g_strdup_printf ("(%s) [%d] - %s", method, res, _tmp0_);
	msg = _tmp1_;
	switch (res) {
		case SQLITE_OK:
		case SQLITE_DONE:
		case SQLITE_ROW:
		{
			_g_free0 (msg);
			return;
		}
		case SQLITE_PERM:
		case SQLITE_BUSY:
		case SQLITE_READONLY:
		case SQLITE_IOERR:
		case SQLITE_CORRUPT:
		case SQLITE_CANTOPEN:
		case SQLITE_NOLFS:
		case SQLITE_AUTH:
		case SQLITE_FORMAT:
		case SQLITE_NOTADB:
		{
			GError* _tmp2_ = NULL;
			_tmp2_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_BACKING, msg);
			_inner_error_ = _tmp2_;
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		case SQLITE_NOMEM:
		{
			GError* _tmp3_ = NULL;
			_tmp3_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_MEMORY, msg);
			_inner_error_ = _tmp3_;
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		case SQLITE_ABORT:
		case SQLITE_LOCKED:
		case SQLITE_INTERRUPT:
		{
			GError* _tmp4_ = NULL;
			_tmp4_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ABORT, msg);
			_inner_error_ = _tmp4_;
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		case SQLITE_FULL:
		case SQLITE_EMPTY:
		case SQLITE_TOOBIG:
		case SQLITE_CONSTRAINT:
		case SQLITE_RANGE:
		{
			GError* _tmp5_ = NULL;
			_tmp5_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_LIMITS, msg);
			_inner_error_ = _tmp5_;
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		case SQLITE_SCHEMA:
		case SQLITE_MISMATCH:
		{
			GError* _tmp6_ = NULL;
			_tmp6_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_TYPESPEC, msg);
			_inner_error_ = _tmp6_;
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		default:
		case SQLITE_ERROR:
		case SQLITE_INTERNAL:
		case SQLITE_MISUSE:
		{
			GError* _tmp7_ = NULL;
			_tmp7_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ERROR, msg);
			_inner_error_ = _tmp7_;
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (msg);
				return;
			} else {
				_g_free0 (msg);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_g_free0 (msg);
}


gboolean database_table_exists_by_id (DatabaseTable* self, gint64 id) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	gint res;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_ = FALSE;
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
	_tmp0_ = g_strdup_printf ("SELECT id FROM %s WHERE id=?", self->table_name);
	_tmp1_ = _tmp0_;
	_tmp3_ = sqlite3_prepare_v2 (database_table_db, _tmp1_, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp1_);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_bind_int64 (stmt, 1, id);
	res = _tmp5_;
	g_assert (res == SQLITE_OK);
	_tmp6_ = sqlite3_step (stmt);
	res = _tmp6_;
	if (res != SQLITE_ROW) {
		_tmp7_ = res != SQLITE_DONE;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_;
		_tmp8_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strdup_printf ("exists_by_id [%s] %s", _tmp9_, self->table_name);
		_tmp11_ = _tmp10_;
		database_table_fatal (_tmp11_, res);
		_g_free0 (_tmp11_);
		_g_free0 (_tmp9_);
	}
	result = res == SQLITE_ROW;
	_sqlite3_finalize0 (stmt);
	return result;
}


gboolean database_table_select_by_id (DatabaseTable* self, gint64 id, const gchar* columns, sqlite3_stmt** stmt) {
	sqlite3_stmt* _stmt = NULL;
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* sql;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint res;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_ = FALSE;
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
	g_return_val_if_fail (columns != NULL, FALSE);
	_tmp0_ = g_strdup_printf ("SELECT %s FROM %s WHERE id=?", columns, self->table_name);
	sql = _tmp0_;
	_tmp2_ = sqlite3_prepare_v2 (database_table_db, sql, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (_stmt);
	_stmt = _tmp1_;
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = sqlite3_bind_int64 (_stmt, 1, id);
	res = _tmp3_;
	g_assert (res == SQLITE_OK);
	_tmp4_ = sqlite3_step (_stmt);
	res = _tmp4_;
	if (res != SQLITE_ROW) {
		_tmp5_ = res != SQLITE_DONE;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strdup_printf ("select_by_id [%s] %s %s", _tmp7_, self->table_name, columns);
		_tmp9_ = _tmp8_;
		database_table_fatal (_tmp9_, res);
		_g_free0 (_tmp9_);
		_g_free0 (_tmp7_);
	}
	result = res == SQLITE_ROW;
	_g_free0 (sql);
	if (stmt) {
		*stmt = _stmt;
	} else {
		_sqlite3_finalize0 (_stmt);
	}
	return result;
}


static void database_table_prepare_update_by_id (DatabaseTable* self, gint64 id, const gchar* column, sqlite3_stmt** stmt) {
	sqlite3_stmt* _stmt = NULL;
	gchar* _tmp0_ = NULL;
	gchar* sql;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	gint res;
	gint _tmp3_;
	g_return_if_fail (IS_DATABASE_TABLE (self));
	g_return_if_fail (column != NULL);
	_tmp0_ = g_strdup_printf ("UPDATE %s SET %s=? WHERE id=?", self->table_name, column);
	sql = _tmp0_;
	_tmp2_ = sqlite3_prepare_v2 (database_table_db, sql, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (_stmt);
	_stmt = _tmp1_;
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = sqlite3_bind_int64 (_stmt, 2, id);
	res = _tmp3_;
	g_assert (res == SQLITE_OK);
	_g_free0 (sql);
	if (stmt) {
		*stmt = _stmt;
	} else {
		_sqlite3_finalize0 (_stmt);
	}
}


static gboolean database_table_execute_update_by_id (DatabaseTable* self, sqlite3_stmt* stmt) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint res;
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
	g_return_val_if_fail (stmt != NULL, FALSE);
	_tmp0_ = sqlite3_step (stmt);
	res = _tmp0_;
	if (res != SQLITE_DONE) {
		database_table_fatal ("execute_update_by_id", res);
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


gboolean database_table_update_text_by_id (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gchar* _tmp1_;
	gint _tmp2_;
	gint res;
	gboolean _tmp3_;
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
	g_return_val_if_fail (column != NULL, FALSE);
	g_return_val_if_fail (text != NULL, FALSE);
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	_tmp1_ = g_strdup (text);
	_tmp2_ = sqlite3_bind_text (stmt, 1, _tmp1_, -1, g_free);
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = database_table_execute_update_by_id (self, stmt);
	result = _tmp3_;
	_sqlite3_finalize0 (stmt);
	return result;
}


void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gchar* _tmp1_;
	gint _tmp2_;
	gint res;
	gint _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_DATABASE_TABLE (self));
	g_return_if_fail (column != NULL);
	g_return_if_fail (text != NULL);
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	_tmp1_ = g_strdup (text);
	_tmp2_ = sqlite3_bind_text (stmt, 1, _tmp1_, -1, g_free);
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = sqlite3_step (stmt);
	res = _tmp3_;
	if (res != SQLITE_DONE) {
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		_tmp4_ = g_strdup_printf ("DatabaseTable.update_text_by_id_2 %s.%s", self->table_name, column);
		_tmp5_ = _tmp4_;
		database_table_throw_error (_tmp5_, res, &_inner_error_);
		_g_free0 (_tmp5_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_sqlite3_finalize0 (stmt);
}


gboolean database_table_update_int_by_id (DatabaseTable* self, gint64 id, const gchar* column, gint value) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gboolean _tmp2_;
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
	g_return_val_if_fail (column != NULL, FALSE);
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	_tmp1_ = sqlite3_bind_int (stmt, 1, value);
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = database_table_execute_update_by_id (self, stmt);
	result = _tmp2_;
	_sqlite3_finalize0 (stmt);
	return result;
}


void database_table_update_int_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint value, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_DATABASE_TABLE (self));
	g_return_if_fail (column != NULL);
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	_tmp1_ = sqlite3_bind_int (stmt, 1, value);
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_step (stmt);
	res = _tmp2_;
	if (res != SQLITE_DONE) {
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp3_ = g_strdup_printf ("DatabaseTable.update_int_by_id_2 %s.%s", self->table_name, column);
		_tmp4_ = _tmp3_;
		database_table_throw_error (_tmp4_, res, &_inner_error_);
		_g_free0 (_tmp4_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_sqlite3_finalize0 (stmt);
}


gboolean database_table_update_int64_by_id (DatabaseTable* self, gint64 id, const gchar* column, gint64 value) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gboolean _tmp2_;
	g_return_val_if_fail (IS_DATABASE_TABLE (self), FALSE);
	g_return_val_if_fail (column != NULL, FALSE);
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	_tmp1_ = sqlite3_bind_int64 (stmt, 1, value);
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = database_table_execute_update_by_id (self, stmt);
	result = _tmp2_;
	_sqlite3_finalize0 (stmt);
	return result;
}


void database_table_update_int64_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint64 value, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_DATABASE_TABLE (self));
	g_return_if_fail (column != NULL);
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	_tmp1_ = sqlite3_bind_int64 (stmt, 1, value);
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_step (stmt);
	res = _tmp2_;
	if (res != SQLITE_DONE) {
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp3_ = g_strdup_printf ("DatabaseTable.update_int64_by_id_2 %s.%s", self->table_name, column);
		_tmp4_ = _tmp3_;
		database_table_throw_error (_tmp4_, res, &_inner_error_);
		_g_free0 (_tmp4_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_sqlite3_finalize0 (stmt);
}


void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error) {
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	gint res;
	gint _tmp5_;
	gint _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_DATABASE_TABLE (self));
	_tmp0_ = g_strdup_printf ("DELETE FROM %s WHERE id=?", self->table_name);
	_tmp1_ = _tmp0_;
	_tmp3_ = sqlite3_prepare_v2 (database_table_db, _tmp1_, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp1_);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_bind_int64 (stmt, 1, id);
	res = _tmp5_;
	g_assert (res == SQLITE_OK);
	_tmp6_ = sqlite3_step (stmt);
	res = _tmp6_;
	if (res != SQLITE_DONE) {
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		_tmp7_ = g_strdup_printf ("%s.remove", self->table_name);
		_tmp8_ = _tmp7_;
		database_table_throw_error (_tmp8_, res, &_inner_error_);
		_g_free0 (_tmp8_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_sqlite3_finalize0 (stmt);
}


gboolean database_table_has_column (const gchar* table_name, const gchar* column_name) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	gint res;
	g_return_val_if_fail (table_name != NULL, FALSE);
	g_return_val_if_fail (column_name != NULL, FALSE);
	_tmp0_ = g_strdup_printf ("PRAGMA table_info(%s)", table_name);
	_tmp1_ = _tmp0_;
	_tmp3_ = sqlite3_prepare_v2 (database_table_db, _tmp1_, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp1_);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	{
		gboolean _tmp5_;
		_tmp5_ = TRUE;
		while (TRUE) {
			gint _tmp6_;
			if (!_tmp5_) {
			}
			_tmp5_ = FALSE;
			_tmp6_ = sqlite3_step (stmt);
			res = _tmp6_;
			if (res == SQLITE_DONE) {
				break;
			} else {
				if (res != SQLITE_ROW) {
					gchar* _tmp7_ = NULL;
					gchar* _tmp8_;
					_tmp7_ = g_strdup_printf ("has_column %s", table_name);
					_tmp8_ = _tmp7_;
					database_table_fatal (_tmp8_, res);
					_g_free0 (_tmp8_);
					break;
				} else {
					const gchar* _tmp9_ = NULL;
					gchar* _tmp10_;
					gchar* column;
					gboolean _tmp11_ = FALSE;
					_tmp9_ = sqlite3_column_text (stmt, 1);
					_tmp10_ = g_strdup (_tmp9_);
					column = _tmp10_;
					if (column != NULL) {
						_tmp11_ = g_strcmp0 (column, column_name) == 0;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						result = TRUE;
						_g_free0 (column);
						_sqlite3_finalize0 (stmt);
						return result;
					}
					_g_free0 (column);
				}
			}
		}
	}
	result = FALSE;
	_sqlite3_finalize0 (stmt);
	return result;
}


gboolean database_table_has_table (const gchar* table_name) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	gint res;
	gint _tmp5_;
	g_return_val_if_fail (table_name != NULL, FALSE);
	_tmp0_ = g_strdup_printf ("PRAGMA table_info(%s)", table_name);
	_tmp1_ = _tmp0_;
	_tmp3_ = sqlite3_prepare_v2 (database_table_db, _tmp1_, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp1_);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_step (stmt);
	res = _tmp5_;
	result = res != SQLITE_DONE;
	_sqlite3_finalize0 (stmt);
	return result;
}


gboolean database_table_add_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	gint res;
	gint _tmp5_;
	g_return_val_if_fail (table_name != NULL, FALSE);
	g_return_val_if_fail (column_name != NULL, FALSE);
	g_return_val_if_fail (column_constraints != NULL, FALSE);
	_tmp0_ = g_strdup_printf ("ALTER TABLE %s ADD COLUMN %s %s", table_name, column_name, column_constraints);
	_tmp1_ = _tmp0_;
	_tmp3_ = sqlite3_prepare_v2 (database_table_db, _tmp1_, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp1_);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_step (stmt);
	res = _tmp5_;
	if (res != SQLITE_DONE) {
		const gchar* _tmp6_ = NULL;
		_tmp6_ = sqlite3_errmsg (database_table_db);
		g_critical ("DatabaseTable.vala:327: Unable to add column %s %s %s: (%d) %s", table_name, column_name, column_constraints, res, _tmp6_);
		result = FALSE;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	result = TRUE;
	_sqlite3_finalize0 (stmt);
	return result;
}


gboolean database_table_ensure_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints, const gchar* upgrade_msg) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp3_;
	g_return_val_if_fail (table_name != NULL, FALSE);
	g_return_val_if_fail (column_name != NULL, FALSE);
	g_return_val_if_fail (column_constraints != NULL, FALSE);
	g_return_val_if_fail (upgrade_msg != NULL, FALSE);
	_tmp1_ = database_table_has_table (table_name);
	if (!_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = database_table_has_column (table_name, column_name);
		_tmp0_ = _tmp2_;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	g_message ("DatabaseTable.vala:344: %s", upgrade_msg);
	_tmp3_ = database_table_add_column (table_name, column_name, column_constraints);
	result = _tmp3_;
	return result;
}


gint database_table_get_row_count (DatabaseTable* self) {
	gint result = 0;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	gint res;
	gint _tmp5_;
	gint _tmp7_;
	g_return_val_if_fail (IS_DATABASE_TABLE (self), 0);
	_tmp0_ = g_strdup_printf ("SELECT COUNT(id) AS RowCount FROM %s", self->table_name);
	_tmp1_ = _tmp0_;
	_tmp3_ = sqlite3_prepare_v2 (database_table_db, _tmp1_, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp1_);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_step (stmt);
	res = _tmp5_;
	if (res != SQLITE_ROW) {
		const gchar* _tmp6_ = NULL;
		_tmp6_ = sqlite3_errmsg (database_table_db);
		g_critical ("DatabaseTable.vala:356: Unable to retrieve row count on %s: (%d) %s", self->table_name, res, _tmp6_);
		result = 0;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp7_ = sqlite3_column_int (stmt, 0);
	result = _tmp7_;
	_sqlite3_finalize0 (stmt);
	return result;
}


void database_table_begin_transaction (void) {
	gint _tmp0_;
	gint _tmp1_;
	gint res;
	_tmp0_ = database_table_in_transaction;
	database_table_in_transaction = _tmp0_ + 1;
	if (_tmp0_ != 0) {
		return;
	}
	_tmp1_ = _sqlite3_exec (database_table_db, "BEGIN TRANSACTION", NULL, NULL, NULL);
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
}


void database_table_commit_transaction (GError** error) {
	gint _tmp0_;
	gint res;
	GError * _inner_error_ = NULL;
	g_assert (database_table_in_transaction > 0);
	database_table_in_transaction = database_table_in_transaction - 1;
	if (database_table_in_transaction != 0) {
		return;
	}
	_tmp0_ = _sqlite3_exec (database_table_db, "COMMIT TRANSACTION", NULL, NULL, NULL);
	res = _tmp0_;
	if (res != SQLITE_DONE) {
		database_table_throw_error ("commit_transaction", res, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
}


DatabaseTable* database_table_construct (GType object_type) {
	DatabaseTable* self = NULL;
	self = (DatabaseTable*) g_type_create_instance (object_type);
	return self;
}


static void value_database_table_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_database_table_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		database_table_unref (value->data[0].v_pointer);
	}
}


static void value_database_table_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = database_table_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_database_table_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_database_table_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DatabaseTable* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = database_table_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_database_table_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DatabaseTable** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = database_table_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecDatabaseTable* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATABASE_TABLE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_database_table (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE), NULL);
	return value->data[0].v_pointer;
}


void value_set_database_table (GValue* value, gpointer v_object) {
	DatabaseTable* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		database_table_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		database_table_unref (old);
	}
}


void value_take_database_table (GValue* value, gpointer v_object) {
	DatabaseTable* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		database_table_unref (old);
	}
}


static void database_table_class_init (DatabaseTableClass * klass) {
	database_table_parent_class = g_type_class_peek_parent (klass);
	DATABASE_TABLE_CLASS (klass)->finalize = database_table_finalize;
}


static void database_table_instance_init (DatabaseTable * self) {
	self->table_name = NULL;
	self->ref_count = 1;
}


static void database_table_finalize (DatabaseTable* obj) {
	DatabaseTable * self;
	self = DATABASE_TABLE (obj);
	_g_free0 (self->table_name);
}


GType database_table_get_type (void) {
	static volatile gsize database_table_type_id__volatile = 0;
	if (g_once_init_enter (&database_table_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_database_table_init, value_database_table_free_value, value_database_table_copy_value, value_database_table_peek_pointer, "p", value_database_table_collect_value, "p", value_database_table_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DatabaseTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseTable), 0, (GInstanceInitFunc) database_table_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType database_table_type_id;
		database_table_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DatabaseTable", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&database_table_type_id__volatile, database_table_type_id);
	}
	return database_table_type_id__volatile;
}


gpointer database_table_ref (gpointer instance) {
	DatabaseTable* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void database_table_unref (gpointer instance) {
	DatabaseTable* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DATABASE_TABLE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



