/* string.c generated by valac 0.12.1, the Vala compiler
 * generated from string.vala, do not modify */

/* Copyright 2010-2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())

typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;



gint64 g_ascii_strtoll (const gchar* str, gchar** endptr, guint num_base);
#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
gboolean is_string_empty (const gchar* s);
gint utf8_cs_compare (void* a, void* b);
gint utf8_ci_compare (void* a, void* b);
gchar* uchar_array_to_string (guchar* data, int data_length1, gint length);
guchar* string_to_uchar_array (const gchar* str, int* result_length1);
static void _vala_array_add1 (guchar** array, int* length, int* size, guchar value);
gchar* guarded_markup_escape_text (const gchar* plain);
glong find_last_offset (const gchar* str, gchar c);
gboolean is_in_ci_array (const gchar* str, gchar** strings, int strings_length1);
GType prepare_input_text_options_get_type (void) G_GNUC_CONST;
gchar* prepare_input_text (const gchar* text, PrepareInputTextOptions options, gint dest_length);
gint64 parse_int64 (const gchar* str, gint num_base);
gboolean string_contains_char (const gchar* haystack, gunichar needle);
gboolean string_contains_str (const gchar* haystack, const gchar* needle);
gchar* string_sliced_at (const gchar* str, gint index);
gchar* string_sliced_at_first_str (const gchar* haystack, const gchar* needle, gint start_index);
gchar* string_sliced_at_last_str (const gchar* haystack, const gchar* needle, gint start_index);
gchar* string_sliced_at_first_char (const gchar* haystack, gunichar ch, gint start_index);
gchar* string_sliced_at_last_char (const gchar* haystack, gunichar ch, gint start_index);
gchar* string_strip_leading_zeroes (const gchar* str);
gchar* string_to_hex_string (const gchar* str);
guint string_collated_hash (void* ptr);
guint string_precollated_hash (void* ptr);
gint string_collated_compare (void* a, void* b);
gint string_precollated_compare (const gchar* astr, const gchar* akey, const gchar* bstr, const gchar* bkey);
gboolean string_collated_equals (void* a, void* b);
gboolean string_precollated_equals (const gchar* astr, const gchar* akey, const gchar* bstr, const gchar* bkey);


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = ((gchar*) self)[index];
	return result;
}


inline gboolean is_string_empty (const gchar* s) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if (s == NULL) {
		_tmp0_ = TRUE;
	} else {
		gchar _tmp1_;
		_tmp1_ = string_get (s, (glong) 0);
		_tmp0_ = _tmp1_ == '\0';
	}
	result = _tmp0_;
	return result;
}


gint utf8_cs_compare (void* a, void* b) {
	gint result = 0;
	gint _tmp0_;
	_tmp0_ = g_utf8_collate ((const gchar*) a, (const gchar*) b);
	result = _tmp0_;
	return result;
}


gint utf8_ci_compare (void* a, void* b) {
	gint result = 0;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	_tmp0_ = g_utf8_strdown ((const gchar*) a, (gssize) (-1));
	_tmp1_ = _tmp0_;
	_tmp2_ = g_utf8_strdown ((const gchar*) b, (gssize) (-1));
	_tmp3_ = _tmp2_;
	_tmp4_ = g_utf8_collate (_tmp1_, _tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	result = _tmp5_;
	return result;
}


gchar* uchar_array_to_string (guchar* data, int data_length1, gint length) {
	gchar* result = NULL;
	GString* _tmp0_ = NULL;
	GString* builder;
	gchar* _tmp2_;
	if (length < 0) {
		length = data_length1;
	}
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				if (!_tmp1_) {
					ctr++;
				}
				_tmp1_ = FALSE;
				if (!(ctr < length)) {
					break;
				}
				if (data[ctr] != '\0') {
					g_string_append_c (builder, (gchar) data[ctr]);
				} else {
					break;
				}
			}
		}
	}
	_tmp2_ = g_strdup (builder->str);
	result = _tmp2_;
	_g_string_free0 (builder);
	return result;
}


static void _vala_array_add1 (guchar** array, int* length, int* size, guchar value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (guchar, *array, *size);
	}
	(*array)[(*length)++] = value;
}


guchar* string_to_uchar_array (const gchar* str, int* result_length1) {
	guchar* result = NULL;
	guchar* _tmp0_ = NULL;
	guchar* data;
	gint data_length1;
	gint _data_size_;
	guchar* _tmp4_;
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = g_new0 (guchar, 0);
	data = _tmp0_;
	data_length1 = 0;
	_data_size_ = 0;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gchar _tmp3_;
				if (!_tmp1_) {
					ctr++;
				}
				_tmp1_ = FALSE;
				_tmp2_ = strlen (str);
				if (!(ctr < _tmp2_)) {
					break;
				}
				_tmp3_ = string_get (str, (glong) ctr);
				_vala_array_add1 (&data, &data_length1, &_data_size_, (guchar) _tmp3_);
			}
		}
	}
	_tmp4_ = data;
	if (result_length1) {
		*result_length1 = data_length1;
	}
	result = _tmp4_;
	return result;
}


inline gchar* guarded_markup_escape_text (const gchar* plain) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	_tmp2_ = is_string_empty (plain);
	if (!_tmp2_) {
		gboolean _tmp3_;
		_tmp3_ = g_utf8_validate (plain, (gssize) (-1), NULL);
		_tmp1_ = _tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gchar* _tmp4_ = NULL;
		_tmp4_ = g_markup_escape_text (plain, (gssize) (-1));
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	} else {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp5_;
	}
	result = _tmp0_;
	return result;
}


glong find_last_offset (const gchar* str, gchar c) {
	glong result = 0L;
	gint _tmp0_;
	glong offset;
	g_return_val_if_fail (str != NULL, 0L);
	_tmp0_ = strlen (str);
	offset = (glong) _tmp0_;
	while (TRUE) {
		gchar _tmp1_;
		offset = offset - 1;
		if (!(offset >= 0)) {
			break;
		}
		_tmp1_ = string_get (str, offset);
		if (_tmp1_ == c) {
			result = offset;
			return result;
		}
	}
	result = (glong) (-1);
	return result;
}


gboolean is_in_ci_array (const gchar* str, gchar** strings, int strings_length1) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* strdown;
	g_return_val_if_fail (str != NULL, FALSE);
	_tmp0_ = g_utf8_strdown (str, (gssize) (-1));
	strdown = _tmp0_;
	{
		gchar** str_element_collection;
		int str_element_collection_length1;
		int str_element_it;
		str_element_collection = strings;
		str_element_collection_length1 = strings_length1;
		for (str_element_it = 0; str_element_it < strings_length1; str_element_it = str_element_it + 1) {
			gchar* _tmp1_;
			gchar* str_element;
			_tmp1_ = g_strdup (str_element_collection[str_element_it]);
			str_element = _tmp1_;
			{
				if (g_strcmp0 (strdown, str_element) == 0) {
					result = TRUE;
					_g_free0 (str_element);
					_g_free0 (strdown);
					return result;
				}
				_g_free0 (str_element);
			}
		}
	}
	result = FALSE;
	_g_free0 (strdown);
	return result;
}


GType prepare_input_text_options_get_type (void) {
	static volatile gsize prepare_input_text_options_type_id__volatile = 0;
	if (g_once_init_enter (&prepare_input_text_options_type_id__volatile)) {
		static const GFlagsValue values[] = {{PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL", "empty-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_VALIDATE, "PREPARE_INPUT_TEXT_OPTIONS_VALIDATE", "validate"}, {PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL", "invalid-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_STRIP, "PREPARE_INPUT_TEXT_OPTIONS_STRIP", "strip"}, {PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF, "PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF", "strip-crlf"}, {PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE, "PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE", "normalize"}, {PREPARE_INPUT_TEXT_OPTIONS_DEFAULT, "PREPARE_INPUT_TEXT_OPTIONS_DEFAULT", "default"}, {0, NULL, NULL}};
		GType prepare_input_text_options_type_id;
		prepare_input_text_options_type_id = g_flags_register_static ("PrepareInputTextOptions", values);
		g_once_init_leave (&prepare_input_text_options_type_id__volatile, prepare_input_text_options_type_id);
	}
	return prepare_input_text_options_type_id__volatile;
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}


static gchar* string_delimit (const gchar* self, const gchar* delimiters, gchar new_delimiter) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (delimiters != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strdelimit (_result_, delimiters, new_delimiter);
	result = _result_;
	return result;
}


gchar* prepare_input_text (const gchar* text, PrepareInputTextOptions options, gint dest_length) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp4_;
	gchar* prepped;
	gboolean _tmp8_ = FALSE;
	if (text == NULL) {
		result = NULL;
		return result;
	}
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) != 0) {
		gboolean _tmp1_;
		_tmp1_ = g_utf8_validate (text, (gssize) (-1), NULL);
		_tmp0_ = !_tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		if ((options & PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) != 0) {
			_tmp2_ = NULL;
		} else {
			_tmp2_ = "";
		}
		_tmp3_ = g_strdup (_tmp2_);
		result = _tmp3_;
		return result;
	}
	_tmp4_ = g_strdup (text);
	prepped = _tmp4_;
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) != 0) {
		gchar* _tmp5_ = NULL;
		_tmp5_ = g_utf8_normalize (prepped, (gssize) (-1), G_NORMALIZE_NFC);
		_g_free0 (prepped);
		prepped = _tmp5_;
	}
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_STRIP) != 0) {
		gchar* _tmp6_ = NULL;
		_tmp6_ = string_strip (prepped);
		_g_free0 (prepped);
		prepped = _tmp6_;
	}
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) != 0) {
		gchar* _tmp7_ = NULL;
		_tmp7_ = string_delimit (prepped, "\n\r", ' ');
		_g_free0 (prepped);
		prepped = _tmp7_;
	}
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) != 0) {
		gboolean _tmp9_;
		_tmp9_ = is_string_empty (prepped);
		_tmp8_ = _tmp9_;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		result = NULL;
		_g_free0 (prepped);
		return result;
	}
	if (dest_length >= 0) {
		GString* _tmp10_ = NULL;
		GString* sb;
		gchar* _tmp11_;
		_tmp10_ = g_string_new (prepped);
		sb = _tmp10_;
		g_string_truncate (sb, (gsize) dest_length);
		_tmp11_ = g_strdup (sb->str);
		result = _tmp11_;
		_g_string_free0 (sb);
		_g_free0 (prepped);
		return result;
	}
	result = prepped;
	return result;
}


gint64 parse_int64 (const gchar* str, gint num_base) {
	gint64 result = 0LL;
	gint64 _tmp0_;
	g_return_val_if_fail (str != NULL, 0LL);
	_tmp0_ = g_ascii_strtoll (str, NULL, (guint) num_base);
	result = _tmp0_;
	return result;
}


static gint string_index_of_char (const gchar* self, gunichar c, gint start_index) {
	gint result = 0;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) (-1), c);
	_result_ = _tmp0_;
	if (_result_ != NULL) {
		result = (gint) (_result_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


inline gboolean string_contains_char (const gchar* haystack, gunichar needle) {
	gboolean result = FALSE;
	gint _tmp0_;
	g_return_val_if_fail (haystack != NULL, FALSE);
	_tmp0_ = string_index_of_char (haystack, needle, 0);
	result = _tmp0_ >= 0;
	return result;
}


static gint string_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	if (_result_ != NULL) {
		result = (gint) (_result_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


inline gboolean string_contains_str (const gchar* haystack, const gchar* needle) {
	gboolean result = FALSE;
	gint _tmp0_;
	g_return_val_if_fail (haystack != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = string_index_of (haystack, needle, 0);
	result = _tmp0_ >= 0;
	return result;
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	gint _tmp0_;
	glong string_length;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	string_length = (glong) _tmp0_;
	if (start < 0) {
		start = string_length + start;
	}
	if (end < 0) {
		end = string_length + end;
	}
	if (start >= 0) {
		_tmp1_ = start <= string_length;
	} else {
		_tmp1_ = FALSE;
	}
	g_return_val_if_fail (_tmp1_, NULL);
	if (end >= 0) {
		_tmp2_ = end <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp3_;
	return result;
}


inline gchar* string_sliced_at (const gchar* str, gint index) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (str != NULL, NULL);
	if (index >= 0) {
		gint _tmp1_;
		gchar* _tmp2_ = NULL;
		_tmp1_ = strlen (str);
		_tmp2_ = string_slice (str, (glong) index, (glong) _tmp1_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	} else {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}


inline gchar* string_sliced_at_first_str (const gchar* haystack, const gchar* needle, gint start_index) {
	gchar* result = NULL;
	gint _tmp0_;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (haystack != NULL, NULL);
	g_return_val_if_fail (needle != NULL, NULL);
	_tmp0_ = string_index_of (haystack, needle, start_index);
	_tmp1_ = string_sliced_at (haystack, _tmp0_);
	result = _tmp1_;
	return result;
}


static gint string_last_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	if (_result_ != NULL) {
		result = (gint) (_result_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


inline gchar* string_sliced_at_last_str (const gchar* haystack, const gchar* needle, gint start_index) {
	gchar* result = NULL;
	gint _tmp0_;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (haystack != NULL, NULL);
	g_return_val_if_fail (needle != NULL, NULL);
	_tmp0_ = string_last_index_of (haystack, needle, start_index);
	_tmp1_ = string_sliced_at (haystack, _tmp0_);
	result = _tmp1_;
	return result;
}


inline gchar* string_sliced_at_first_char (const gchar* haystack, gunichar ch, gint start_index) {
	gchar* result = NULL;
	gint _tmp0_;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (haystack != NULL, NULL);
	_tmp0_ = string_index_of_char (haystack, ch, start_index);
	_tmp1_ = string_sliced_at (haystack, _tmp0_);
	result = _tmp1_;
	return result;
}


static gint string_last_index_of_char (const gchar* self, gunichar c, gint start_index) {
	gint result = 0;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) (-1), c);
	_result_ = _tmp0_;
	if (_result_ != NULL) {
		result = (gint) (_result_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


inline gchar* string_sliced_at_last_char (const gchar* haystack, gunichar ch, gint start_index) {
	gchar* result = NULL;
	gint _tmp0_;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (haystack != NULL, NULL);
	_tmp0_ = string_last_index_of_char (haystack, ch, start_index);
	_tmp1_ = string_sliced_at (haystack, _tmp0_);
	result = _tmp1_;
	return result;
}


static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	gunichar _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = g_utf8_get_char (((gchar*) self) + index);
	result = _tmp0_;
	return result;
}


gchar* string_strip_leading_zeroes (const gchar* str) {
	gchar* result = NULL;
	GString* _tmp0_ = NULL;
	GString* stripped;
	gboolean prev_is_space;
	gchar* _tmp7_;
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = g_string_new ("");
	stripped = _tmp0_;
	prev_is_space = TRUE;
	{
		const gchar* iter;
		iter = str;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				gunichar _tmp3_;
				gunichar _tmp4_;
				gunichar ch;
				gboolean _tmp5_ = FALSE;
				if (!_tmp1_) {
					const gchar* _tmp2_ = NULL;
					_tmp2_ = g_utf8_next_char (iter);
					iter = _tmp2_;
				}
				_tmp1_ = FALSE;
				_tmp3_ = string_get_char (iter, (glong) 0);
				if (!(_tmp3_ != 0)) {
					break;
				}
				_tmp4_ = string_get_char (iter, (glong) 0);
				ch = _tmp4_;
				if (!prev_is_space) {
					_tmp5_ = TRUE;
				} else {
					_tmp5_ = ch != '0';
				}
				if (_tmp5_) {
					gboolean _tmp6_;
					g_string_append_unichar (stripped, ch);
					_tmp6_ = g_unichar_isspace (ch);
					prev_is_space = _tmp6_;
				}
			}
		}
	}
	_tmp7_ = g_strdup (stripped->str);
	result = _tmp7_;
	_g_string_free0 (stripped);
	return result;
}


gchar* string_to_hex_string (const gchar* str) {
	gchar* result = NULL;
	GString* _tmp0_ = NULL;
	GString* builder;
	guint8* data;
	gchar* _tmp3_;
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	data = (guint8*) str;
	while (TRUE) {
		const gchar* _tmp1_ = NULL;
		guint8* _tmp2_;
		if (!((*data) != 0)) {
			break;
		}
		if ((*data) != 0) {
			_tmp1_ = " ";
		} else {
			_tmp1_ = "";
		}
		_tmp2_ = data;
		data = _tmp2_ + 1;
		g_string_append_printf (builder, "%02Xh%s", (guint) (*_tmp2_), _tmp1_);
	}
	_tmp3_ = g_strdup (builder->str);
	result = _tmp3_;
	_g_string_free0 (builder);
	return result;
}


guint string_collated_hash (void* ptr) {
	guint result = 0U;
	gchar* _tmp0_;
	gchar* str;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	_tmp0_ = g_strdup ((const gchar*) ptr);
	str = _tmp0_;
	_tmp1_ = g_utf8_collate_key (str, (gssize) (-1));
	_tmp2_ = _tmp1_;
	_tmp3_ = g_str_hash (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	_g_free0 (str);
	return result;
}


guint string_precollated_hash (void* ptr) {
	guint result = 0U;
	guint _tmp0_;
	_tmp0_ = g_str_hash ((const gchar*) ptr);
	result = _tmp0_;
	return result;
}


gint string_collated_compare (void* a, void* b) {
	gint result = 0;
	gchar* _tmp0_;
	gchar* astr;
	gchar* _tmp1_;
	gchar* bstr;
	gint _tmp2_;
	gint _result_;
	gint _tmp3_ = 0;
	_tmp0_ = g_strdup ((const gchar*) a);
	astr = _tmp0_;
	_tmp1_ = g_strdup ((const gchar*) b);
	bstr = _tmp1_;
	_tmp2_ = g_utf8_collate (astr, bstr);
	_result_ = _tmp2_;
	if (_result_ != 0) {
		_tmp3_ = _result_;
	} else {
		gint _tmp4_;
		_tmp4_ = g_strcmp0 (astr, bstr);
		_tmp3_ = _tmp4_;
	}
	result = _tmp3_;
	_g_free0 (bstr);
	_g_free0 (astr);
	return result;
}


gint string_precollated_compare (const gchar* astr, const gchar* akey, const gchar* bstr, const gchar* bkey) {
	gint result = 0;
	gint _tmp0_;
	gint _result_;
	gint _tmp1_ = 0;
	g_return_val_if_fail (astr != NULL, 0);
	g_return_val_if_fail (akey != NULL, 0);
	g_return_val_if_fail (bstr != NULL, 0);
	g_return_val_if_fail (bkey != NULL, 0);
	_tmp0_ = g_strcmp0 (akey, bkey);
	_result_ = _tmp0_;
	if (_result_ != 0) {
		_tmp1_ = _result_;
	} else {
		gint _tmp2_;
		_tmp2_ = g_strcmp0 (astr, bstr);
		_tmp1_ = _tmp2_;
	}
	result = _tmp1_;
	return result;
}


gboolean string_collated_equals (void* a, void* b) {
	gboolean result = FALSE;
	gint _tmp0_;
	_tmp0_ = string_collated_compare (a, b);
	result = _tmp0_ == 0;
	return result;
}


gboolean string_precollated_equals (const gchar* astr, const gchar* akey, const gchar* bstr, const gchar* bkey) {
	gboolean result = FALSE;
	gint _tmp0_;
	g_return_val_if_fail (astr != NULL, FALSE);
	g_return_val_if_fail (akey != NULL, FALSE);
	g_return_val_if_fail (bstr != NULL, FALSE);
	g_return_val_if_fail (bkey != NULL, FALSE);
	_tmp0_ = string_precollated_compare (astr, akey, bstr, bkey);
	result = _tmp0_ == 0;
	return result;
}



