/* ViewCollection.c generated by valac 0.12.1, the Vala compiler
 * generated from ViewCollection.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* A ViewCollection holds DataView objects, which are view instances wrapping DataSource objects.*/
/* Thus, multiple views can exist of a single SourceCollection, each view displaying all or some*/
/* of that SourceCollection.  A view collection also has a notion of order*/
/* (first/last/next/previous) that can be overridden by child classes.  It also understands hidden*/
/* objects, which are withheld entirely from the collection until they're made visible.  Currently*/
/* the only way to hide objects is with a ViewFilter.*/
/**/
/* A ViewCollection may also be locked.  When locked, it will not (a) remove hidden items from the*/
/* collection and (b) remove DataViews representing unlinked DataSources.  This allows for the*/
/* ViewCollection to be "frozen" while manipulating items within it.  When the collection is*/
/* unlocked, all changes are applied at once.*/
/**/
/* The default implementation provides a browser which orders the view in the order they're*/
/* stored in DataCollection, which is not specified.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ViewCollectionPrivate ViewCollectionPrivate;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;

#define TYPE_VIEW_FILTER (view_filter_get_type ())
#define VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_FILTER, ViewFilter))
#define VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_FILTER, ViewFilterClass))
#define IS_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_FILTER))
#define IS_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_FILTER))
#define VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_FILTER, ViewFilterClass))

typedef struct _ViewFilter ViewFilter;
typedef struct _ViewFilterClass ViewFilterClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define VIEW_COLLECTION_TYPE_MONITOR (view_collection_monitor_get_type ())
#define VIEW_COLLECTION_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor))
#define VIEW_COLLECTION_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))
#define VIEW_COLLECTION_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))

typedef struct _ViewCollectionMonitor ViewCollectionMonitor;
typedef struct _ViewCollectionMonitorClass ViewCollectionMonitorClass;

#define VIEW_COLLECTION_TYPE_MONITOR_IMPL (view_collection_monitor_impl_get_type ())
#define VIEW_COLLECTION_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl))
#define VIEW_COLLECTION_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))
#define VIEW_COLLECTION_IS_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_IS_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_MONITOR_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))

typedef struct _ViewCollectionMonitorImpl ViewCollectionMonitorImpl;
typedef struct _ViewCollectionMonitorImplClass ViewCollectionMonitorImplClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_DATA_SET (data_set_get_type ())
#define DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SET, DataSet))
#define DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SET, DataSetClass))
#define IS_DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SET))
#define IS_DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SET))
#define DATA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SET, DataSetClass))

typedef struct _DataSet DataSet;
typedef struct _DataSetClass DataSetClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))

#define TYPE_VIEW_MANAGER (view_manager_get_type ())
#define VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_MANAGER, ViewManager))
#define VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_MANAGER, ViewManagerClass))
#define IS_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_MANAGER))
#define IS_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_MANAGER))
#define VIEW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_MANAGER, ViewManagerClass))

typedef struct _ViewManager ViewManager;
typedef struct _ViewManagerClass ViewManagerClass;
#define _view_collection_monitor_unref0(var) ((var == NULL) ? NULL : (var = (view_collection_monitor_unref (var), NULL)))
typedef struct _ViewCollectionMonitorPrivate ViewCollectionMonitorPrivate;
typedef struct _ViewCollectionMonitorImplPrivate ViewCollectionMonitorImplPrivate;
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define VIEW_COLLECTION_TYPE_TOGGLE_LISTS (view_collection_toggle_lists_get_type ())
#define VIEW_COLLECTION_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists))
#define VIEW_COLLECTION_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_TOGGLE_LISTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))

typedef struct _ViewCollectionToggleLists ViewCollectionToggleLists;
typedef struct _ViewCollectionToggleListsClass ViewCollectionToggleListsClass;
typedef struct _ViewCollectionToggleListsPrivate ViewCollectionToggleListsPrivate;
typedef struct _ViewCollectionParamSpecMonitor ViewCollectionParamSpecMonitor;
#define _view_manager_unref0(var) ((var == NULL) ? NULL : (var = (view_manager_unref (var), NULL)))
typedef struct _ViewManagerPrivate ViewManagerPrivate;
typedef struct _ParamSpecViewManager ParamSpecViewManager;
typedef struct _ViewFilterPrivate ViewFilterPrivate;
typedef struct _ParamSpecViewFilter ParamSpecViewFilter;

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _ViewCollection {
	DataCollection parent_instance;
	ViewCollectionPrivate * priv;
};

struct _ViewCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_items_selected_unselected) (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected);
	void (*notify_selection_group_altered) (ViewCollection* self);
	void (*notify_item_view_altered) (ViewCollection* self, DataView* view);
	void (*notify_views_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*notify_geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_items_shown) (ViewCollection* self, GeeCollection* shown);
	void (*notify_items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*notify_items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*notify_view_filter_installed) (ViewCollection* self, ViewFilter* filter);
	void (*notify_view_filter_removed) (ViewCollection* self, ViewFilter* filter);
	DataView* (*get_first) (ViewCollection* self);
	DataView* (*get_last) (ViewCollection* self);
	DataView* (*get_next) (ViewCollection* self, DataView* view);
	DataView* (*get_previous) (ViewCollection* self, DataView* view);
	void (*items_selected) (ViewCollection* self, GeeIterable* selected);
	void (*items_unselected) (ViewCollection* self, GeeIterable* unselected);
	void (*items_state_changed) (ViewCollection* self, GeeIterable* changed);
	void (*selection_group_altered) (ViewCollection* self);
	void (*items_shown) (ViewCollection* self, GeeCollection* visible);
	void (*items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*item_view_altered) (ViewCollection* self, DataView* view);
	void (*item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*views_altered) (ViewCollection* self, GeeCollection* views);
	void (*geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*view_filter_installed) (ViewCollection* self, ViewFilter* filer);
	void (*view_filter_removed) (ViewCollection* self, ViewFilter* filer);
};

typedef DataView* (*CreateView) (DataSource* source, void* user_data);
typedef gboolean (*CreateViewPredicate) (DataSource* source, void* user_data);
struct _ViewCollectionPrivate {
	GeeHashMultiMap* monitors;
	ViewCollection* mirroring;
	CreateView mirroring_ctor;
	gpointer mirroring_ctor_target;
	GDestroyNotify mirroring_ctor_target_destroy_notify;
	CreateViewPredicate should_mirror;
	gpointer should_mirror_target;
	GDestroyNotify should_mirror_target_destroy_notify;
	GeeSet* filters;
	DataSet* selected;
	DataSet* visible;
	GeeHashSet* frozen_views_altered;
	GeeHashSet* frozen_geometries_altered;
	GeeHashMap* source_map;
};

struct _ViewCollectionMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewCollectionMonitorPrivate * priv;
};

struct _ViewCollectionMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (ViewCollectionMonitor *self);
};

struct _ViewCollectionMonitorImpl {
	ViewCollectionMonitor parent_instance;
	ViewCollectionMonitorImplPrivate * priv;
	ViewCollection* owner;
	SourceCollection* sources;
	ViewManager* manager;
	Alteration* prereq;
};

struct _ViewCollectionMonitorImplClass {
	ViewCollectionMonitorClass parent_class;
};

typedef gboolean (*MarkedAction) (DataObject* object, GObject* user, void* user_data);
struct _ViewCollectionToggleLists {
	GObject parent_instance;
	ViewCollectionToggleListsPrivate * priv;
	GeeArrayList* selected;
	GeeArrayList* unselected;
};

struct _ViewCollectionToggleListsClass {
	GObjectClass parent_class;
};

struct _ViewCollectionParamSpecMonitor {
	GParamSpec parent_instance;
};

struct _ViewManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewManagerPrivate * priv;
};

struct _ViewManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ViewManager *self);
	gboolean (*include_in_view) (ViewManager* self, DataSource* source);
	DataView* (*create_view) (ViewManager* self, DataSource* source);
};

struct _ParamSpecViewManager {
	GParamSpec parent_instance;
};

struct _ViewFilter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewFilterPrivate * priv;
};

struct _ViewFilterClass {
	GTypeClass parent_class;
	void (*finalize) (ViewFilter *self);
	gboolean (*predicate) (ViewFilter* self, DataView* view);
	void (*refresh) (ViewFilter* self);
};

struct _ParamSpecViewFilter {
	GParamSpec parent_instance;
};


static gpointer view_collection_parent_class = NULL;
static gpointer view_collection_monitor_parent_class = NULL;
static gpointer view_collection_monitor_impl_parent_class = NULL;
static gpointer view_collection_toggle_lists_parent_class = NULL;
static gpointer view_manager_parent_class = NULL;
static gpointer view_filter_parent_class = NULL;

gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
GType marker_get_type (void) G_GNUC_CONST;
GType view_collection_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
gpointer view_filter_ref (gpointer instance);
void view_filter_unref (gpointer instance);
GParamSpec* param_spec_view_filter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_view_filter (GValue* value, gpointer v_object);
void value_take_view_filter (GValue* value, gpointer v_object);
gpointer value_get_view_filter (const GValue* value);
GType view_filter_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer view_collection_monitor_ref (gpointer instance);
void view_collection_monitor_unref (gpointer instance);
GParamSpec* view_collection_param_spec_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void view_collection_value_set_monitor (GValue* value, gpointer v_object);
void view_collection_value_take_monitor (GValue* value, gpointer v_object);
gpointer view_collection_value_get_monitor (const GValue* value);
GType view_collection_monitor_get_type (void) G_GNUC_CONST;
static GType view_collection_monitor_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer data_set_ref (gpointer instance);
void data_set_unref (gpointer instance);
GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_set (GValue* value, gpointer v_object);
void value_take_data_set (GValue* value, gpointer v_object);
gpointer value_get_data_set (const GValue* value);
GType data_set_get_type (void) G_GNUC_CONST;
#define VIEW_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_VIEW_COLLECTION, ViewCollectionPrivate))
enum  {
	VIEW_COLLECTION_DUMMY_PROPERTY
};
DataSet* data_set_new (void);
DataSet* data_set_construct (GType object_type);
ViewCollection* view_collection_new (const gchar* name);
ViewCollection* view_collection_construct (GType object_type, const gchar* name);
DataCollection* data_collection_new (const gchar* name);
DataCollection* data_collection_construct (GType object_type, const gchar* name);
void view_collection_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected);
static void view_collection_real_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected);
void view_collection_notify_selection_group_altered (ViewCollection* self);
static void view_collection_real_notify_selection_group_altered (ViewCollection* self);
void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_items_shown (ViewCollection* self, GeeCollection* shown);
static void view_collection_real_notify_items_shown (ViewCollection* self, GeeCollection* shown);
void view_collection_notify_items_hidden (ViewCollection* self, GeeCollection* hidden);
static void view_collection_real_notify_items_hidden (ViewCollection* self, GeeCollection* hidden);
void view_collection_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
void view_collection_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter);
static void view_collection_real_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter);
void view_collection_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter);
static void view_collection_real_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter);
static void view_collection_real_clear (DataCollection* base);
gchar* data_collection_to_string (DataCollection* self);
void data_collection_clear (DataCollection* self);
static void view_collection_real_close (DataCollection* base);
void view_collection_halt_all_monitoring (ViewCollection* self);
void view_collection_halt_mirroring (ViewCollection* self);
static void view_collection_on_view_filter_refresh (ViewCollection* self);
static void _view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender, gpointer self);
void data_collection_close (DataCollection* self);
gpointer view_manager_ref (gpointer instance);
void view_manager_unref (gpointer instance);
GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_view_manager (GValue* value, gpointer v_object);
void value_take_view_manager (GValue* value, gpointer v_object);
gpointer value_get_view_manager (const GValue* value);
GType view_manager_get_type (void) G_GNUC_CONST;
ViewCollectionMonitor* view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, Alteration* prereq, GeeCollection* initial, ProgressMonitor progress_monitor, void* progress_monitor_target);
void data_collection_freeze_notifications (DataCollection* self);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_new (ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_construct (GType object_type, ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq);
DataView* view_manager_create_view (ViewManager* self, DataSource* source);
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
static void view_collection_add_sources (ViewCollection* self, SourceCollection* sources, GeeIterable* added, ProgressMonitor progress_monitor, void* progress_monitor_target);
GeeCollection* data_collection_get_all (DataCollection* self);
void data_collection_thaw_notifications (DataCollection* self);
void view_collection_halt_monitoring (ViewCollection* self, ViewCollectionMonitor* m);
void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target, CreateViewPredicate should_mirror, void* should_mirror_target);
void data_collection_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
Comparator data_collection_get_comparator (DataCollection* self, void** result_target, GDestroyNotify* result_target_destroy_notify);
ComparatorPredicate data_collection_get_comparator_predicate (DataCollection* self, void** result_target, GDestroyNotify* result_target_destroy_notify);
static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added);
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed);
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
void view_collection_copy_into (ViewCollection* self, ViewCollection* to_copy, CreateView copying_ctor, void* copying_ctor_target, CreateViewPredicate should_copy, void* should_copy_target);
DataSource* data_view_get_source (DataView* self);
gboolean view_collection_is_view_filter_installed (ViewCollection* self, ViewFilter* f);
void view_collection_install_view_filter (ViewCollection* self, ViewFilter* f);
void view_collection_remove_view_filter (ViewCollection* self, ViewFilter* f);
static void view_collection_filter_altered_items (ViewCollection* self, GeeCollection* views);
static gboolean view_collection_is_in_filter (ViewCollection* self, DataView* view);
gboolean view_filter_predicate (ViewFilter* self, DataView* view);
static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object);
static void view_collection_on_sources_added (ViewCollection* self, DataCollection* sources, GeeIterable* added);
gboolean view_manager_include_in_view (ViewManager* self, DataSource* source);
static DataView* _view_manager_create_view_create_view (DataSource* source, gpointer self);
gboolean data_collection_add (DataCollection* self, DataObject* object);
static gboolean view_collection_real_add (DataCollection* base, DataObject* object);
void data_view_internal_set_visible (DataView* self, gboolean visible);
GeeCollection* data_collection_get_singleton (DataObject* object);
static GeeCollection* view_collection_real_add_many (DataCollection* base, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed);
Marker* data_collection_start_marking (DataCollection* self);
void marker_mark (Marker* self, DataObject* object);
gint marker_get_count (Marker* self);
void data_collection_remove_marked (DataCollection* self, Marker* m);
static void view_collection_on_sources_altered (ViewCollection* self, DataCollection* collection, GeeMap* items);
gboolean alteration_contains_any (Alteration* self, Alteration* other);
gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source);
DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source);
gboolean data_set_contains (DataSet* self, DataObject* object);
gboolean data_set_resort_object (DataSet* self, DataObject* object, Alteration* alteration);
static gboolean view_collection_is_visible (ViewCollection* self, DataView* view);
Marker* data_collection_mark_many (DataCollection* self, GeeCollection* objects);
void data_collection_notify_ordering_changed (DataCollection* self);
static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added);
gboolean data_view_is_selected (DataView* self);
gboolean data_view_is_visible (DataView* self);
static gboolean view_collection_add_many_visible (ViewCollection* self, GeeCollection* many);
static void view_collection_add_many_selected (ViewCollection* self, GeeCollection* views);
void data_collection_notify_items_added (DataCollection* self, GeeIterable* added);
static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed);
gboolean data_set_remove (DataSet* self, DataObject* object);
static void view_collection_remove_many_selected (ViewCollection* self, GeeCollection* views);
void data_collection_notify_items_removed (DataCollection* self, GeeIterable* removed);
static void view_collection_show_items (ViewCollection* self, GeeList* to_show);
static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide);
static void view_collection_real_items_altered (DataCollection* base, GeeMap* map);
static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
void data_set_set_comparator (DataSet* self, Comparator user_comparator, void* user_comparator_target, ComparatorPredicate comparator_predicate, void* comparator_predicate_target);
static void view_collection_real_reset_comparator (DataCollection* base);
void data_set_reset_comparator (DataSet* self);
void data_collection_reset_comparator (DataCollection* self);
static GeeCollection* view_collection_real_get_all (DataCollection* base);
GeeList* data_set_get_all (DataSet* self);
GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self);
static gint view_collection_real_get_count (DataCollection* base);
gint data_set_get_count (DataSet* self);
gint data_collection_get_count (DataCollection* self);
gint view_collection_get_unfiltered_count (ViewCollection* self);
static DataObject* view_collection_real_get_at (DataCollection* base, gint index);
DataObject* data_set_get_at (DataSet* self, gint index);
DataObject* data_collection_get_at (DataCollection* self, gint index);
static gint view_collection_real_index_of (DataCollection* base, DataObject* object);
gint data_set_index_of (DataSet* self, DataObject* object);
gint data_collection_index_of (DataCollection* self, DataObject* object);
static gboolean view_collection_real_contains (DataCollection* base, DataObject* object);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
DataView* view_collection_get_first (ViewCollection* self);
static DataView* view_collection_real_get_first (ViewCollection* self);
DataView* view_collection_get_last (ViewCollection* self);
static DataView* view_collection_real_get_last (ViewCollection* self);
DataView* view_collection_get_next (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view);
DataView* view_collection_get_previous (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view);
gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev, const gchar* type_selector);
gchar* data_source_get_typename (DataSource* self);
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home, const gchar* typename);
gboolean data_set_add_many (DataSet* self, GeeCollection* objects);
gboolean data_set_remove_many (DataSet* self, GeeCollection* objects);
void view_collection_select_marked (ViewCollection* self, Marker* marker);
void data_collection_act_on_marked (DataCollection* self, Marker* m, MarkedAction action, void* action_target, ProgressMonitor monitor, void* monitor_target, GObject* user);
static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_select_all (ViewCollection* self);
void marker_mark_all (Marker* self);
void data_view_internal_set_selected (DataView* self, gboolean selected);
void view_collection_unselect_marked (ViewCollection* self, Marker* marker);
static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_unselect_all (ViewCollection* self);
void marker_mark_many (Marker* self, GeeCollection* list);
GeeList* view_collection_get_selected (ViewCollection* self);
void view_collection_unselect_all_but (ViewCollection* self, DataView* exception);
void view_collection_unselect_and_select_marked (ViewCollection* self, Marker* unselect, Marker* select);
void view_collection_toggle_marked (ViewCollection* self, Marker* marker);
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void);
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type);
static GType view_collection_toggle_lists_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self);
gboolean data_view_internal_toggle (DataView* self);
gint view_collection_get_selected_count (ViewCollection* self);
DataView* view_collection_get_selected_at (ViewCollection* self, gint index);
DataSet* data_collection_get_dataset_copy (DataCollection* self);
gboolean view_collection_has_view_for_source_with_filtered (ViewCollection* self, DataSource* source);
DataView* view_collection_get_view_for_source_filtered (ViewCollection* self, DataSource* source);
GeeCollection* view_collection_get_sources (ViewCollection* self);
gboolean view_collection_has_source_of_type (ViewCollection* self, GType t);
gint view_collection_get_sources_of_type_count (ViewCollection* self, GType t);
GeeList* view_collection_get_sources_of_type (ViewCollection* self, GType t);
GeeList* view_collection_get_selected_sources (ViewCollection* self);
DataSource* view_collection_get_selected_source_at (ViewCollection* self, gint index);
GeeList* view_collection_get_selected_sources_of_type (ViewCollection* self, GType t);
gint view_collection_index_of_source (ViewCollection* self, DataSource* source);
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_thawed (DataCollection* base);
void data_collection_notify_thawed (DataCollection* self);
gboolean view_collection_are_items_filtered_out (ViewCollection* self);
void view_collection_items_selected (ViewCollection* self, GeeIterable* selected);
static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected);
void view_collection_items_unselected (ViewCollection* self, GeeIterable* unselected);
static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected);
void view_collection_items_state_changed (ViewCollection* self, GeeIterable* changed);
static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed);
void view_collection_selection_group_altered (ViewCollection* self);
static void view_collection_real_selection_group_altered (ViewCollection* self);
void view_collection_items_shown (ViewCollection* self, GeeCollection* visible);
static void view_collection_real_items_shown (ViewCollection* self, GeeCollection* visible);
void view_collection_items_hidden (ViewCollection* self, GeeCollection* hidden);
static void view_collection_real_items_hidden (ViewCollection* self, GeeCollection* hidden);
void view_collection_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
void view_collection_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views);
void view_collection_view_filter_installed (ViewCollection* self, ViewFilter* filer);
static void view_collection_real_view_filter_installed (ViewCollection* self, ViewFilter* filer);
static void g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
void view_collection_view_filter_removed (ViewCollection* self, ViewFilter* filer);
static void view_collection_real_view_filter_removed (ViewCollection* self, ViewFilter* filer);
enum  {
	VIEW_COLLECTION_MONITOR_DUMMY_PROPERTY
};
ViewCollectionMonitor* view_collection_monitor_new (void);
ViewCollectionMonitor* view_collection_monitor_construct (GType object_type);
static void view_collection_monitor_finalize (ViewCollectionMonitor* obj);
enum  {
	VIEW_COLLECTION_MONITOR_IMPL_DUMMY_PROPERTY
};
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self);
static void view_collection_monitor_impl_finalize (ViewCollectionMonitor* obj);
enum  {
	VIEW_COLLECTION_TOGGLE_LISTS_DUMMY_PROPERTY
};
static void view_collection_toggle_lists_finalize (GObject* obj);
static void view_collection_finalize (DataCollection* obj);
enum  {
	VIEW_MANAGER_DUMMY_PROPERTY
};
static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source);
static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source);
ViewManager* view_manager_construct (GType object_type);
static void view_manager_finalize (ViewManager* obj);
enum  {
	VIEW_FILTER_DUMMY_PROPERTY
};
static gboolean view_filter_real_predicate (ViewFilter* self, DataView* view);
ViewFilter* view_filter_construct (GType object_type);
void view_filter_refresh (ViewFilter* self);
static void view_filter_real_refresh (ViewFilter* self);
static void view_filter_finalize (ViewFilter* obj);


ViewCollection* view_collection_construct (GType object_type, const gchar* name) {
	ViewCollection* self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (ViewCollection*) data_collection_construct (object_type, name);
	return self;
}


ViewCollection* view_collection_new (const gchar* name) {
	return view_collection_construct (TYPE_VIEW_COLLECTION, name);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void view_collection_real_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected) {
	gboolean _tmp0_ = FALSE;
	gboolean has_selected;
	gboolean _tmp2_ = FALSE;
	gboolean has_unselected;
	GeeCollection* sum = NULL;
	gboolean _tmp4_ = FALSE;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail ((selected == NULL) || GEE_IS_COLLECTION (selected));
	g_return_if_fail ((unselected == NULL) || GEE_IS_COLLECTION (unselected));
	if (selected != NULL) {
		gint _tmp1_;
		_tmp1_ = gee_collection_get_size (selected);
		_tmp0_ = _tmp1_ > 0;
	} else {
		_tmp0_ = FALSE;
	}
	has_selected = _tmp0_;
	if (unselected != NULL) {
		gint _tmp3_;
		_tmp3_ = gee_collection_get_size (unselected);
		_tmp2_ = _tmp3_ > 0;
	} else {
		_tmp2_ = FALSE;
	}
	has_unselected = _tmp2_;
	if (has_selected) {
		g_signal_emit_by_name (self, "items-selected", GEE_ITERABLE (selected));
	}
	if (has_unselected) {
		g_signal_emit_by_name (self, "items-unselected", GEE_ITERABLE (unselected));
	}
	if (has_selected) {
		_tmp4_ = !has_unselected;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GeeCollection* _tmp5_;
		_tmp5_ = _g_object_ref0 (selected);
		_g_object_unref0 (sum);
		sum = _tmp5_;
	} else {
		gboolean _tmp6_ = FALSE;
		if (!has_selected) {
			_tmp6_ = has_unselected;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			GeeCollection* _tmp7_;
			_tmp7_ = _g_object_ref0 (unselected);
			_g_object_unref0 (sum);
			sum = _tmp7_;
		} else {
			gboolean _tmp8_ = FALSE;
			if (!has_selected) {
				_tmp8_ = !has_unselected;
			} else {
				_tmp8_ = FALSE;
			}
			if (_tmp8_) {
				_g_object_unref0 (sum);
				sum = NULL;
			} else {
				GeeHashSet* _tmp9_ = NULL;
				_tmp9_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
				_g_object_unref0 (sum);
				sum = GEE_COLLECTION (_tmp9_);
				gee_collection_add_all (sum, selected);
				gee_collection_add_all (sum, unselected);
			}
		}
	}
	if (sum != NULL) {
		g_signal_emit_by_name (self, "items-state-changed", GEE_ITERABLE (sum));
		view_collection_notify_selection_group_altered (self);
	}
	_g_object_unref0 (sum);
}


void view_collection_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected) {
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_selected_unselected (self, selected, unselected);
}


static void view_collection_real_notify_selection_group_altered (ViewCollection* self) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_signal_emit_by_name (self, "selection-group-altered");
}


void view_collection_notify_selection_group_altered (ViewCollection* self) {
	VIEW_COLLECTION_GET_CLASS (self)->notify_selection_group_altered (self);
}


static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_DATA_VIEW (view));
	g_signal_emit_by_name (self, "item-view-altered", view);
}


void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view) {
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_view_altered (self, view);
}


static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (views));
	g_signal_emit_by_name (self, "views-altered", views);
}


void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views) {
	VIEW_COLLECTION_GET_CLASS (self)->notify_views_altered (self, views);
}


static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_DATA_VIEW (view));
	g_signal_emit_by_name (self, "item-geometry-altered", view);
}


void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_geometry_altered (self, view);
}


static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (views));
	g_signal_emit_by_name (self, "geometries-altered", views);
}


void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
	VIEW_COLLECTION_GET_CLASS (self)->notify_geometries_altered (self, views);
}


static void view_collection_real_notify_items_shown (ViewCollection* self, GeeCollection* shown) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (shown));
	g_signal_emit_by_name (self, "items-shown", shown);
}


void view_collection_notify_items_shown (ViewCollection* self, GeeCollection* shown) {
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_shown (self, shown);
}


static void view_collection_real_notify_items_hidden (ViewCollection* self, GeeCollection* hidden) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (hidden));
	g_signal_emit_by_name (self, "items-hidden", hidden);
}


void view_collection_notify_items_hidden (ViewCollection* self, GeeCollection* hidden) {
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_hidden (self, hidden);
}


static void view_collection_real_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (changed));
	g_signal_emit_by_name (self, "items-visibility-changed", changed);
}


void view_collection_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_visibility_changed (self, changed);
}


static void view_collection_real_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_VIEW_FILTER (filter));
	g_signal_emit_by_name (self, "view-filter-installed", filter);
}


void view_collection_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter) {
	VIEW_COLLECTION_GET_CLASS (self)->notify_view_filter_installed (self, filter);
}


static void view_collection_real_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_VIEW_FILTER (filter));
	g_signal_emit_by_name (self, "view-filter-removed", filter);
}


void view_collection_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter) {
	VIEW_COLLECTION_GET_CLASS (self)->notify_view_filter_removed (self, filter);
}


static void view_collection_real_clear (DataCollection* base) {
	ViewCollection * self;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	self = VIEW_COLLECTION (base);
	_tmp1_ = gee_multi_map_get_size (GEE_MULTI_MAP (self->priv->monitors));
	if (_tmp1_ > 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->mirroring != NULL;
	}
	if (_tmp0_) {
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		_tmp2_ = data_collection_to_string (DATA_COLLECTION (self));
		_tmp3_ = _tmp2_;
		g_warning ("ViewCollection.vala:204: Cannot clear %s: monitoring or mirroring in e" \
"ffect", _tmp3_);
		_g_free0 (_tmp3_);
		return;
	}
	DATA_COLLECTION_CLASS (view_collection_parent_class)->clear (DATA_COLLECTION (self));
}


static void _view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender, gpointer self) {
	view_collection_on_view_filter_refresh (self);
}


static void view_collection_real_close (DataCollection* base) {
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
	view_collection_halt_all_monitoring (self);
	view_collection_halt_mirroring (self);
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _f_it;
		_tmp0_ = gee_iterable_iterator (GEE_ITERABLE (self->priv->filters));
		_f_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			ViewFilter* f;
			guint _tmp3_;
			_tmp1_ = gee_iterator_next (_f_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_f_it);
			f = (ViewFilter*) _tmp2_;
			g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp3_, NULL, FALSE);
			g_signal_handlers_disconnect_matched (f, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
			_view_filter_unref0 (f);
		}
		_g_object_unref0 (_f_it);
	}
	gee_collection_clear (GEE_COLLECTION (self->priv->filters));
	DATA_COLLECTION_CLASS (view_collection_parent_class)->close (DATA_COLLECTION (self));
}


ViewCollectionMonitor* view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, Alteration* prereq, GeeCollection* initial, ProgressMonitor progress_monitor, void* progress_monitor_target) {
	ViewCollectionMonitor* result = NULL;
	ViewCollectionMonitorImpl* _tmp0_ = NULL;
	ViewCollectionMonitorImpl* monitor;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
	g_return_val_if_fail (IS_VIEW_MANAGER (manager), NULL);
	g_return_val_if_fail ((prereq == NULL) || IS_ALTERATION (prereq), NULL);
	g_return_val_if_fail ((initial == NULL) || GEE_IS_COLLECTION (initial), NULL);
	view_collection_halt_mirroring (self);
	data_collection_freeze_notifications (DATA_COLLECTION (self));
	_tmp0_ = view_collection_monitor_impl_new (self, sources, manager, prereq);
	monitor = _tmp0_;
	gee_multi_map_set (GEE_MULTI_MAP (self->priv->monitors), sources, monitor);
	if (initial != NULL) {
		gint _tmp2_;
		_tmp2_ = gee_collection_get_size (initial);
		_tmp1_ = _tmp2_ > 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GeeArrayList* _tmp3_ = NULL;
		GeeArrayList* created_views;
		GeeCollection* _tmp9_ = NULL;
		GeeCollection* _tmp10_;
		_tmp3_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
		created_views = _tmp3_;
		{
			GeeIterator* _tmp4_ = NULL;
			GeeIterator* _source_it;
			_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (initial));
			_source_it = _tmp4_;
			while (TRUE) {
				gboolean _tmp5_;
				gpointer _tmp6_ = NULL;
				DataSource* source;
				DataView* _tmp7_ = NULL;
				DataView* _tmp8_;
				_tmp5_ = gee_iterator_next (_source_it);
				if (!_tmp5_) {
					break;
				}
				_tmp6_ = gee_iterator_get (_source_it);
				source = (DataSource*) _tmp6_;
				_tmp7_ = view_manager_create_view (manager, source);
				_tmp8_ = _tmp7_;
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), _tmp8_);
				_g_object_unref0 (_tmp8_);
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
		_tmp9_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (created_views), progress_monitor, progress_monitor_target);
		_tmp10_ = _tmp9_;
		_g_object_unref0 (_tmp10_);
		_g_object_unref0 (created_views);
	} else {
		GeeCollection* _tmp11_ = NULL;
		GeeIterable* _tmp12_;
		_tmp11_ = data_collection_get_all (DATA_COLLECTION (sources));
		_tmp12_ = GEE_ITERABLE (_tmp11_);
		view_collection_add_sources (self, sources, _tmp12_, progress_monitor, progress_monitor_target);
		_g_object_unref0 (_tmp12_);
	}
	data_collection_thaw_notifications (DATA_COLLECTION (self));
	result = VIEW_COLLECTION_MONITOR (monitor);
	return result;
}


static gpointer _view_collection_monitor_ref0 (gpointer self) {
	return self ? view_collection_monitor_ref (self) : NULL;
}


void view_collection_halt_monitoring (ViewCollection* self, ViewCollectionMonitor* m) {
	ViewCollectionMonitorImpl* _tmp0_;
	ViewCollectionMonitorImpl* monitor;
	gboolean _tmp1_;
	gboolean removed;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (VIEW_COLLECTION_IS_MONITOR (m));
	_tmp0_ = _view_collection_monitor_ref0 (VIEW_COLLECTION_MONITOR_IMPL (m));
	monitor = _tmp0_;
	_tmp1_ = gee_multi_map_remove (GEE_MULTI_MAP (self->priv->monitors), monitor->sources, monitor);
	removed = _tmp1_;
	g_assert (removed);
	_view_collection_monitor_unref0 (monitor);
}


void view_collection_halt_all_monitoring (ViewCollection* self) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	gee_multi_map_clear (GEE_MULTI_MAP (self->priv->monitors));
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
	view_collection_on_mirror_contents_added (self, added);
}


static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
	view_collection_on_mirror_contents_removed (self, removed);
}


void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target, CreateViewPredicate should_mirror, void* should_mirror_target) {
	ViewCollection* _tmp0_;
	CreateView _tmp1_;
	CreateViewPredicate _tmp2_;
	void* _tmp3_ = NULL;
	GDestroyNotify _tmp4_ = NULL;
	Comparator _tmp5_ = NULL;
	Comparator _tmp6_;
	void* _tmp6__target = NULL;
	GDestroyNotify _tmp6__target_destroy_notify = NULL;
	void* _tmp7_ = NULL;
	GDestroyNotify _tmp8_ = NULL;
	ComparatorPredicate _tmp9_ = NULL;
	ComparatorPredicate _tmp10_;
	void* _tmp10__target = NULL;
	GDestroyNotify _tmp10__target_destroy_notify = NULL;
	GeeCollection* _tmp11_ = NULL;
	GeeCollection* _tmp12_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_VIEW_COLLECTION (to_mirror));
	view_collection_halt_mirroring (self);
	view_collection_halt_all_monitoring (self);
	data_collection_clear (DATA_COLLECTION (self));
	_tmp0_ = _data_collection_ref0 (to_mirror);
	_data_collection_unref0 (self->priv->mirroring);
	self->priv->mirroring = _tmp0_;
	_tmp1_ = mirroring_ctor;
	(self->priv->mirroring_ctor_target_destroy_notify == NULL) ? NULL : (self->priv->mirroring_ctor_target_destroy_notify (self->priv->mirroring_ctor_target), NULL);
	self->priv->mirroring_ctor = NULL;
	self->priv->mirroring_ctor_target = NULL;
	self->priv->mirroring_ctor_target_destroy_notify = NULL;
	self->priv->mirroring_ctor = _tmp1_;
	self->priv->mirroring_ctor_target = mirroring_ctor_target;
	self->priv->mirroring_ctor_target_destroy_notify = NULL;
	_tmp2_ = should_mirror;
	(self->priv->should_mirror_target_destroy_notify == NULL) ? NULL : (self->priv->should_mirror_target_destroy_notify (self->priv->should_mirror_target), NULL);
	self->priv->should_mirror = NULL;
	self->priv->should_mirror_target = NULL;
	self->priv->should_mirror_target_destroy_notify = NULL;
	self->priv->should_mirror = _tmp2_;
	self->priv->should_mirror_target = should_mirror_target;
	self->priv->should_mirror_target_destroy_notify = NULL;
	_tmp5_ = data_collection_get_comparator (DATA_COLLECTION (to_mirror), &_tmp3_, &_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp6__target = _tmp3_;
	_tmp6__target_destroy_notify = _tmp4_;
	_tmp9_ = data_collection_get_comparator_predicate (DATA_COLLECTION (to_mirror), &_tmp7_, &_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp10__target = _tmp7_;
	_tmp10__target_destroy_notify = _tmp8_;
	data_collection_set_comparator (DATA_COLLECTION (self), _tmp6_, _tmp3_, _tmp10_, _tmp7_);
	(_tmp10__target_destroy_notify == NULL) ? NULL : (_tmp10__target_destroy_notify (_tmp10__target), NULL);
	_tmp10_ = NULL;
	_tmp10__target = NULL;
	_tmp10__target_destroy_notify = NULL;
	(_tmp6__target_destroy_notify == NULL) ? NULL : (_tmp6__target_destroy_notify (_tmp6__target), NULL);
	_tmp6_ = NULL;
	_tmp6__target = NULL;
	_tmp6__target_destroy_notify = NULL;
	_tmp11_ = data_collection_get_all (DATA_COLLECTION (self->priv->mirroring));
	_tmp12_ = _tmp11_;
	view_collection_on_mirror_contents_added (self, GEE_ITERABLE (_tmp12_));
	_g_object_unref0 (_tmp12_);
	g_signal_connect (DATA_COLLECTION (self->priv->mirroring), "items-added", (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
	g_signal_connect (DATA_COLLECTION (self->priv->mirroring), "items-removed", (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
}


void view_collection_halt_mirroring (ViewCollection* self) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	if (self->priv->mirroring != NULL) {
		guint _tmp0_;
		guint _tmp1_;
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->mirroring), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->mirroring), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
	}
	_data_collection_unref0 (self->priv->mirroring);
	self->priv->mirroring = NULL;
}


void view_collection_copy_into (ViewCollection* self, ViewCollection* to_copy, CreateView copying_ctor, void* copying_ctor_target, CreateViewPredicate should_copy, void* should_copy_target) {
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* copy_view;
	GeeCollection* _tmp16_ = NULL;
	GeeCollection* _tmp17_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_VIEW_COLLECTION (to_copy));
	_tmp0_ = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	copy_view = _tmp0_;
	{
		GeeCollection* _tmp1_ = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _tmp4_;
		GeeIterator* _object_it;
		_tmp1_ = data_collection_get_all (DATA_COLLECTION (to_copy));
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_));
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_object_it = _tmp4_;
		while (TRUE) {
			gboolean _tmp5_;
			gpointer _tmp6_ = NULL;
			DataObject* object;
			DataView* _tmp7_;
			DataView* view;
			DataSource* _tmp8_ = NULL;
			DataSource* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			_tmp5_ = gee_iterator_next (_object_it);
			if (!_tmp5_) {
				break;
			}
			_tmp6_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp6_;
			_tmp7_ = _g_object_ref0 (DATA_VIEW (object));
			view = _tmp7_;
			_tmp8_ = data_view_get_source (view);
			_tmp9_ = _tmp8_;
			_tmp10_ = should_copy (_tmp9_, should_copy_target);
			_tmp11_ = _tmp10_;
			_g_object_unref0 (_tmp9_);
			if (_tmp11_) {
				DataSource* _tmp12_ = NULL;
				DataSource* _tmp13_;
				DataView* _tmp14_ = NULL;
				DataView* _tmp15_;
				_tmp12_ = data_view_get_source (view);
				_tmp13_ = _tmp12_;
				_tmp14_ = copying_ctor (_tmp13_, copying_ctor_target);
				_tmp15_ = _tmp14_;
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (copy_view), DATA_OBJECT (_tmp15_));
				_g_object_unref0 (_tmp15_);
				_g_object_unref0 (_tmp13_);
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	_tmp16_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (copy_view), NULL, NULL);
	_tmp17_ = _tmp16_;
	_g_object_unref0 (_tmp17_);
	_g_object_unref0 (copy_view);
}


gboolean view_collection_is_view_filter_installed (ViewCollection* self, ViewFilter* f) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_VIEW_FILTER (f), FALSE);
	_tmp0_ = gee_collection_contains (GEE_COLLECTION (self->priv->filters), f);
	result = _tmp0_;
	return result;
}


void view_collection_install_view_filter (ViewCollection* self, ViewFilter* f) {
	gboolean _tmp0_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_VIEW_FILTER (f));
	_tmp0_ = view_collection_is_view_filter_installed (self, f);
	if (_tmp0_) {
		return;
	}
	gee_collection_add (GEE_COLLECTION (self->priv->filters), f);
	g_signal_connect (f, "refresh", (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
	view_collection_on_view_filter_refresh (self);
	view_collection_notify_view_filter_installed (self, f);
}


void view_collection_remove_view_filter (ViewCollection* self, ViewFilter* f) {
	gboolean _tmp0_;
	guint _tmp1_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_VIEW_FILTER (f));
	_tmp0_ = view_collection_is_view_filter_installed (self, f);
	if (!_tmp0_) {
		return;
	}
	gee_collection_remove (GEE_COLLECTION (self->priv->filters), f);
	g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (f, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
	view_collection_on_view_filter_refresh (self);
	view_collection_notify_view_filter_removed (self, f);
}


static void view_collection_on_view_filter_refresh (ViewCollection* self) {
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self));
	_tmp1_ = GEE_COLLECTION (_tmp0_);
	view_collection_filter_altered_items (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
}


static gboolean view_collection_is_in_filter (ViewCollection* self, DataView* view) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _f_it;
		_tmp0_ = gee_iterable_iterator (GEE_ITERABLE (self->priv->filters));
		_f_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			ViewFilter* f;
			gboolean _tmp3_;
			_tmp1_ = gee_iterator_next (_f_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_f_it);
			f = (ViewFilter*) _tmp2_;
			_tmp3_ = view_filter_predicate (f, view);
			if (!_tmp3_) {
				result = FALSE;
				_view_filter_unref0 (f);
				_g_object_unref0 (_f_it);
				return result;
			}
			_view_filter_unref0 (f);
		}
		_g_object_unref0 (_f_it);
	}
	result = TRUE;
	return result;
}


static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gboolean result = FALSE;
	self = VIEW_COLLECTION (base);
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
	result = IS_DATA_VIEW (object);
	return result;
}


static void view_collection_on_sources_added (ViewCollection* self, DataCollection* sources, GeeIterable* added) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_DATA_COLLECTION (sources));
	g_return_if_fail (GEE_IS_ITERABLE (added));
	view_collection_add_sources (self, SOURCE_COLLECTION (sources), added, NULL, NULL);
}


static DataView* _view_manager_create_view_create_view (DataSource* source, gpointer self) {
	DataView* result;
	result = view_manager_create_view (self, source);
	return result;
}


static void view_collection_add_sources (ViewCollection* self, SourceCollection* sources, GeeIterable* added, ProgressMonitor progress_monitor, void* progress_monitor_target) {
	DataView* created_view;
	GeeArrayList* created_views;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
	g_return_if_fail (GEE_IS_ITERABLE (added));
	created_view = NULL;
	created_views = NULL;
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _source_it;
		_tmp0_ = gee_iterable_iterator (added);
		_source_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			DataSource* source;
			CreateView factory;
			void* factory_target = NULL;
			GDestroyNotify factory_target_destroy_notify = NULL;
			_tmp1_ = gee_iterator_next (_source_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_source_it);
			source = (DataSource*) _tmp2_;
			factory = NULL;
			factory_target = NULL;
			factory_target_destroy_notify = NULL;
			{
				GeeCollection* _tmp3_ = NULL;
				GeeCollection* _tmp4_;
				GeeIterator* _tmp5_ = NULL;
				GeeIterator* _tmp6_;
				GeeIterator* _monitor_it;
				_tmp3_ = gee_multi_map_get (GEE_MULTI_MAP (self->priv->monitors), sources);
				_tmp4_ = _tmp3_;
				_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (_tmp4_));
				_tmp6_ = _tmp5_;
				_g_object_unref0 (_tmp4_);
				_monitor_it = _tmp6_;
				while (TRUE) {
					gboolean _tmp7_;
					gpointer _tmp8_ = NULL;
					ViewCollectionMonitorImpl* monitor;
					gboolean _tmp9_;
					_tmp7_ = gee_iterator_next (_monitor_it);
					if (!_tmp7_) {
						break;
					}
					_tmp8_ = gee_iterator_get (_monitor_it);
					monitor = (ViewCollectionMonitorImpl*) _tmp8_;
					_tmp9_ = view_manager_include_in_view (monitor->manager, source);
					if (_tmp9_) {
						(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
						factory = NULL;
						factory_target = NULL;
						factory_target_destroy_notify = NULL;
						factory = _view_manager_create_view_create_view;
						factory_target = view_manager_ref (monitor->manager);
						factory_target_destroy_notify = view_manager_unref;
						_view_collection_monitor_unref0 (monitor);
						break;
					}
					_view_collection_monitor_unref0 (monitor);
				}
				_g_object_unref0 (_monitor_it);
			}
			if (factory != NULL) {
				DataView* _tmp10_ = NULL;
				DataView* new_view;
				_tmp10_ = factory (source, factory_target);
				new_view = _tmp10_;
				if (created_views != NULL) {
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), new_view);
				} else {
					if (created_view == NULL) {
						DataView* _tmp11_;
						_tmp11_ = _g_object_ref0 (new_view);
						_g_object_unref0 (created_view);
						created_view = _tmp11_;
					} else {
						GeeArrayList* _tmp12_ = NULL;
						_tmp12_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
						_g_object_unref0 (created_views);
						created_views = _tmp12_;
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), created_view);
						_g_object_unref0 (created_view);
						created_view = NULL;
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), new_view);
					}
				}
				_g_object_unref0 (new_view);
			}
			(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
			factory = NULL;
			factory_target = NULL;
			factory_target_destroy_notify = NULL;
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	if (created_view != NULL) {
		data_collection_add (DATA_COLLECTION (self), DATA_OBJECT (created_view));
	} else {
		gboolean _tmp13_ = FALSE;
		if (created_views != NULL) {
			gint _tmp14_;
			_tmp14_ = gee_collection_get_size (GEE_COLLECTION (created_views));
			_tmp13_ = _tmp14_ > 0;
		} else {
			_tmp13_ = FALSE;
		}
		if (_tmp13_) {
			GeeCollection* _tmp15_ = NULL;
			GeeCollection* _tmp16_;
			_tmp15_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (created_views), progress_monitor, progress_monitor_target);
			_tmp16_ = _tmp15_;
			_g_object_unref0 (_tmp16_);
		}
	}
	_g_object_unref0 (created_views);
	_g_object_unref0 (created_view);
}


static gboolean view_collection_real_add (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* _tmp2_;
	self = VIEW_COLLECTION (base);
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
	data_view_internal_set_visible (DATA_VIEW (object), TRUE);
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->add (DATA_COLLECTION (self), object);
	if (!_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = data_collection_get_singleton (object);
	_tmp2_ = GEE_COLLECTION (_tmp1_);
	view_collection_filter_altered_items (self, _tmp2_);
	_g_object_unref0 (_tmp2_);
	result = TRUE;
	return result;
}


static GeeCollection* view_collection_real_add_many (DataCollection* base, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target) {
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* _tmp3_ = NULL;
	GeeCollection* return_list;
	self = VIEW_COLLECTION (base);
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), NULL);
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _object_it;
		_tmp0_ = gee_iterable_iterator (GEE_ITERABLE (objects));
		_object_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			DataObject* object;
			_tmp1_ = gee_iterator_next (_object_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp2_;
			data_view_internal_set_visible (DATA_VIEW (object), TRUE);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	_tmp3_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->add_many (DATA_COLLECTION (self), objects, monitor, monitor_target);
	return_list = _tmp3_;
	view_collection_filter_altered_items (self, GEE_COLLECTION (return_list));
	result = return_list;
	return result;
}


static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed) {
	Marker* marker;
	gboolean _tmp5_ = FALSE;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_ITERABLE (removed));
	marker = NULL;
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _source_it;
		_tmp0_ = gee_iterable_iterator (removed);
		_source_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			DataSource* source;
			gpointer _tmp3_ = NULL;
			DataView* view;
			_tmp1_ = gee_iterator_next (_source_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_source_it);
			source = (DataSource*) _tmp2_;
			_tmp3_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->source_map), source);
			view = (DataView*) _tmp3_;
			if (view != NULL) {
				if (marker == NULL) {
					Marker* _tmp4_ = NULL;
					_tmp4_ = data_collection_start_marking (DATA_COLLECTION (self));
					_g_object_unref0 (marker);
					marker = _tmp4_;
				}
				marker_mark (marker, DATA_OBJECT (view));
			}
			_g_object_unref0 (view);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	if (marker != NULL) {
		gint _tmp6_;
		_tmp6_ = marker_get_count (marker);
		_tmp5_ = _tmp6_ != 0;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		data_collection_remove_marked (DATA_COLLECTION (self), marker);
	}
	_g_object_unref0 (marker);
}


static void view_collection_on_sources_altered (ViewCollection* self, DataCollection* collection, GeeMap* items) {
	GeeArrayList* to_add;
	GeeArrayList* to_remove;
	gboolean ordering_changed;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_DATA_COLLECTION (collection));
	g_return_if_fail (GEE_IS_MAP (items));
	to_add = NULL;
	to_remove = NULL;
	ordering_changed = FALSE;
	{
		GeeSet* _tmp0_ = NULL;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _tmp3_;
		GeeIterator* _object_it;
		_tmp0_ = gee_map_get_keys (items);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_object_it = _tmp3_;
		while (TRUE) {
			gboolean _tmp4_;
			gpointer _tmp5_ = NULL;
			DataObject* object;
			gpointer _tmp6_ = NULL;
			Alteration* alteration;
			DataSource* _tmp7_;
			DataSource* source;
			ViewCollectionMonitorImpl* monitor;
			gboolean ignored;
			gboolean _tmp18_ = FALSE;
			_tmp4_ = gee_iterator_next (_object_it);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp5_;
			_tmp6_ = gee_map_get (items, object);
			alteration = (Alteration*) _tmp6_;
			_tmp7_ = _g_object_ref0 (DATA_SOURCE (object));
			source = _tmp7_;
			monitor = NULL;
			ignored = TRUE;
			{
				GeeCollection* _tmp8_ = NULL;
				GeeCollection* _tmp9_;
				GeeIterator* _tmp10_ = NULL;
				GeeIterator* _tmp11_;
				GeeIterator* _monitor_impl_it;
				_tmp8_ = gee_multi_map_get (GEE_MULTI_MAP (self->priv->monitors), SOURCE_COLLECTION (collection));
				_tmp9_ = _tmp8_;
				_tmp10_ = gee_iterable_iterator (GEE_ITERABLE (_tmp9_));
				_tmp11_ = _tmp10_;
				_g_object_unref0 (_tmp9_);
				_monitor_impl_it = _tmp11_;
				while (TRUE) {
					gboolean _tmp12_;
					gpointer _tmp13_ = NULL;
					ViewCollectionMonitorImpl* monitor_impl;
					gboolean _tmp14_ = FALSE;
					gboolean _tmp16_;
					_tmp12_ = gee_iterator_next (_monitor_impl_it);
					if (!_tmp12_) {
						break;
					}
					_tmp13_ = gee_iterator_get (_monitor_impl_it);
					monitor_impl = (ViewCollectionMonitorImpl*) _tmp13_;
					if (monitor_impl->prereq != NULL) {
						gboolean _tmp15_;
						_tmp15_ = alteration_contains_any (alteration, monitor_impl->prereq);
						_tmp14_ = !_tmp15_;
					} else {
						_tmp14_ = FALSE;
					}
					if (_tmp14_) {
						_view_collection_monitor_unref0 (monitor_impl);
						continue;
					}
					ignored = FALSE;
					_tmp16_ = view_manager_include_in_view (monitor_impl->manager, source);
					if (_tmp16_) {
						ViewCollectionMonitorImpl* _tmp17_;
						_tmp17_ = _view_collection_monitor_ref0 (monitor_impl);
						_view_collection_monitor_unref0 (monitor);
						monitor = _tmp17_;
						_view_collection_monitor_unref0 (monitor_impl);
						break;
					}
					_view_collection_monitor_unref0 (monitor_impl);
				}
				_g_object_unref0 (_monitor_impl_it);
			}
			if (ignored) {
				g_assert (monitor == NULL);
				_view_collection_monitor_unref0 (monitor);
				_g_object_unref0 (source);
				_alteration_unref0 (alteration);
				_g_object_unref0 (object);
				continue;
			}
			if (monitor != NULL) {
				gboolean _tmp19_;
				_tmp19_ = view_collection_has_view_for_source (self, source);
				_tmp18_ = !_tmp19_;
			} else {
				_tmp18_ = FALSE;
			}
			if (_tmp18_) {
				DataView* _tmp21_ = NULL;
				DataView* _tmp22_;
				if (to_add == NULL) {
					GeeArrayList* _tmp20_ = NULL;
					_tmp20_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
					_g_object_unref0 (to_add);
					to_add = _tmp20_;
				}
				_tmp21_ = view_manager_create_view (monitor->manager, source);
				_tmp22_ = _tmp21_;
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_add), _tmp22_);
				_g_object_unref0 (_tmp22_);
			} else {
				gboolean _tmp23_ = FALSE;
				if (monitor == NULL) {
					gboolean _tmp24_;
					_tmp24_ = view_collection_has_view_for_source (self, source);
					_tmp23_ = _tmp24_;
				} else {
					_tmp23_ = FALSE;
				}
				if (_tmp23_) {
					DataView* _tmp26_ = NULL;
					DataView* _tmp27_;
					if (to_remove == NULL) {
						GeeArrayList* _tmp25_ = NULL;
						_tmp25_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
						_g_object_unref0 (to_remove);
						to_remove = _tmp25_;
					}
					_tmp26_ = view_collection_get_view_for_source (self, source);
					_tmp27_ = _tmp26_;
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_remove), _tmp27_);
					_g_object_unref0 (_tmp27_);
				} else {
					gboolean _tmp28_ = FALSE;
					if (monitor != NULL) {
						gboolean _tmp29_;
						_tmp29_ = view_collection_has_view_for_source (self, source);
						_tmp28_ = _tmp29_;
					} else {
						_tmp28_ = FALSE;
					}
					if (_tmp28_) {
						DataView* _tmp30_ = NULL;
						DataView* view;
						gboolean _tmp31_;
						gboolean _tmp32_ = FALSE;
						_tmp30_ = view_collection_get_view_for_source (self, source);
						view = _tmp30_;
						_tmp31_ = data_set_contains (self->priv->selected, DATA_OBJECT (view));
						if (_tmp31_) {
							data_set_resort_object (self->priv->selected, DATA_OBJECT (view), alteration);
						}
						if (self->priv->visible != NULL) {
							gboolean _tmp33_;
							_tmp33_ = view_collection_is_visible (self, view);
							_tmp32_ = _tmp33_;
						} else {
							_tmp32_ = FALSE;
						}
						if (_tmp32_) {
							gboolean _tmp34_;
							_tmp34_ = data_set_resort_object (self->priv->visible, DATA_OBJECT (view), alteration);
							if (_tmp34_) {
								ordering_changed = TRUE;
							}
						}
						_g_object_unref0 (view);
					}
				}
			}
			_view_collection_monitor_unref0 (monitor);
			_g_object_unref0 (source);
			_alteration_unref0 (alteration);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	if (to_add != NULL) {
		GeeCollection* _tmp35_ = NULL;
		GeeCollection* _tmp36_;
		_tmp35_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (to_add), NULL, NULL);
		_tmp36_ = _tmp35_;
		_g_object_unref0 (_tmp36_);
	}
	if (to_remove != NULL) {
		Marker* _tmp37_ = NULL;
		Marker* _tmp38_;
		_tmp37_ = data_collection_mark_many (DATA_COLLECTION (self), GEE_COLLECTION (to_remove));
		_tmp38_ = _tmp37_;
		data_collection_remove_marked (DATA_COLLECTION (self), _tmp38_);
		_g_object_unref0 (_tmp38_);
	}
	if (ordering_changed) {
		data_collection_notify_ordering_changed (DATA_COLLECTION (self));
	}
	_g_object_unref0 (to_remove);
	_g_object_unref0 (to_add);
}


static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added) {
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* to_add;
	gint _tmp9_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_ITERABLE (added));
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	to_add = _tmp0_;
	{
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _object_it;
		_tmp1_ = gee_iterable_iterator (added);
		_object_it = _tmp1_;
		while (TRUE) {
			gboolean _tmp2_;
			gpointer _tmp3_ = NULL;
			DataObject* object;
			DataSource* _tmp4_ = NULL;
			DataSource* source;
			gboolean _tmp5_ = FALSE;
			_tmp2_ = gee_iterator_next (_object_it);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp3_;
			_tmp4_ = data_view_get_source (DATA_VIEW (object));
			source = _tmp4_;
			if (self->priv->should_mirror == NULL) {
				_tmp5_ = TRUE;
			} else {
				gboolean _tmp6_;
				_tmp6_ = self->priv->should_mirror (source, self->priv->should_mirror_target);
				_tmp5_ = _tmp6_;
			}
			if (_tmp5_) {
				DataView* _tmp7_ = NULL;
				DataView* _tmp8_;
				_tmp7_ = self->priv->mirroring_ctor (source, self->priv->mirroring_ctor_target);
				_tmp8_ = _tmp7_;
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_add), _tmp8_);
				_g_object_unref0 (_tmp8_);
			}
			_g_object_unref0 (source);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	_tmp9_ = gee_collection_get_size (GEE_COLLECTION (to_add));
	if (_tmp9_ > 0) {
		GeeCollection* _tmp10_ = NULL;
		GeeCollection* _tmp11_;
		_tmp10_ = data_collection_add_many (DATA_COLLECTION (self), GEE_COLLECTION (to_add), NULL, NULL);
		_tmp11_ = _tmp10_;
		_g_object_unref0 (_tmp11_);
	}
	_g_object_unref0 (to_add);
}


static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed) {
	Marker* _tmp0_ = NULL;
	Marker* marker;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_ITERABLE (removed));
	_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self));
	marker = _tmp0_;
	{
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _object_it;
		_tmp1_ = gee_iterable_iterator (removed);
		_object_it = _tmp1_;
		while (TRUE) {
			gboolean _tmp2_;
			gpointer _tmp3_ = NULL;
			DataObject* object;
			DataView* _tmp4_;
			DataView* view;
			DataSource* _tmp5_ = NULL;
			DataSource* _tmp6_;
			DataView* _tmp7_ = NULL;
			DataView* _tmp8_;
			DataView* our_view;
			_tmp2_ = gee_iterator_next (_object_it);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp3_;
			_tmp4_ = _g_object_ref0 (DATA_VIEW (object));
			view = _tmp4_;
			_tmp5_ = data_view_get_source (view);
			_tmp6_ = _tmp5_;
			_tmp7_ = view_collection_get_view_for_source (self, _tmp6_);
			_tmp8_ = _tmp7_;
			_g_object_unref0 (_tmp6_);
			our_view = _tmp8_;
			g_assert (our_view != NULL);
			marker_mark (marker, DATA_OBJECT (our_view));
			_g_object_unref0 (our_view);
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	data_collection_remove_marked (DATA_COLLECTION (self), marker);
	_g_object_unref0 (marker);
}


static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added) {
	ViewCollection * self;
	GeeArrayList* added_visible;
	GeeArrayList* added_selected;
	self = VIEW_COLLECTION (base);
	g_return_if_fail (GEE_IS_ITERABLE (added));
	added_visible = NULL;
	added_selected = NULL;
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _object_it;
		_tmp0_ = gee_iterable_iterator (added);
		_object_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			DataObject* object;
			DataView* _tmp3_;
			DataView* view;
			DataSource* _tmp4_ = NULL;
			DataSource* _tmp5_;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_;
			_tmp1_ = gee_iterator_next (_object_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp2_;
			_tmp3_ = _g_object_ref0 (DATA_VIEW (object));
			view = _tmp3_;
			_tmp4_ = data_view_get_source (view);
			_tmp5_ = _tmp4_;
			gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->source_map), _tmp5_, view);
			_g_object_unref0 (_tmp5_);
			_tmp7_ = data_view_is_selected (view);
			if (_tmp7_) {
				gboolean _tmp8_;
				_tmp8_ = data_view_is_visible (view);
				_tmp6_ = _tmp8_;
			} else {
				_tmp6_ = FALSE;
			}
			if (_tmp6_) {
				if (added_selected == NULL) {
					GeeArrayList* _tmp9_ = NULL;
					_tmp9_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
					_g_object_unref0 (added_selected);
					added_selected = _tmp9_;
				}
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_selected), view);
			}
			_tmp11_ = data_view_is_visible (view);
			if (_tmp11_) {
				_tmp10_ = self->priv->visible != NULL;
			} else {
				_tmp10_ = FALSE;
			}
			if (_tmp10_) {
				if (added_visible == NULL) {
					GeeArrayList* _tmp12_ = NULL;
					_tmp12_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
					_g_object_unref0 (added_visible);
					added_visible = _tmp12_;
				}
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_visible), view);
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	if (added_visible != NULL) {
		gboolean _tmp13_;
		gboolean is_added;
		_tmp13_ = view_collection_add_many_visible (self, GEE_COLLECTION (added_visible));
		is_added = _tmp13_;
		g_assert (is_added);
	}
	if (added_selected != NULL) {
		view_collection_add_many_selected (self, GEE_COLLECTION (added_selected));
		view_collection_notify_items_selected_unselected (self, GEE_COLLECTION (added_selected), NULL);
	}
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_added (DATA_COLLECTION (self), added);
	_g_object_unref0 (added_selected);
	_g_object_unref0 (added_visible);
}


static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed) {
	ViewCollection * self;
	GeeArrayList* selected_removed;
	self = VIEW_COLLECTION (base);
	g_return_if_fail (GEE_IS_ITERABLE (removed));
	selected_removed = NULL;
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _object_it;
		_tmp0_ = gee_iterable_iterator (removed);
		_object_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			DataObject* object;
			DataView* _tmp3_;
			DataView* view;
			DataSource* _tmp4_ = NULL;
			DataSource* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
			gboolean is_removed;
			gboolean _tmp8_;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_;
			_tmp1_ = gee_iterator_next (_object_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp2_;
			_tmp3_ = _g_object_ref0 (DATA_VIEW (object));
			view = _tmp3_;
			_tmp4_ = data_view_get_source (view);
			_tmp5_ = _tmp4_;
			_tmp6_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->source_map), _tmp5_, NULL);
			_tmp7_ = _tmp6_;
			_g_object_unref0 (_tmp5_);
			is_removed = _tmp7_;
			g_assert (is_removed);
			_tmp8_ = data_view_is_selected (view);
			if (_tmp8_) {
				gboolean _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
				_tmp9_ = data_set_contains (self->priv->selected, DATA_OBJECT (view));
				_tmp10_ = data_view_is_visible (view);
				g_assert (_tmp9_ == _tmp10_);
				_tmp11_ = data_view_is_visible (view);
				if (_tmp11_) {
					if (selected_removed == NULL) {
						GeeArrayList* _tmp12_ = NULL;
						_tmp12_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
						_g_object_unref0 (selected_removed);
						selected_removed = _tmp12_;
					}
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (selected_removed), view);
				}
			}
			_tmp14_ = data_view_is_visible (view);
			if (_tmp14_) {
				_tmp13_ = self->priv->visible != NULL;
			} else {
				_tmp13_ = FALSE;
			}
			if (_tmp13_) {
				gboolean _tmp15_;
				_tmp15_ = data_set_remove (self->priv->visible, DATA_OBJECT (view));
				is_removed = _tmp15_;
				g_assert (is_removed);
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	if (selected_removed != NULL) {
		view_collection_remove_many_selected (self, GEE_COLLECTION (selected_removed));
		view_collection_notify_selection_group_altered (self);
	}
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_removed (DATA_COLLECTION (self), removed);
	_g_object_unref0 (selected_removed);
}


static void view_collection_filter_altered_items (ViewCollection* self, GeeCollection* views) {
	GeeArrayList* to_show;
	GeeArrayList* to_hide;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (views));
	to_show = NULL;
	to_hide = NULL;
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _view_it;
		_tmp0_ = gee_iterable_iterator (GEE_ITERABLE (views));
		_view_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			DataView* view;
			gboolean _tmp3_;
			_tmp1_ = gee_iterator_next (_view_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_view_it);
			view = (DataView*) _tmp2_;
			_tmp3_ = view_collection_is_in_filter (self, view);
			if (_tmp3_) {
				gboolean _tmp4_;
				_tmp4_ = data_view_is_visible (view);
				if (!_tmp4_) {
					if (to_show == NULL) {
						GeeArrayList* _tmp5_ = NULL;
						_tmp5_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
						_g_object_unref0 (to_show);
						to_show = _tmp5_;
					}
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), view);
				}
			} else {
				gboolean _tmp6_;
				_tmp6_ = data_view_is_visible (view);
				if (_tmp6_) {
					if (to_hide == NULL) {
						GeeArrayList* _tmp7_ = NULL;
						_tmp7_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
						_g_object_unref0 (to_hide);
						to_hide = _tmp7_;
					}
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_hide), view);
				}
			}
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_it);
	}
	if (to_show != NULL) {
		view_collection_show_items (self, GEE_LIST (to_show));
	}
	if (to_hide != NULL) {
		view_collection_hide_items (self, GEE_LIST (to_hide));
	}
	_g_object_unref0 (to_hide);
	_g_object_unref0 (to_show);
}


static void view_collection_real_items_altered (DataCollection* base, GeeMap* map) {
	ViewCollection * self;
	GeeSet* _tmp0_ = NULL;
	GeeSet* _tmp1_;
	self = VIEW_COLLECTION (base);
	g_return_if_fail (GEE_IS_MAP (map));
	_tmp0_ = gee_map_get_keys (map);
	_tmp1_ = _tmp0_;
	view_collection_filter_altered_items (self, GEE_COLLECTION (_tmp1_));
	_g_object_unref0 (_tmp1_);
	DATA_COLLECTION_CLASS (view_collection_parent_class)->items_altered (DATA_COLLECTION (self), map);
}


static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target) {
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
	data_set_set_comparator (self->priv->selected, comparator, comparator_target, predicate, predicate_target);
	if (self->priv->visible != NULL) {
		data_set_set_comparator (self->priv->visible, comparator, comparator_target, predicate, predicate_target);
	}
	DATA_COLLECTION_CLASS (view_collection_parent_class)->set_comparator (DATA_COLLECTION (self), comparator, comparator_target, predicate, predicate_target);
}


static void view_collection_real_reset_comparator (DataCollection* base) {
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
	data_set_reset_comparator (self->priv->selected);
	if (self->priv->visible != NULL) {
		data_set_reset_comparator (self->priv->visible);
	}
	DATA_COLLECTION_CLASS (view_collection_parent_class)->reset_comparator (DATA_COLLECTION (self));
}


static GeeCollection* view_collection_real_get_all (DataCollection* base) {
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_ = NULL;
	self = VIEW_COLLECTION (base);
	if (self->priv->visible != NULL) {
		GeeList* _tmp1_ = NULL;
		_tmp1_ = data_set_get_all (self->priv->visible);
		_g_object_unref0 (_tmp0_);
		_tmp0_ = GEE_COLLECTION (_tmp1_);
	} else {
		GeeCollection* _tmp2_ = NULL;
		_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self));
		_g_object_unref0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	result = _tmp0_;
	return result;
}


GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self) {
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_ = NULL;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self));
	result = _tmp0_;
	return result;
}


static gint view_collection_real_get_count (DataCollection* base) {
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = VIEW_COLLECTION (base);
	if (self->priv->visible != NULL) {
		gint _tmp1_;
		_tmp1_ = data_set_get_count (self->priv->visible);
		_tmp0_ = _tmp1_;
	} else {
		gint _tmp2_;
		_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
		_tmp0_ = _tmp2_;
	}
	result = _tmp0_;
	return result;
}


gint view_collection_get_unfiltered_count (ViewCollection* self) {
	gint result = 0;
	gint _tmp0_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
	result = _tmp0_;
	return result;
}


static DataObject* view_collection_real_get_at (DataCollection* base, gint index) {
	ViewCollection * self;
	DataObject* result = NULL;
	DataObject* _tmp0_ = NULL;
	self = VIEW_COLLECTION (base);
	if (self->priv->visible != NULL) {
		DataObject* _tmp1_ = NULL;
		_tmp1_ = data_set_get_at (self->priv->visible, index);
		_g_object_unref0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		DataObject* _tmp2_ = NULL;
		_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_at (DATA_COLLECTION (self), index);
		_g_object_unref0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	result = _tmp0_;
	return result;
}


static gint view_collection_real_index_of (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = VIEW_COLLECTION (base);
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
	if (self->priv->visible != NULL) {
		gint _tmp1_;
		_tmp1_ = data_set_index_of (self->priv->visible, object);
		_tmp0_ = _tmp1_;
	} else {
		gint _tmp2_;
		_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->index_of (DATA_COLLECTION (self), object);
		_tmp0_ = _tmp2_;
	}
	result = _tmp0_;
	return result;
}


static gboolean view_collection_real_contains (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = VIEW_COLLECTION (base);
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->contains (DATA_COLLECTION (self), object);
	if (!_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = view_collection_is_visible (self, DATA_VIEW (object));
	result = _tmp1_;
	return result;
}


static DataView* view_collection_real_get_first (ViewCollection* self) {
	DataView* result = NULL;
	DataView* _tmp0_ = NULL;
	gint _tmp1_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	_tmp1_ = data_collection_get_count (DATA_COLLECTION (self));
	if (_tmp1_ > 0) {
		DataObject* _tmp2_ = NULL;
		_tmp2_ = data_collection_get_at (DATA_COLLECTION (self), 0);
		_g_object_unref0 (_tmp0_);
		_tmp0_ = DATA_VIEW (_tmp2_);
	} else {
		_g_object_unref0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}


DataView* view_collection_get_first (ViewCollection* self) {
	return VIEW_COLLECTION_GET_CLASS (self)->get_first (self);
}


static DataView* view_collection_real_get_last (ViewCollection* self) {
	DataView* result = NULL;
	DataView* _tmp0_ = NULL;
	gint _tmp1_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	_tmp1_ = data_collection_get_count (DATA_COLLECTION (self));
	if (_tmp1_ > 0) {
		gint _tmp2_;
		DataObject* _tmp3_ = NULL;
		_tmp2_ = data_collection_get_count (DATA_COLLECTION (self));
		_tmp3_ = data_collection_get_at (DATA_COLLECTION (self), _tmp2_ - 1);
		_g_object_unref0 (_tmp0_);
		_tmp0_ = DATA_VIEW (_tmp3_);
	} else {
		_g_object_unref0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}


DataView* view_collection_get_last (ViewCollection* self) {
	return VIEW_COLLECTION_GET_CLASS (self)->get_last (self);
}


static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view) {
	DataView* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint index;
	gint _tmp2_;
	DataObject* _tmp3_ = NULL;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
	_tmp0_ = data_collection_get_count (DATA_COLLECTION (self));
	if (_tmp0_ == 0) {
		result = NULL;
		return result;
	}
	_tmp1_ = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (view));
	index = _tmp1_;
	if (index < 0) {
		result = NULL;
		return result;
	}
	index++;
	_tmp2_ = data_collection_get_count (DATA_COLLECTION (self));
	if (index >= _tmp2_) {
		index = 0;
	}
	_tmp3_ = data_collection_get_at (DATA_COLLECTION (self), index);
	result = DATA_VIEW (_tmp3_);
	return result;
}


DataView* view_collection_get_next (ViewCollection* self, DataView* view) {
	return VIEW_COLLECTION_GET_CLASS (self)->get_next (self, view);
}


static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view) {
	DataView* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint index;
	DataObject* _tmp3_ = NULL;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
	_tmp0_ = data_collection_get_count (DATA_COLLECTION (self));
	if (_tmp0_ == 0) {
		result = NULL;
		return result;
	}
	_tmp1_ = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (view));
	index = _tmp1_;
	if (index < 0) {
		result = NULL;
		return result;
	}
	index--;
	if (index < 0) {
		gint _tmp2_;
		_tmp2_ = data_collection_get_count (DATA_COLLECTION (self));
		index = _tmp2_ - 1;
	}
	_tmp3_ = data_collection_get_at (DATA_COLLECTION (self), index);
	result = DATA_VIEW (_tmp3_);
	return result;
}


DataView* view_collection_get_previous (ViewCollection* self, DataView* view) {
	return VIEW_COLLECTION_GET_CLASS (self)->get_previous (self, view);
}


gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev, const gchar* type_selector) {
	DataSource* _next = NULL;
	DataSource* _prev = NULL;
	gboolean result = FALSE;
	DataView* _tmp0_ = NULL;
	DataView* home_view;
	DataView* _tmp1_ = NULL;
	DataView* next_view;
	DataView* _tmp9_ = NULL;
	DataView* prev_view;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_DATA_SOURCE (home), FALSE);
	_tmp0_ = view_collection_get_view_for_source (self, home);
	home_view = _tmp0_;
	if (home_view == NULL) {
		result = FALSE;
		_g_object_unref0 (home_view);
		if (next) {
			*next = _next;
		} else {
			_g_object_unref0 (_next);
		}
		if (prev) {
			*prev = _prev;
		} else {
			_g_object_unref0 (_prev);
		}
		return result;
	}
	_g_object_unref0 (_next);
	_next = NULL;
	_tmp1_ = view_collection_get_next (self, home_view);
	next_view = _tmp1_;
	while (TRUE) {
		gboolean _tmp2_ = FALSE;
		DataView* _tmp8_ = NULL;
		if (!(next_view != home_view)) {
			break;
		}
		if (type_selector == NULL) {
			_tmp2_ = TRUE;
		} else {
			DataSource* _tmp3_ = NULL;
			DataSource* _tmp4_;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_;
			_tmp3_ = data_view_get_source (next_view);
			_tmp4_ = _tmp3_;
			_tmp5_ = data_source_get_typename (_tmp4_);
			_tmp6_ = _tmp5_;
			_tmp2_ = g_strcmp0 (_tmp6_, type_selector) == 0;
			_g_free0 (_tmp6_);
			_g_object_unref0 (_tmp4_);
		}
		if (_tmp2_) {
			DataSource* _tmp7_ = NULL;
			_tmp7_ = data_view_get_source (next_view);
			_g_object_unref0 (_next);
			_next = _tmp7_;
			break;
		}
		_tmp8_ = view_collection_get_next (self, next_view);
		_g_object_unref0 (next_view);
		next_view = _tmp8_;
	}
	_g_object_unref0 (_prev);
	_prev = NULL;
	_tmp9_ = view_collection_get_previous (self, home_view);
	prev_view = _tmp9_;
	while (TRUE) {
		gboolean _tmp10_ = FALSE;
		DataView* _tmp16_ = NULL;
		if (!(prev_view != home_view)) {
			break;
		}
		if (type_selector == NULL) {
			_tmp10_ = TRUE;
		} else {
			DataSource* _tmp11_ = NULL;
			DataSource* _tmp12_;
			gchar* _tmp13_ = NULL;
			gchar* _tmp14_;
			_tmp11_ = data_view_get_source (prev_view);
			_tmp12_ = _tmp11_;
			_tmp13_ = data_source_get_typename (_tmp12_);
			_tmp14_ = _tmp13_;
			_tmp10_ = g_strcmp0 (_tmp14_, type_selector) == 0;
			_g_free0 (_tmp14_);
			_g_object_unref0 (_tmp12_);
		}
		if (_tmp10_) {
			DataSource* _tmp15_ = NULL;
			_tmp15_ = data_view_get_source (prev_view);
			_g_object_unref0 (_prev);
			_prev = _tmp15_;
			break;
		}
		_tmp16_ = view_collection_get_previous (self, prev_view);
		_g_object_unref0 (prev_view);
		prev_view = _tmp16_;
	}
	result = TRUE;
	_g_object_unref0 (prev_view);
	_g_object_unref0 (next_view);
	_g_object_unref0 (home_view);
	if (next) {
		*next = _next;
	} else {
		_g_object_unref0 (_next);
	}
	if (prev) {
		*prev = _prev;
	} else {
		_g_object_unref0 (_prev);
	}
	return result;
}


GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home, const gchar* typename) {
	GeeSet* result = NULL;
	GeeHashSet* _tmp0_ = NULL;
	GeeSet* neighbors;
	DataSource* next = NULL;
	DataSource* prev = NULL;
	DataSource* _tmp1_ = NULL;
	DataSource* _tmp2_ = NULL;
	gboolean _tmp3_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	g_return_val_if_fail (IS_DATA_SOURCE (home), NULL);
	_tmp0_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	neighbors = GEE_SET (_tmp0_);
	_tmp3_ = view_collection_get_immediate_neighbors (self, home, &_tmp1_, &_tmp2_, typename);
	_g_object_unref0 (next);
	next = _tmp1_;
	_g_object_unref0 (prev);
	prev = _tmp2_;
	if (!_tmp3_) {
		result = neighbors;
		_g_object_unref0 (prev);
		_g_object_unref0 (next);
		return result;
	}
	if (next != NULL) {
		DataSource* next_next = NULL;
		DataSource* next_prev = NULL;
		DataSource* _tmp4_ = NULL;
		DataSource* _tmp5_ = NULL;
		gee_collection_add (GEE_COLLECTION (neighbors), next);
		view_collection_get_immediate_neighbors (self, next, &_tmp4_, &_tmp5_, typename);
		_g_object_unref0 (next_next);
		next_next = _tmp4_;
		_g_object_unref0 (next_prev);
		next_prev = _tmp5_;
		if (next_next != NULL) {
			gee_collection_add (GEE_COLLECTION (neighbors), next_next);
		}
		_g_object_unref0 (next_prev);
		_g_object_unref0 (next_next);
	}
	if (prev != NULL) {
		DataSource* next_prev = NULL;
		DataSource* prev_prev = NULL;
		DataSource* _tmp6_ = NULL;
		DataSource* _tmp7_ = NULL;
		gee_collection_add (GEE_COLLECTION (neighbors), prev);
		view_collection_get_immediate_neighbors (self, prev, &_tmp6_, &_tmp7_, typename);
		_g_object_unref0 (next_prev);
		next_prev = _tmp6_;
		_g_object_unref0 (prev_prev);
		prev_prev = _tmp7_;
		if (prev_prev != NULL) {
			gee_collection_add (GEE_COLLECTION (neighbors), prev_prev);
		}
		_g_object_unref0 (prev_prev);
		_g_object_unref0 (next_prev);
	}
	gee_collection_remove (GEE_COLLECTION (neighbors), home);
	result = neighbors;
	_g_object_unref0 (prev);
	_g_object_unref0 (next);
	return result;
}


static void view_collection_add_many_selected (ViewCollection* self, GeeCollection* views) {
	gint _tmp0_;
	gboolean _tmp5_;
	gboolean added;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (views));
	_tmp0_ = gee_collection_get_size (views);
	if (_tmp0_ == 0) {
		return;
	}
	{
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _view_it;
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (views));
		_view_it = _tmp1_;
		while (TRUE) {
			gboolean _tmp2_;
			gpointer _tmp3_ = NULL;
			DataView* view;
			gboolean _tmp4_;
			_tmp2_ = gee_iterator_next (_view_it);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = gee_iterator_get (_view_it);
			view = (DataView*) _tmp3_;
			_tmp4_ = data_view_is_visible (view);
			g_assert (_tmp4_);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_it);
	}
	_tmp5_ = data_set_add_many (self->priv->selected, views);
	added = _tmp5_;
	g_assert (added);
}


static void view_collection_remove_many_selected (ViewCollection* self, GeeCollection* views) {
	gint _tmp0_;
	gboolean _tmp1_;
	gboolean removed;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (views));
	_tmp0_ = gee_collection_get_size (views);
	if (_tmp0_ == 0) {
		return;
	}
	_tmp1_ = data_set_remove_many (self->priv->selected, views);
	removed = _tmp1_;
	g_assert (removed);
}


static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self) {
	gboolean result;
	result = view_collection_select_item (self, object, user);
	return result;
}


void view_collection_select_marked (ViewCollection* self, Marker* marker) {
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* selected;
	gint _tmp1_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_MARKER (marker));
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	selected = _tmp0_;
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_select_item_marked_action, self, NULL, NULL, G_OBJECT (selected));
	_tmp1_ = gee_collection_get_size (GEE_COLLECTION (selected));
	if (_tmp1_ > 0) {
		view_collection_add_many_selected (self, GEE_COLLECTION (selected));
		view_collection_notify_items_selected_unselected (self, GEE_COLLECTION (selected), NULL);
	}
	_g_object_unref0 (selected);
}


void view_collection_select_all (ViewCollection* self) {
	Marker* _tmp0_ = NULL;
	Marker* marker;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self));
	marker = _tmp0_;
	marker_mark_all (marker);
	view_collection_select_marked (self, marker);
	_g_object_unref0 (marker);
}


static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user) {
	gboolean result = FALSE;
	DataView* _tmp0_;
	DataView* view;
	gboolean _tmp1_;
	gboolean _tmp4_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
	_tmp0_ = _g_object_ref0 (DATA_VIEW (object));
	view = _tmp0_;
	_tmp1_ = data_view_is_selected (view);
	if (_tmp1_) {
		gboolean _tmp2_;
		_tmp2_ = data_view_is_visible (view);
		if (_tmp2_) {
			gboolean _tmp3_;
			_tmp3_ = data_set_contains (self->priv->selected, DATA_OBJECT (view));
			g_assert (_tmp3_);
		}
		result = TRUE;
		_g_object_unref0 (view);
		return result;
	}
	data_view_internal_set_selected (view, TRUE);
	_tmp4_ = data_view_is_visible (view);
	if (_tmp4_) {
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (user)), view);
	}
	result = TRUE;
	_g_object_unref0 (view);
	return result;
}


static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self) {
	gboolean result;
	result = view_collection_unselect_item (self, object, user);
	return result;
}


void view_collection_unselect_marked (ViewCollection* self, Marker* marker) {
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* unselected;
	gint _tmp1_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_MARKER (marker));
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	unselected = _tmp0_;
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_OBJECT (unselected));
	_tmp1_ = gee_collection_get_size (GEE_COLLECTION (unselected));
	if (_tmp1_ > 0) {
		view_collection_remove_many_selected (self, GEE_COLLECTION (unselected));
		view_collection_notify_items_selected_unselected (self, NULL, GEE_COLLECTION (unselected));
	}
	_g_object_unref0 (unselected);
}


void view_collection_unselect_all (ViewCollection* self) {
	gint _tmp0_;
	Marker* _tmp1_ = NULL;
	Marker* marker;
	GeeList* _tmp2_ = NULL;
	GeeList* _tmp3_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	_tmp0_ = data_set_get_count (self->priv->selected);
	if (_tmp0_ == 0) {
		return;
	}
	_tmp1_ = data_collection_start_marking (DATA_COLLECTION (self));
	marker = _tmp1_;
	_tmp2_ = view_collection_get_selected (self);
	_tmp3_ = _tmp2_;
	marker_mark_many (marker, GEE_COLLECTION (_tmp3_));
	_g_object_unref0 (_tmp3_);
	view_collection_unselect_marked (self, marker);
	_g_object_unref0 (marker);
}


void view_collection_unselect_all_but (ViewCollection* self, DataView* exception) {
	Marker* _tmp0_ = NULL;
	Marker* marker;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_DATA_VIEW (exception));
	_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self));
	marker = _tmp0_;
	{
		GeeCollection* _tmp1_ = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _tmp4_;
		GeeIterator* _object_it;
		_tmp1_ = data_collection_get_all (DATA_COLLECTION (self));
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_));
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_object_it = _tmp4_;
		while (TRUE) {
			gboolean _tmp5_;
			gpointer _tmp6_ = NULL;
			DataObject* object;
			DataView* _tmp7_;
			DataView* view;
			_tmp5_ = gee_iterator_next (_object_it);
			if (!_tmp5_) {
				break;
			}
			_tmp6_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp6_;
			_tmp7_ = _g_object_ref0 (DATA_VIEW (object));
			view = _tmp7_;
			if (view != exception) {
				marker_mark (marker, DATA_OBJECT (view));
			}
			_g_object_unref0 (view);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	view_collection_unselect_marked (self, marker);
	_g_object_unref0 (marker);
}


static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user) {
	gboolean result = FALSE;
	DataView* _tmp0_;
	DataView* view;
	gboolean _tmp1_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
	_tmp0_ = _g_object_ref0 (DATA_VIEW (object));
	view = _tmp0_;
	_tmp1_ = data_view_is_selected (view);
	if (!_tmp1_) {
		gboolean _tmp2_;
		_tmp2_ = data_set_contains (self->priv->selected, DATA_OBJECT (view));
		g_assert (!_tmp2_);
		result = TRUE;
		_g_object_unref0 (view);
		return result;
	}
	data_view_internal_set_selected (view, FALSE);
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (user)), view);
	result = TRUE;
	_g_object_unref0 (view);
	return result;
}


void view_collection_unselect_and_select_marked (ViewCollection* self, Marker* unselect, Marker* select) {
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* unselected;
	GeeArrayList* _tmp1_ = NULL;
	GeeArrayList* selected;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_MARKER (unselect));
	g_return_if_fail (IS_MARKER (select));
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	unselected = _tmp0_;
	data_collection_act_on_marked (DATA_COLLECTION (self), unselect, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_OBJECT (unselected));
	view_collection_remove_many_selected (self, GEE_COLLECTION (unselected));
	_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	selected = _tmp1_;
	data_collection_act_on_marked (DATA_COLLECTION (self), select, _view_collection_select_item_marked_action, self, NULL, NULL, G_OBJECT (selected));
	view_collection_add_many_selected (self, GEE_COLLECTION (selected));
	view_collection_notify_items_selected_unselected (self, GEE_COLLECTION (selected), GEE_COLLECTION (unselected));
	_g_object_unref0 (selected);
	_g_object_unref0 (unselected);
}


static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self) {
	gboolean result;
	result = view_collection_toggle_item (self, object, user);
	return result;
}


void view_collection_toggle_marked (ViewCollection* self, Marker* marker) {
	ViewCollectionToggleLists* _tmp0_ = NULL;
	ViewCollectionToggleLists* lists;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_MARKER (marker));
	_tmp0_ = view_collection_toggle_lists_new ();
	lists = _tmp0_;
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_toggle_item_marked_action, self, NULL, NULL, G_OBJECT (lists));
	view_collection_add_many_selected (self, GEE_COLLECTION (lists->selected));
	view_collection_remove_many_selected (self, GEE_COLLECTION (lists->unselected));
	view_collection_notify_items_selected_unselected (self, GEE_COLLECTION (lists->selected), GEE_COLLECTION (lists->unselected));
	_g_object_unref0 (lists);
}


static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user) {
	gboolean result = FALSE;
	DataView* _tmp0_;
	DataView* view;
	ViewCollectionToggleLists* _tmp1_;
	ViewCollectionToggleLists* lists;
	gboolean _tmp2_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
	_tmp0_ = _g_object_ref0 (DATA_VIEW (object));
	view = _tmp0_;
	_tmp1_ = _g_object_ref0 (VIEW_COLLECTION_TOGGLE_LISTS (user));
	lists = _tmp1_;
	_tmp2_ = data_view_internal_toggle (view);
	if (_tmp2_) {
		gboolean _tmp3_;
		_tmp3_ = data_view_is_visible (view);
		if (_tmp3_) {
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (lists->selected), view);
		}
	} else {
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (lists->unselected), view);
	}
	result = TRUE;
	_g_object_unref0 (lists);
	_g_object_unref0 (view);
	return result;
}


gint view_collection_get_selected_count (ViewCollection* self) {
	gint result = 0;
	gint _tmp0_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
	_tmp0_ = data_set_get_count (self->priv->selected);
	result = _tmp0_;
	return result;
}


GeeList* view_collection_get_selected (ViewCollection* self) {
	GeeList* result = NULL;
	GeeList* _tmp0_ = NULL;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	_tmp0_ = data_set_get_all (self->priv->selected);
	result = GEE_LIST (_tmp0_);
	return result;
}


DataView* view_collection_get_selected_at (ViewCollection* self, gint index) {
	DataView* result = NULL;
	DataObject* _tmp0_ = NULL;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	_tmp0_ = data_set_get_at (self->priv->selected, index);
	result = DATA_VIEW (_tmp0_);
	return result;
}


static gboolean view_collection_is_visible (ViewCollection* self, DataView* view) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
	if (self->priv->visible != NULL) {
		gboolean _tmp1_;
		_tmp1_ = data_set_contains (self->priv->visible, DATA_OBJECT (view));
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = TRUE;
	}
	result = _tmp0_;
	return result;
}


static gboolean view_collection_add_many_visible (ViewCollection* self, GeeCollection* many) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	g_return_val_if_fail (GEE_IS_COLLECTION (many), FALSE);
	if (self->priv->visible == NULL) {
		result = TRUE;
		return result;
	}
	_tmp0_ = data_set_add_many (self->priv->visible, many);
	if (!_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = data_set_get_count (self->priv->visible);
	_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
	if (_tmp1_ == _tmp2_) {
		_data_set_unref0 (self->priv->visible);
		self->priv->visible = NULL;
	}
	result = TRUE;
	return result;
}


static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide) {
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* unselected;
	gint _tmp1_;
	gint count;
	gboolean _tmp8_;
	gboolean removed;
	gint _tmp9_;
	gint _tmp10_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_LIST (to_hide));
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	unselected = _tmp0_;
	_tmp1_ = gee_collection_get_size (GEE_COLLECTION (to_hide));
	count = _tmp1_;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				gpointer _tmp3_ = NULL;
				DataView* view;
				gboolean _tmp4_;
				gboolean _tmp5_;
				if (!_tmp2_) {
					ctr++;
				}
				_tmp2_ = FALSE;
				if (!(ctr < count)) {
					break;
				}
				_tmp3_ = gee_list_get (to_hide, ctr);
				view = (DataView*) _tmp3_;
				_tmp4_ = data_view_is_visible (view);
				g_assert (_tmp4_);
				_tmp5_ = data_view_is_selected (view);
				if (_tmp5_) {
					data_view_internal_set_selected (view, FALSE);
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (unselected), view);
				} else {
					gboolean _tmp6_;
					_tmp6_ = data_set_contains (self->priv->selected, DATA_OBJECT (view));
					g_assert (!_tmp6_);
				}
				data_view_internal_set_visible (view, FALSE);
				_g_object_unref0 (view);
			}
		}
	}
	if (self->priv->visible == NULL) {
		DataSet* _tmp7_ = NULL;
		_tmp7_ = data_collection_get_dataset_copy (DATA_COLLECTION (self));
		_data_set_unref0 (self->priv->visible);
		self->priv->visible = _tmp7_;
	}
	_tmp8_ = data_set_remove_many (self->priv->visible, GEE_COLLECTION (to_hide));
	removed = _tmp8_;
	g_assert (removed);
	view_collection_remove_many_selected (self, GEE_COLLECTION (unselected));
	_tmp9_ = gee_collection_get_size (GEE_COLLECTION (unselected));
	if (_tmp9_ > 0) {
		view_collection_notify_items_selected_unselected (self, NULL, GEE_COLLECTION (unselected));
	}
	_tmp10_ = gee_collection_get_size (GEE_COLLECTION (to_hide));
	if (_tmp10_ > 0) {
		view_collection_notify_items_hidden (self, GEE_COLLECTION (to_hide));
		view_collection_notify_items_visibility_changed (self, GEE_COLLECTION (to_hide));
	}
	_g_object_unref0 (unselected);
}


static void view_collection_show_items (ViewCollection* self, GeeList* to_show) {
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* added_selected;
	gint _tmp1_;
	gint count;
	gboolean _tmp7_;
	gboolean added;
	gint _tmp8_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_LIST (to_show));
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	added_selected = _tmp0_;
	_tmp1_ = gee_collection_get_size (GEE_COLLECTION (to_show));
	count = _tmp1_;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				gpointer _tmp3_ = NULL;
				DataView* view;
				gboolean _tmp4_;
				gboolean _tmp5_;
				if (!_tmp2_) {
					ctr++;
				}
				_tmp2_ = FALSE;
				if (!(ctr < count)) {
					break;
				}
				_tmp3_ = gee_list_get (to_show, ctr);
				view = (DataView*) _tmp3_;
				_tmp4_ = data_view_is_visible (view);
				g_assert (!_tmp4_);
				data_view_internal_set_visible (view, TRUE);
				_tmp5_ = data_view_is_selected (view);
				if (_tmp5_) {
					gboolean _tmp6_;
					_tmp6_ = data_set_contains (self->priv->selected, DATA_OBJECT (view));
					g_assert (!_tmp6_);
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_selected), view);
				}
				_g_object_unref0 (view);
			}
		}
	}
	_tmp7_ = view_collection_add_many_visible (self, GEE_COLLECTION (to_show));
	added = _tmp7_;
	g_assert (added);
	view_collection_add_many_selected (self, GEE_COLLECTION (added_selected));
	_tmp8_ = gee_collection_get_size (GEE_COLLECTION (to_show));
	if (_tmp8_ > 0) {
		view_collection_notify_items_shown (self, GEE_COLLECTION (to_show));
		view_collection_notify_items_visibility_changed (self, GEE_COLLECTION (to_show));
	}
	_g_object_unref0 (added_selected);
}


gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source) {
	gboolean result = FALSE;
	DataView* _tmp0_ = NULL;
	DataView* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
	_tmp0_ = view_collection_get_view_for_source (self, source);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_ != NULL;
	_g_object_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}


DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source) {
	DataView* result = NULL;
	gpointer _tmp0_ = NULL;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
	_tmp0_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->source_map), source);
	result = (DataView*) _tmp0_;
	return result;
}


gboolean view_collection_has_view_for_source_with_filtered (ViewCollection* self, DataSource* source) {
	gboolean result = FALSE;
	DataView* _tmp0_ = NULL;
	DataView* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
	_tmp0_ = view_collection_get_view_for_source_filtered (self, source);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_ != NULL;
	_g_object_unref0 (_tmp1_);
	result = _tmp2_;
	return result;
}


DataView* view_collection_get_view_for_source_filtered (ViewCollection* self, DataSource* source) {
	DataView* result = NULL;
	gpointer _tmp0_ = NULL;
	DataView* view;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
	_tmp0_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->source_map), source);
	view = (DataView*) _tmp0_;
	if (view != NULL) {
		gboolean _tmp2_;
		_tmp2_ = view_collection_is_in_filter (self, view);
		_tmp1_ = !_tmp2_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		result = NULL;
		_g_object_unref0 (view);
		return result;
	}
	result = view;
	return result;
}


GeeCollection* view_collection_get_sources (ViewCollection* self) {
	GeeCollection* result = NULL;
	GeeSet* _tmp0_ = NULL;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_ = NULL;
	GeeCollection* _tmp3_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->source_map));
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_set_get_read_only_view (_tmp1_);
	_tmp3_ = GEE_COLLECTION (_tmp2_);
	_g_object_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


gboolean view_collection_has_source_of_type (ViewCollection* self, GType t) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	_tmp0_ = g_type_is_a (t, TYPE_DATA_SOURCE);
	g_assert (_tmp0_);
	{
		GeeSet* _tmp1_ = NULL;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _tmp4_;
		GeeIterator* _source_it;
		_tmp1_ = gee_map_get_keys (GEE_MAP (self->priv->source_map));
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_));
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_source_it = _tmp4_;
		while (TRUE) {
			gboolean _tmp5_;
			gpointer _tmp6_ = NULL;
			DataSource* source;
			GType _tmp7_;
			gboolean _tmp8_;
			_tmp5_ = gee_iterator_next (_source_it);
			if (!_tmp5_) {
				break;
			}
			_tmp6_ = gee_iterator_get (_source_it);
			source = (DataSource*) _tmp6_;
			_tmp7_ = G_TYPE_FROM_INSTANCE (G_OBJECT (source));
			_tmp8_ = g_type_is_a (_tmp7_, t);
			if (_tmp8_) {
				result = TRUE;
				_g_object_unref0 (source);
				_g_object_unref0 (_source_it);
				return result;
			}
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	result = FALSE;
	return result;
}


gint view_collection_get_sources_of_type_count (ViewCollection* self, GType t) {
	gint result = 0;
	gboolean _tmp0_;
	gint count;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
	_tmp0_ = g_type_is_a (t, TYPE_DATA_SOURCE);
	g_assert (_tmp0_);
	count = 0;
	{
		GeeCollection* _tmp1_ = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _tmp4_;
		GeeIterator* _object_it;
		_tmp1_ = data_collection_get_all (DATA_COLLECTION (self));
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_));
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_object_it = _tmp4_;
		while (TRUE) {
			gboolean _tmp5_;
			gpointer _tmp6_ = NULL;
			DataObject* object;
			DataSource* _tmp7_ = NULL;
			DataSource* _tmp8_;
			GType _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			_tmp5_ = gee_iterator_next (_object_it);
			if (!_tmp5_) {
				break;
			}
			_tmp6_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp6_;
			_tmp7_ = data_view_get_source (DATA_VIEW (object));
			_tmp8_ = _tmp7_;
			_tmp9_ = G_TYPE_FROM_INSTANCE (G_OBJECT (_tmp8_));
			_tmp10_ = g_type_is_a (_tmp9_, t);
			_tmp11_ = _tmp10_;
			_g_object_unref0 (_tmp8_);
			if (_tmp11_) {
				count++;
			}
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	result = count;
	return result;
}


GeeList* view_collection_get_sources_of_type (ViewCollection* self, GType t) {
	GeeList* result = NULL;
	gboolean _tmp0_;
	GeeList* sources;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	_tmp0_ = g_type_is_a (t, TYPE_DATA_SOURCE);
	g_assert (_tmp0_);
	sources = NULL;
	{
		GeeCollection* _tmp1_ = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _tmp4_;
		GeeIterator* _object_it;
		_tmp1_ = data_collection_get_all (DATA_COLLECTION (self));
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_));
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_object_it = _tmp4_;
		while (TRUE) {
			gboolean _tmp5_;
			gpointer _tmp6_ = NULL;
			DataObject* object;
			DataSource* _tmp7_ = NULL;
			DataSource* source;
			GType _tmp8_;
			gboolean _tmp9_;
			_tmp5_ = gee_iterator_next (_object_it);
			if (!_tmp5_) {
				break;
			}
			_tmp6_ = gee_iterator_get (_object_it);
			object = (DataObject*) _tmp6_;
			_tmp7_ = data_view_get_source (DATA_VIEW (object));
			source = _tmp7_;
			_tmp8_ = G_TYPE_FROM_INSTANCE (G_OBJECT (source));
			_tmp9_ = g_type_is_a (_tmp8_, t);
			if (_tmp9_) {
				if (sources == NULL) {
					GeeArrayList* _tmp10_ = NULL;
					_tmp10_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
					_g_object_unref0 (sources);
					sources = GEE_LIST (_tmp10_);
				}
				gee_collection_add (GEE_COLLECTION (sources), source);
			}
			_g_object_unref0 (source);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	result = sources;
	return result;
}


GeeList* view_collection_get_selected_sources (ViewCollection* self) {
	GeeList* result = NULL;
	GeeArrayList* _tmp0_ = NULL;
	GeeList* sources;
	gint _tmp1_;
	gint count;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	_tmp0_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	sources = GEE_LIST (_tmp0_);
	_tmp1_ = data_set_get_count (self->priv->selected);
	count = _tmp1_;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				DataObject* _tmp3_ = NULL;
				DataView* _tmp4_;
				DataSource* _tmp5_ = NULL;
				DataSource* _tmp6_;
				if (!_tmp2_) {
					ctr++;
				}
				_tmp2_ = FALSE;
				if (!(ctr < count)) {
					break;
				}
				_tmp3_ = data_set_get_at (self->priv->selected, ctr);
				_tmp4_ = DATA_VIEW (_tmp3_);
				_tmp5_ = data_view_get_source (_tmp4_);
				_tmp6_ = _tmp5_;
				gee_collection_add (GEE_COLLECTION (sources), _tmp6_);
				_g_object_unref0 (_tmp6_);
				_g_object_unref0 (_tmp4_);
			}
		}
	}
	result = sources;
	return result;
}


DataSource* view_collection_get_selected_source_at (ViewCollection* self, gint index) {
	DataSource* result = NULL;
	DataObject* _tmp0_ = NULL;
	DataObject* object;
	DataSource* _tmp1_ = NULL;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	_tmp0_ = data_set_get_at (self->priv->selected, index);
	object = _tmp0_;
	if (object != NULL) {
		DataSource* _tmp2_ = NULL;
		_tmp2_ = data_view_get_source (DATA_VIEW (object));
		_g_object_unref0 (_tmp1_);
		_tmp1_ = _tmp2_;
	} else {
		_g_object_unref0 (_tmp1_);
		_tmp1_ = NULL;
	}
	result = _tmp1_;
	_g_object_unref0 (object);
	return result;
}


GeeList* view_collection_get_selected_sources_of_type (ViewCollection* self, GType t) {
	GeeList* result = NULL;
	GeeList* sources;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
	sources = NULL;
	{
		GeeList* _tmp0_ = NULL;
		GeeList* _view_list;
		gint _tmp1_;
		gint _view_size;
		gint _view_index;
		_tmp0_ = view_collection_get_selected (self);
		_view_list = _tmp0_;
		_tmp1_ = gee_collection_get_size (GEE_COLLECTION (_view_list));
		_view_size = _tmp1_;
		_view_index = -1;
		while (TRUE) {
			gpointer _tmp2_ = NULL;
			DataView* view;
			DataSource* _tmp3_ = NULL;
			DataSource* source;
			GType _tmp4_;
			gboolean _tmp5_;
			_view_index = _view_index + 1;
			if (!(_view_index < _view_size)) {
				break;
			}
			_tmp2_ = gee_list_get (_view_list, _view_index);
			view = (DataView*) _tmp2_;
			_tmp3_ = data_view_get_source (view);
			source = _tmp3_;
			_tmp4_ = G_TYPE_FROM_INSTANCE (G_OBJECT (source));
			_tmp5_ = g_type_is_a (_tmp4_, t);
			if (_tmp5_) {
				if (sources == NULL) {
					GeeArrayList* _tmp6_ = NULL;
					_tmp6_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
					_g_object_unref0 (sources);
					sources = GEE_LIST (_tmp6_);
				}
				gee_collection_add (GEE_COLLECTION (sources), source);
			}
			_g_object_unref0 (source);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_list);
	}
	result = sources;
	return result;
}


gint view_collection_index_of_source (ViewCollection* self, DataSource* source) {
	gint result = 0;
	DataView* _tmp0_ = NULL;
	DataView* view;
	gint _tmp1_ = 0;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0);
	_tmp0_ = view_collection_get_view_for_source (self, source);
	view = _tmp0_;
	if (view != NULL) {
		gint _tmp2_;
		_tmp2_ = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (view));
		_tmp1_ = _tmp2_;
	} else {
		_tmp1_ = -1;
	}
	result = _tmp1_;
	_g_object_unref0 (view);
	return result;
}


void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view) {
	gboolean _tmp0_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_DATA_VIEW (view));
	_tmp0_ = data_collection_are_notifications_frozen (DATA_COLLECTION (self));
	if (!_tmp0_) {
		GeeCollection* _tmp1_ = NULL;
		GeeCollection* _tmp2_;
		view_collection_notify_item_view_altered (self, view);
		_tmp1_ = data_collection_get_singleton (DATA_OBJECT (view));
		_tmp2_ = GEE_COLLECTION (_tmp1_);
		view_collection_notify_views_altered (self, _tmp2_);
		_g_object_unref0 (_tmp2_);
	} else {
		if (self->priv->frozen_views_altered == NULL) {
			GeeHashSet* _tmp3_ = NULL;
			_tmp3_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
			_g_object_unref0 (self->priv->frozen_views_altered);
			self->priv->frozen_views_altered = _tmp3_;
		}
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_views_altered), view);
	}
}


void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view) {
	gboolean _tmp0_;
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_DATA_VIEW (view));
	_tmp0_ = data_collection_are_notifications_frozen (DATA_COLLECTION (self));
	if (!_tmp0_) {
		GeeCollection* _tmp1_ = NULL;
		GeeCollection* _tmp2_;
		view_collection_notify_item_geometry_altered (self, view);
		_tmp1_ = data_collection_get_singleton (DATA_OBJECT (view));
		_tmp2_ = GEE_COLLECTION (_tmp1_);
		view_collection_notify_geometries_altered (self, _tmp2_);
		_g_object_unref0 (_tmp2_);
	} else {
		if (self->priv->frozen_geometries_altered == NULL) {
			GeeHashSet* _tmp3_ = NULL;
			_tmp3_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
			_g_object_unref0 (self->priv->frozen_geometries_altered);
			self->priv->frozen_geometries_altered = _tmp3_;
		}
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_geometries_altered), view);
	}
}


static void view_collection_real_notify_thawed (DataCollection* base) {
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
	if (self->priv->frozen_views_altered != NULL) {
		{
			GeeIterator* _tmp0_ = NULL;
			GeeIterator* _view_it;
			_tmp0_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_views_altered));
			_view_it = _tmp0_;
			while (TRUE) {
				gboolean _tmp1_;
				gpointer _tmp2_ = NULL;
				DataView* view;
				_tmp1_ = gee_iterator_next (_view_it);
				if (!_tmp1_) {
					break;
				}
				_tmp2_ = gee_iterator_get (_view_it);
				view = (DataView*) _tmp2_;
				view_collection_notify_item_view_altered (self, view);
				_g_object_unref0 (view);
			}
			_g_object_unref0 (_view_it);
		}
		view_collection_notify_views_altered (self, GEE_COLLECTION (self->priv->frozen_views_altered));
		_g_object_unref0 (self->priv->frozen_views_altered);
		self->priv->frozen_views_altered = NULL;
	}
	if (self->priv->frozen_geometries_altered != NULL) {
		{
			GeeIterator* _tmp3_ = NULL;
			GeeIterator* _view_it;
			_tmp3_ = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_geometries_altered));
			_view_it = _tmp3_;
			while (TRUE) {
				gboolean _tmp4_;
				gpointer _tmp5_ = NULL;
				DataView* view;
				_tmp4_ = gee_iterator_next (_view_it);
				if (!_tmp4_) {
					break;
				}
				_tmp5_ = gee_iterator_get (_view_it);
				view = (DataView*) _tmp5_;
				view_collection_notify_item_geometry_altered (self, view);
				_g_object_unref0 (view);
			}
			_g_object_unref0 (_view_it);
		}
		view_collection_notify_geometries_altered (self, GEE_COLLECTION (self->priv->frozen_geometries_altered));
		_g_object_unref0 (self->priv->frozen_geometries_altered);
		self->priv->frozen_geometries_altered = NULL;
	}
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_thawed (DATA_COLLECTION (self));
}


gboolean view_collection_are_items_filtered_out (ViewCollection* self) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
	_tmp1_ = data_collection_get_count (DATA_COLLECTION (self));
	result = _tmp0_ != _tmp1_;
	return result;
}


static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_ITERABLE (selected));
}


static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_ITERABLE (unselected));
}


static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_ITERABLE (changed));
}


static void view_collection_real_selection_group_altered (ViewCollection* self) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
}


static void view_collection_real_items_shown (ViewCollection* self, GeeCollection* visible) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (visible));
}


static void view_collection_real_items_hidden (ViewCollection* self, GeeCollection* hidden) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (hidden));
}


static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (changed));
}


static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_DATA_VIEW (view));
}


static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_DATA_VIEW (view));
}


static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (views));
}


static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (GEE_IS_COLLECTION (views));
}


static void view_collection_real_view_filter_installed (ViewCollection* self, ViewFilter* filer) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_VIEW_FILTER (filer));
}


static void g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__VIEW_FILTER) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__VIEW_FILTER callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__VIEW_FILTER) (marshal_data ? marshal_data : cc->callback);
	callback (data1, value_get_view_filter (param_values + 1), data2);
}


static void view_collection_real_view_filter_removed (ViewCollection* self, ViewFilter* filer) {
	g_return_if_fail (IS_VIEW_COLLECTION (self));
	g_return_if_fail (IS_VIEW_FILTER (filer));
}


ViewCollectionMonitor* view_collection_monitor_construct (GType object_type) {
	ViewCollectionMonitor* self = NULL;
	self = (ViewCollectionMonitor*) g_type_create_instance (object_type);
	return self;
}


ViewCollectionMonitor* view_collection_monitor_new (void) {
	return view_collection_monitor_construct (VIEW_COLLECTION_TYPE_MONITOR);
}


static void view_collection_value_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void view_collection_value_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		view_collection_monitor_unref (value->data[0].v_pointer);
	}
}


static void view_collection_value_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = view_collection_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer view_collection_value_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* view_collection_value_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ViewCollectionMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = view_collection_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* view_collection_value_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewCollectionMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = view_collection_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* view_collection_param_spec_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ViewCollectionParamSpecMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, VIEW_COLLECTION_TYPE_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer view_collection_value_get_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR), NULL);
	return value->data[0].v_pointer;
}


void view_collection_value_set_monitor (GValue* value, gpointer v_object) {
	ViewCollectionMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		view_collection_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_collection_monitor_unref (old);
	}
}


void view_collection_value_take_monitor (GValue* value, gpointer v_object) {
	ViewCollectionMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_collection_monitor_unref (old);
	}
}


static void view_collection_monitor_class_init (ViewCollectionMonitorClass * klass) {
	view_collection_monitor_parent_class = g_type_class_peek_parent (klass);
	VIEW_COLLECTION_MONITOR_CLASS (klass)->finalize = view_collection_monitor_finalize;
}


static void view_collection_monitor_instance_init (ViewCollectionMonitor * self) {
	self->ref_count = 1;
}


static void view_collection_monitor_finalize (ViewCollectionMonitor* obj) {
	ViewCollectionMonitor * self;
	self = VIEW_COLLECTION_MONITOR (obj);
}


GType view_collection_monitor_get_type (void) {
	static volatile gsize view_collection_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { view_collection_value_monitor_init, view_collection_value_monitor_free_value, view_collection_value_monitor_copy_value, view_collection_value_monitor_peek_pointer, "p", view_collection_value_monitor_collect_value, "p", view_collection_value_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitor), 0, (GInstanceInitFunc) view_collection_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_collection_monitor_type_id;
		view_collection_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewCollectionMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&view_collection_monitor_type_id__volatile, view_collection_monitor_type_id);
	}
	return view_collection_monitor_type_id__volatile;
}


gpointer view_collection_monitor_ref (gpointer instance) {
	ViewCollectionMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void view_collection_monitor_unref (gpointer instance) {
	ViewCollectionMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VIEW_COLLECTION_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
	view_collection_on_sources_added (self, _sender, added);
}


static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
	view_collection_on_sources_removed (self, removed);
}


static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self) {
	view_collection_on_sources_altered (self, _sender, items);
}


static gpointer _view_manager_ref0 (gpointer self) {
	return self ? view_manager_ref (self) : NULL;
}


static gpointer _alteration_ref0 (gpointer self) {
	return self ? alteration_ref (self) : NULL;
}


static ViewCollectionMonitorImpl* view_collection_monitor_impl_construct (GType object_type, ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq) {
	ViewCollectionMonitorImpl* self = NULL;
	ViewCollection* _tmp0_;
	SourceCollection* _tmp1_;
	ViewManager* _tmp2_;
	Alteration* _tmp3_;
	g_return_val_if_fail (IS_VIEW_COLLECTION (owner), NULL);
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
	g_return_val_if_fail (IS_VIEW_MANAGER (manager), NULL);
	g_return_val_if_fail ((prereq == NULL) || IS_ALTERATION (prereq), NULL);
	self = (ViewCollectionMonitorImpl*) view_collection_monitor_construct (object_type);
	_tmp0_ = _data_collection_ref0 (owner);
	_data_collection_unref0 (self->owner);
	self->owner = _tmp0_;
	_tmp1_ = _data_collection_ref0 (sources);
	_data_collection_unref0 (self->sources);
	self->sources = _tmp1_;
	_tmp2_ = _view_manager_ref0 (manager);
	_view_manager_unref0 (self->manager);
	self->manager = _tmp2_;
	_tmp3_ = _alteration_ref0 (prereq);
	_alteration_unref0 (self->prereq);
	self->prereq = _tmp3_;
	g_signal_connect (DATA_COLLECTION (sources), "items-added", (GCallback) _view_collection_on_sources_added_data_collection_items_added, owner);
	g_signal_connect (DATA_COLLECTION (sources), "items-removed", (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, owner);
	g_signal_connect (DATA_COLLECTION (sources), "items-altered", (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, owner);
	return self;
}


static ViewCollectionMonitorImpl* view_collection_monitor_impl_new (ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq) {
	return view_collection_monitor_impl_construct (VIEW_COLLECTION_TYPE_MONITOR_IMPL, owner, sources, manager, prereq);
}


static void view_collection_monitor_impl_class_init (ViewCollectionMonitorImplClass * klass) {
	view_collection_monitor_impl_parent_class = g_type_class_peek_parent (klass);
	VIEW_COLLECTION_MONITOR_CLASS (klass)->finalize = view_collection_monitor_impl_finalize;
}


static void view_collection_monitor_impl_instance_init (ViewCollectionMonitorImpl * self) {
}


static void view_collection_monitor_impl_finalize (ViewCollectionMonitor* obj) {
	ViewCollectionMonitorImpl * self;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	self = VIEW_COLLECTION_MONITOR_IMPL (obj);
	g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _view_collection_on_sources_added_data_collection_items_added, self->owner);
	g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, self->owner);
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, self->owner);
	_data_collection_unref0 (self->owner);
	_data_collection_unref0 (self->sources);
	_view_manager_unref0 (self->manager);
	_alteration_unref0 (self->prereq);
	VIEW_COLLECTION_MONITOR_CLASS (view_collection_monitor_impl_parent_class)->finalize (obj);
}


static GType view_collection_monitor_impl_get_type (void) {
	static volatile gsize view_collection_monitor_impl_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_monitor_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitorImpl), 0, (GInstanceInitFunc) view_collection_monitor_impl_instance_init, NULL };
		GType view_collection_monitor_impl_type_id;
		view_collection_monitor_impl_type_id = g_type_register_static (VIEW_COLLECTION_TYPE_MONITOR, "ViewCollectionMonitorImpl", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_monitor_impl_type_id__volatile, view_collection_monitor_impl_type_id);
	}
	return view_collection_monitor_impl_type_id__volatile;
}


static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type) {
	ViewCollectionToggleLists * self = NULL;
	self = (ViewCollectionToggleLists*) g_object_new (object_type, NULL);
	return self;
}


static ViewCollectionToggleLists* view_collection_toggle_lists_new (void) {
	return view_collection_toggle_lists_construct (VIEW_COLLECTION_TYPE_TOGGLE_LISTS);
}


static void view_collection_toggle_lists_class_init (ViewCollectionToggleListsClass * klass) {
	view_collection_toggle_lists_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = view_collection_toggle_lists_finalize;
}


static void view_collection_toggle_lists_instance_init (ViewCollectionToggleLists * self) {
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->selected = _tmp0_;
	_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->unselected = _tmp1_;
}


static void view_collection_toggle_lists_finalize (GObject* obj) {
	ViewCollectionToggleLists * self;
	self = VIEW_COLLECTION_TOGGLE_LISTS (obj);
	_g_object_unref0 (self->selected);
	_g_object_unref0 (self->unselected);
	G_OBJECT_CLASS (view_collection_toggle_lists_parent_class)->finalize (obj);
}


static GType view_collection_toggle_lists_get_type (void) {
	static volatile gsize view_collection_toggle_lists_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_toggle_lists_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionToggleListsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_toggle_lists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionToggleLists), 0, (GInstanceInitFunc) view_collection_toggle_lists_instance_init, NULL };
		GType view_collection_toggle_lists_type_id;
		view_collection_toggle_lists_type_id = g_type_register_static (G_TYPE_OBJECT, "ViewCollectionToggleLists", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_toggle_lists_type_id__volatile, view_collection_toggle_lists_type_id);
	}
	return view_collection_toggle_lists_type_id__volatile;
}


static void view_collection_class_init (ViewCollectionClass * klass) {
	view_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = view_collection_finalize;
	g_type_class_add_private (klass, sizeof (ViewCollectionPrivate));
	VIEW_COLLECTION_CLASS (klass)->notify_items_selected_unselected = view_collection_real_notify_items_selected_unselected;
	VIEW_COLLECTION_CLASS (klass)->notify_selection_group_altered = view_collection_real_notify_selection_group_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_item_view_altered = view_collection_real_notify_item_view_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_views_altered = view_collection_real_notify_views_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_item_geometry_altered = view_collection_real_notify_item_geometry_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_geometries_altered = view_collection_real_notify_geometries_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_items_shown = view_collection_real_notify_items_shown;
	VIEW_COLLECTION_CLASS (klass)->notify_items_hidden = view_collection_real_notify_items_hidden;
	VIEW_COLLECTION_CLASS (klass)->notify_items_visibility_changed = view_collection_real_notify_items_visibility_changed;
	VIEW_COLLECTION_CLASS (klass)->notify_view_filter_installed = view_collection_real_notify_view_filter_installed;
	VIEW_COLLECTION_CLASS (klass)->notify_view_filter_removed = view_collection_real_notify_view_filter_removed;
	DATA_COLLECTION_CLASS (klass)->clear = view_collection_real_clear;
	DATA_COLLECTION_CLASS (klass)->close = view_collection_real_close;
	DATA_COLLECTION_CLASS (klass)->valid_type = view_collection_real_valid_type;
	DATA_COLLECTION_CLASS (klass)->add = view_collection_real_add;
	DATA_COLLECTION_CLASS (klass)->add_many = view_collection_real_add_many;
	DATA_COLLECTION_CLASS (klass)->notify_items_added = view_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = view_collection_real_notify_items_removed;
	DATA_COLLECTION_CLASS (klass)->items_altered = view_collection_real_items_altered;
	DATA_COLLECTION_CLASS (klass)->set_comparator = view_collection_real_set_comparator;
	DATA_COLLECTION_CLASS (klass)->reset_comparator = view_collection_real_reset_comparator;
	DATA_COLLECTION_CLASS (klass)->get_all = view_collection_real_get_all;
	DATA_COLLECTION_CLASS (klass)->get_count = view_collection_real_get_count;
	DATA_COLLECTION_CLASS (klass)->get_at = view_collection_real_get_at;
	DATA_COLLECTION_CLASS (klass)->index_of = view_collection_real_index_of;
	DATA_COLLECTION_CLASS (klass)->contains = view_collection_real_contains;
	VIEW_COLLECTION_CLASS (klass)->get_first = view_collection_real_get_first;
	VIEW_COLLECTION_CLASS (klass)->get_last = view_collection_real_get_last;
	VIEW_COLLECTION_CLASS (klass)->get_next = view_collection_real_get_next;
	VIEW_COLLECTION_CLASS (klass)->get_previous = view_collection_real_get_previous;
	DATA_COLLECTION_CLASS (klass)->notify_thawed = view_collection_real_notify_thawed;
	VIEW_COLLECTION_CLASS (klass)->items_selected = view_collection_real_items_selected;
	VIEW_COLLECTION_CLASS (klass)->items_unselected = view_collection_real_items_unselected;
	VIEW_COLLECTION_CLASS (klass)->items_state_changed = view_collection_real_items_state_changed;
	VIEW_COLLECTION_CLASS (klass)->selection_group_altered = view_collection_real_selection_group_altered;
	VIEW_COLLECTION_CLASS (klass)->items_shown = view_collection_real_items_shown;
	VIEW_COLLECTION_CLASS (klass)->items_hidden = view_collection_real_items_hidden;
	VIEW_COLLECTION_CLASS (klass)->items_visibility_changed = view_collection_real_items_visibility_changed;
	VIEW_COLLECTION_CLASS (klass)->item_view_altered = view_collection_real_item_view_altered;
	VIEW_COLLECTION_CLASS (klass)->item_geometry_altered = view_collection_real_item_geometry_altered;
	VIEW_COLLECTION_CLASS (klass)->views_altered = view_collection_real_views_altered;
	VIEW_COLLECTION_CLASS (klass)->geometries_altered = view_collection_real_geometries_altered;
	VIEW_COLLECTION_CLASS (klass)->view_filter_installed = view_collection_real_view_filter_installed;
	VIEW_COLLECTION_CLASS (klass)->view_filter_removed = view_collection_real_view_filter_removed;
	g_signal_new ("items_selected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_unselected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_unselected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_state_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_state_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("selection_group_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, selection_group_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("items_shown", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_shown), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("items_hidden", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_hidden), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("items_visibility_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("item_view_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_view_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
	g_signal_new ("item_geometry_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
	g_signal_new ("views_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, views_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("geometries_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, geometries_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("view_filter_installed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_installed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
	g_signal_new ("view_filter_removed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_removed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
}


static void view_collection_instance_init (ViewCollection * self) {
	GeeHashMultiMap* _tmp0_ = NULL;
	GeeHashSet* _tmp1_ = NULL;
	DataSet* _tmp2_ = NULL;
	GeeHashMap* _tmp3_ = NULL;
	self->priv = VIEW_COLLECTION_GET_PRIVATE (self);
	_tmp0_ = gee_hash_multi_map_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, data_collection_unref, VIEW_COLLECTION_TYPE_MONITOR_IMPL, (GBoxedCopyFunc) view_collection_monitor_ref, view_collection_monitor_unref, NULL, NULL, NULL, NULL);
	self->priv->monitors = _tmp0_;
	self->priv->mirroring = NULL;
	self->priv->mirroring_ctor = NULL;
	self->priv->should_mirror = NULL;
	_tmp1_ = gee_hash_set_new (TYPE_VIEW_FILTER, (GBoxedCopyFunc) view_filter_ref, view_filter_unref, NULL, NULL);
	self->priv->filters = GEE_SET (_tmp1_);
	_tmp2_ = data_set_new ();
	self->priv->selected = _tmp2_;
	self->priv->visible = NULL;
	self->priv->frozen_views_altered = NULL;
	self->priv->frozen_geometries_altered = NULL;
	_tmp3_ = gee_hash_map_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_hash, g_direct_equal, g_direct_equal);
	self->priv->source_map = _tmp3_;
}


static void view_collection_finalize (DataCollection* obj) {
	ViewCollection * self;
	self = VIEW_COLLECTION (obj);
	_g_object_unref0 (self->priv->monitors);
	_data_collection_unref0 (self->priv->mirroring);
	(self->priv->mirroring_ctor_target_destroy_notify == NULL) ? NULL : (self->priv->mirroring_ctor_target_destroy_notify (self->priv->mirroring_ctor_target), NULL);
	self->priv->mirroring_ctor = NULL;
	self->priv->mirroring_ctor_target = NULL;
	self->priv->mirroring_ctor_target_destroy_notify = NULL;
	(self->priv->should_mirror_target_destroy_notify == NULL) ? NULL : (self->priv->should_mirror_target_destroy_notify (self->priv->should_mirror_target), NULL);
	self->priv->should_mirror = NULL;
	self->priv->should_mirror_target = NULL;
	self->priv->should_mirror_target_destroy_notify = NULL;
	_g_object_unref0 (self->priv->filters);
	_data_set_unref0 (self->priv->selected);
	_data_set_unref0 (self->priv->visible);
	_g_object_unref0 (self->priv->frozen_views_altered);
	_g_object_unref0 (self->priv->frozen_geometries_altered);
	_g_object_unref0 (self->priv->source_map);
	DATA_COLLECTION_CLASS (view_collection_parent_class)->finalize (obj);
}


GType view_collection_get_type (void) {
	static volatile gsize view_collection_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollection), 0, (GInstanceInitFunc) view_collection_instance_init, NULL };
		GType view_collection_type_id;
		view_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "ViewCollection", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_type_id__volatile, view_collection_type_id);
	}
	return view_collection_type_id__volatile;
}


static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_VIEW_MANAGER (self), FALSE);
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
	result = TRUE;
	return result;
}


gboolean view_manager_include_in_view (ViewManager* self, DataSource* source) {
	return VIEW_MANAGER_GET_CLASS (self)->include_in_view (self, source);
}


static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source) {
	g_return_val_if_fail (IS_VIEW_MANAGER (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `view_manager_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


DataView* view_manager_create_view (ViewManager* self, DataSource* source) {
	return VIEW_MANAGER_GET_CLASS (self)->create_view (self, source);
}


ViewManager* view_manager_construct (GType object_type) {
	ViewManager* self = NULL;
	self = (ViewManager*) g_type_create_instance (object_type);
	return self;
}


static void value_view_manager_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_view_manager_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		view_manager_unref (value->data[0].v_pointer);
	}
}


static void value_view_manager_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = view_manager_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_view_manager_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_view_manager_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ViewManager* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = view_manager_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_view_manager_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewManager** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = view_manager_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecViewManager* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_MANAGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_view_manager (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER), NULL);
	return value->data[0].v_pointer;
}


void value_set_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		view_manager_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_manager_unref (old);
	}
}


void value_take_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_manager_unref (old);
	}
}


static void view_manager_class_init (ViewManagerClass * klass) {
	view_manager_parent_class = g_type_class_peek_parent (klass);
	VIEW_MANAGER_CLASS (klass)->finalize = view_manager_finalize;
	VIEW_MANAGER_CLASS (klass)->include_in_view = view_manager_real_include_in_view;
	VIEW_MANAGER_CLASS (klass)->create_view = view_manager_real_create_view;
}


static void view_manager_instance_init (ViewManager * self) {
	self->ref_count = 1;
}


static void view_manager_finalize (ViewManager* obj) {
	ViewManager * self;
	self = VIEW_MANAGER (obj);
}


GType view_manager_get_type (void) {
	static volatile gsize view_manager_type_id__volatile = 0;
	if (g_once_init_enter (&view_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_manager_init, value_view_manager_free_value, value_view_manager_copy_value, value_view_manager_peek_pointer, "p", value_view_manager_collect_value, "p", value_view_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewManager), 0, (GInstanceInitFunc) view_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_manager_type_id;
		view_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewManager", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_manager_type_id__volatile, view_manager_type_id);
	}
	return view_manager_type_id__volatile;
}


gpointer view_manager_ref (gpointer instance) {
	ViewManager* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void view_manager_unref (gpointer instance) {
	ViewManager* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VIEW_MANAGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static gboolean view_filter_real_predicate (ViewFilter* self, DataView* view) {
	g_return_val_if_fail (IS_VIEW_FILTER (self), FALSE);
	g_critical ("Type `%s' does not implement abstract method `view_filter_predicate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean view_filter_predicate (ViewFilter* self, DataView* view) {
	return VIEW_FILTER_GET_CLASS (self)->predicate (self, view);
}


ViewFilter* view_filter_construct (GType object_type) {
	ViewFilter* self = NULL;
	self = (ViewFilter*) g_type_create_instance (object_type);
	return self;
}


static void view_filter_real_refresh (ViewFilter* self) {
	g_return_if_fail (IS_VIEW_FILTER (self));
}


static void value_view_filter_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_view_filter_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		view_filter_unref (value->data[0].v_pointer);
	}
}


static void value_view_filter_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = view_filter_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_view_filter_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_view_filter_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ViewFilter* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = view_filter_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_view_filter_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewFilter** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = view_filter_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_view_filter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecViewFilter* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_FILTER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_view_filter (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER), NULL);
	return value->data[0].v_pointer;
}


void value_set_view_filter (GValue* value, gpointer v_object) {
	ViewFilter* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		view_filter_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_filter_unref (old);
	}
}


void value_take_view_filter (GValue* value, gpointer v_object) {
	ViewFilter* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_filter_unref (old);
	}
}


static void view_filter_class_init (ViewFilterClass * klass) {
	view_filter_parent_class = g_type_class_peek_parent (klass);
	VIEW_FILTER_CLASS (klass)->finalize = view_filter_finalize;
	VIEW_FILTER_CLASS (klass)->predicate = view_filter_real_predicate;
	VIEW_FILTER_CLASS (klass)->refresh = view_filter_real_refresh;
	g_signal_new ("refresh", TYPE_VIEW_FILTER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewFilterClass, refresh), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void view_filter_instance_init (ViewFilter * self) {
	self->ref_count = 1;
}


static void view_filter_finalize (ViewFilter* obj) {
	ViewFilter * self;
	self = VIEW_FILTER (obj);
}


GType view_filter_get_type (void) {
	static volatile gsize view_filter_type_id__volatile = 0;
	if (g_once_init_enter (&view_filter_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_filter_init, value_view_filter_free_value, value_view_filter_copy_value, value_view_filter_peek_pointer, "p", value_view_filter_collect_value, "p", value_view_filter_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewFilter), 0, (GInstanceInitFunc) view_filter_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_filter_type_id;
		view_filter_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewFilter", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_filter_type_id__volatile, view_filter_type_id);
	}
	return view_filter_type_id__volatile;
}


gpointer view_filter_ref (gpointer instance) {
	ViewFilter* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void view_filter_unref (gpointer instance) {
	ViewFilter* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VIEW_FILTER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



